/*==========================================================================================*/
/*																							*/
/*							  Input Machine for Intagrate - and -Fire Model					*/
/*                                  by Ruben Tikidji - Hamburyan                            */
/*																							*/
/*==========================================================================================*/

#if !defined(AFX_INPUTM_H__8B656B43_4395_11D5_85D8_5254AB1ABD30__INCLUDED_)
#define AFX_INPUTM_H__8B656B43_4395_11D5_85D8_5254AB1ABD30__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct Event{double Time; int Input;};
struct Patern{double Probability, StartTime, TimeEnd; unsigned From, To;
			  int EventCount; Event *Events;};
struct Level{int PaternCount; Patern *Paterns; int WorkPattern;};

class InputM
{
public:
	int *InputList, InputCount;
	Level *Levels;		
	int LevelCount;
	bool Pause;
	int ActCount;
//	CFile Log;

public:
	InputM();
	~InputM();
	
	int GetNumberInput(int NCell);
	int AddInput(int NCell);
	void DeleteInput(int NInput);

	void SaveInputMachine(CFile &File);
	void LoadInputMachine(CFile &File);

	void ImportMachine(CFile &File);
	void ExportMachine(CFile &File);

	int AddLevel();
	void DeleteLevel(int NLevel);
	int AddPatern(int NLevel);
	void DeletePatern(int NLevel, int NPatern);
	int AddEvent(int NLevel, int NPatern);
	void DeleteEvent(int NLevel, int NPatern, int NEvent);
	
	void Assemble(void* MDL);
	void Calculate(void* MDL);
};

#endif // !defined(AFX_INPUTM_H__8B656B43_4395_11D5_85D8_5254AB1ABD30__INCLUDED_)
