// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ModelAnalyser.h"
#include "AnalyserProperty.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_DYNAMIC_PREPARATION_GO, OnDynamicPreparationGo)
	ON_UPDATE_COMMAND_UI(ID_DYNAMIC_PREPARATION_GO, OnUpdateDynamicPreparationGo)
	ON_COMMAND(ID_DYNAMIC_PREPARATION_ONLINE, OnDynamicPreparationOnline)
	ON_UPDATE_COMMAND_UI(ID_DYNAMIC_PREPARATION_ONLINE, OnUpdateDynamicPreparationOnline)
	ON_COMMAND(ID_DYNAMIC_PREPARATION_STOP, OnDynamicPreparationStop)
	ON_UPDATE_COMMAND_UI(ID_DYNAMIC_PREPARATION_STOP, OnUpdateDynamicPreparationStop)
	ON_COMMAND(ID_PREPARATION_STEP_BEGIN, OnPreparationStepBegin)
	ON_UPDATE_COMMAND_UI(ID_PREPARATION_STEP_BEGIN, OnUpdatePreparationStepBegin)
	ON_COMMAND(ID_PREPARATION_STEP_END, OnPreparationStepEnd)
	ON_UPDATE_COMMAND_UI(ID_PREPARATION_STEP_END, OnUpdatePreparationStepEnd)
	ON_COMMAND(ID_PREPARATION_STEP_LEFT, OnPreparationStepLeft)
	ON_UPDATE_COMMAND_UI(ID_PREPARATION_STEP_LEFT, OnUpdatePreparationStepLeft)
	ON_COMMAND(ID_PREPARATION_STEP_RIGHT, OnPreparationStepRight)
	ON_UPDATE_COMMAND_UI(ID_PREPARATION_STEP_RIGHT, OnUpdatePreparationStepRight)
	ON_COMMAND(ID_SIMULATION_GO, OnSimulationGo)
	ON_UPDATE_COMMAND_UI(ID_SIMULATION_GO, OnUpdateSimulationGo)
	ON_COMMAND(ID_SIMULATION_PASS, OnSimulationPass)
	ON_UPDATE_COMMAND_UI(ID_SIMULATION_PASS, OnUpdateSimulationPass)
	ON_COMMAND(ID_SIMULATION_PAUSE, OnSimulationPause)
	ON_UPDATE_COMMAND_UI(ID_SIMULATION_PAUSE, OnUpdateSimulationPause)
	ON_COMMAND(ID_SIMULATION_STEP, OnSimulationStep)
	ON_UPDATE_COMMAND_UI(ID_SIMULATION_STEP, OnUpdateSimulationStep)
	ON_COMMAND(ID_SIMULATION_STOP, OnSimulationStop)
	ON_UPDATE_COMMAND_UI(ID_SIMULATION_STOP, OnUpdateSimulationStop)
	ON_COMMAND(ID_OPTIONS, OnOptions)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS, OnUpdateOptions)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	IDS_SPLITTER,
	IDS_SPLITTER,
	IDS_SPLITTER
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER|WS_VSCROLL|WS_HSCROLL,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	ModFrm =new ModelFrm;
	ModFrm->Create(NULL,"==Model Analyser==Model View==",
		WS_BORDER|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_VISIBLE 
		,CRect(0,0,300,300),NULL,MAKEINTRESOURCE(IDR_MAINFRAME),0,NULL);
	ModFrm->UpdateWindow();
	ModFrm->Frame = this;

	ResFrm =new ResultFrm;
	ResFrm->Create(NULL,"==Model Analyser==Result View==",
		WS_BORDER|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_VISIBLE 
		,CRect(0,300,300,600),NULL,MAKEINTRESOURCE(IDR_MAINFRAME),0,NULL);
	ResFrm->UpdateWindow();
	ResFrm->Frame = this;


	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnDynamicPreparationGo() 
{
}

void CMainFrame::OnUpdateDynamicPreparationGo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnDynamicPreparationOnline() 
{
}

void CMainFrame::OnUpdateDynamicPreparationOnline(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnDynamicPreparationStop() 
{
}

void CMainFrame::OnUpdateDynamicPreparationStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnPreparationStepBegin() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdatePreparationStepBegin(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnPreparationStepEnd() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdatePreparationStepEnd(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnPreparationStepLeft() 
{
	Analyser as;	
}

void CMainFrame::OnUpdatePreparationStepLeft(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnPreparationStepRight() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdatePreparationStepRight(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnSimulationGo() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateSimulationGo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnSimulationPass() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateSimulationPass(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnSimulationPause() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateSimulationPause(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnSimulationStep() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateSimulationStep(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnSimulationStop() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateSimulationStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnOptions() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateOptions(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMainFrame::OnFileOpen() 
{
	CFileDialog FDlg(true,"sim","*.sim",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Sim File(*.sim)|*.sim|(*.*)|*.*||");
	if(FDlg.DoModal() != IDOK)return;
	FileName = FDlg.GetPathName();
	FileOpen();
}

void CMainFrame::FileOpen()
{
	Anal.hSim = ::CreateFile(FileName, GENERIC_READ, 0, NULL,	OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(Anal.hSim == INVALID_HANDLE_VALUE)  return;
	Anal.PointBegin = 0;
	char Str=' '; DWORD dR;
	while(Str != '\0'){
		::ReadFile(Anal.hSim,&Str,1,&dR,NULL);
		Anal.PointBegin+=dR;
	}
	Str = ' ';
	while(Str != '\0'){
		::ReadFile(Anal.hSim,&Str,1,&dR,NULL);
		Anal.PointBegin+=dR;
	}
	unsigned int Length=0,from,to;
	::ReadFile(Anal.hSim,&Length,4,&dR,NULL);
	Anal.PointBegin+=Length+12;

	::ReadFile(Anal.hSim,&ModFrm->m_wndView.NObjects,4,&dR,NULL);
	if(ModFrm->m_wndView.ObjectList != NULL) delete[]ModFrm->m_wndView.ObjectList;
	ModFrm->m_wndView.ObjectList = new ObjectView[ModFrm->m_wndView.NObjects];
	Anal.NCells = 0;
	for(int c=0; c<ModFrm->m_wndView.NObjects; c++){
		::ReadFile(Anal.hSim,&ModFrm->m_wndView.ObjectList[c],10,&dR,NULL);
		if(ModFrm->m_wndView.ObjectList[c].Selected<0x10)Anal.NCells++;
	}
	::ReadFile(Anal.hSim,&Length,4,&dR,NULL);
	for(c=0; c<Length; c++){						///!!!!!!!!!1
		::ReadFile(Anal.hSim,&from,4,&dR,NULL);
		::ReadFile(Anal.hSim,&to,4,&dR,NULL);
	}												///!!!!11!!!!
	
	unsigned short Ftr;
	::ReadFile(Anal.hSim,&Ftr,2,&dR,NULL);
	Anal.NLevel = Ftr;
	float TimeStep;
	::ReadFile(Anal.hSim,&Anal.RecLength,4,&dR,NULL);
	::ReadFile(Anal.hSim,&Anal.RecCount,4,&dR,NULL);
	::ReadFile(Anal.hSim,&TimeStep,4,&dR,NULL);
	Anal.TimeStep = (double)TimeStep;

	AnalyserProperty Ap;
	Ap.m_AveragingStep = Anal.AveragingStep;
	Ap.m_AveragingWindow = Anal.AveragingWindow;
	Ap.m_EpochAnalysis = Anal.AnalysisEpoch;
	Ap.m_VrsWindow = Anal.MaxDeltaVrs;
	if(Ap.DoModal() == IDOK){
		Anal.AveragingStep = Ap.m_AveragingStep;
		Anal.AnalysisEpoch = Ap.m_EpochAnalysis;
		Anal.MaxDeltaVrs = Ap.m_VrsWindow;
		Anal.AveragingWindow = Ap.m_AveragingWindow;
	}
	Anal.CurrentRec = 0;

	Anal.LeechToModFile();
}
