// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__3452282C_03C6_4972_9BB9_2B11CB0F23B8__INCLUDED_)
#define AFX_MAINFRM_H__3452282C_03C6_4972_9BB9_2B11CB0F23B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"
#include "ModelView.h"
#include "ResultView.h"
#include "Analyser.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:
	CString FileName;
	Analyser Anal;
// Operations
public:
	void FileOpen();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CChildView  m_wndView;
	ModelFrm	*ModFrm;
	ResultFrm	*ResFrm;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnDynamicPreparationGo();
	afx_msg void OnUpdateDynamicPreparationGo(CCmdUI* pCmdUI);
	afx_msg void OnDynamicPreparationOnline();
	afx_msg void OnUpdateDynamicPreparationOnline(CCmdUI* pCmdUI);
	afx_msg void OnDynamicPreparationStop();
	afx_msg void OnUpdateDynamicPreparationStop(CCmdUI* pCmdUI);
	afx_msg void OnPreparationStepBegin();
	afx_msg void OnUpdatePreparationStepBegin(CCmdUI* pCmdUI);
	afx_msg void OnPreparationStepEnd();
	afx_msg void OnUpdatePreparationStepEnd(CCmdUI* pCmdUI);
	afx_msg void OnPreparationStepLeft();
	afx_msg void OnUpdatePreparationStepLeft(CCmdUI* pCmdUI);
	afx_msg void OnPreparationStepRight();
	afx_msg void OnUpdatePreparationStepRight(CCmdUI* pCmdUI);
	afx_msg void OnSimulationGo();
	afx_msg void OnUpdateSimulationGo(CCmdUI* pCmdUI);
	afx_msg void OnSimulationPass();
	afx_msg void OnUpdateSimulationPass(CCmdUI* pCmdUI);
	afx_msg void OnSimulationPause();
	afx_msg void OnUpdateSimulationPause(CCmdUI* pCmdUI);
	afx_msg void OnSimulationStep();
	afx_msg void OnUpdateSimulationStep(CCmdUI* pCmdUI);
	afx_msg void OnSimulationStop();
	afx_msg void OnUpdateSimulationStop(CCmdUI* pCmdUI);
	afx_msg void OnOptions();
	afx_msg void OnUpdateOptions(CCmdUI* pCmdUI);
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__3452282C_03C6_4972_9BB9_2B11CB0F23B8__INCLUDED_)
