// ModelView.cpp : implementation file
//

#include "stdafx.h"
#include "ModelAnalyser.h"
#include "ModelView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ModelFrm

IMPLEMENT_DYNCREATE(ModelFrm, CFrameWnd)
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	IDS_SPLITTER,
	IDS_SPLITTER,
	IDS_SPLITTER
};

ModelFrm::ModelFrm()
{
}

ModelFrm::~ModelFrm()
{
}


BEGIN_MESSAGE_MAP(ModelFrm, CFrameWnd)
	//{{AFX_MSG_MAP(ModelFrm)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ModelFrm message handlers
int ModelFrm::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndView.Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER|WS_VSCROLL|WS_HSCROLL,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndView.m_wndStatusBar=&m_wndStatusBar;
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}


BOOL ModelFrm::DestroyWindow() 
{
	m_wndView.DestroyWindow();
	((CMainFrame*)Frame)->DestroyWindow();
	return CFrameWnd::DestroyWindow();
}

void ModelFrm::OnSetFocus(CWnd* pOldWnd) 
{
	// TODO: Add your message handler code here
	m_wndView.SetFocus();	
}

BOOL ModelFrm::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	switch(nID){
	case ID_PREPARATION_STEP_LEFT:
	case ID_PREPARATION_STEP_BEGIN:
	case ID_PREPARATION_STEP_RIGHT:
	case ID_PREPARATION_STEP_END:
	case ID_DYNAMIC_PREPARATION_STOP:
	case ID_DYNAMIC_PREPARATION_GO:
	case ID_DYNAMIC_PREPARATION_ONLINE:
	case ID_SETTER:
	case ID_SIMULATION_STEP:
	case ID_SIMULATION_PASS:
	case ID_SIMULATION_GO:
	case ID_SIMULATION_PAUSE:
	case ID_SIMULATION_STOP:
	case ID_OPTIONS:
	case ID_FILE_OPEN:
		return((CMainFrame*)Frame)->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
		break;
	default: 
		return m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
		break;
	}
}



/////////////////////////////////////////////////////////////////////////////
// ModelView

ModelView::ModelView()
{
	ObjectList = NULL;
	NObjects = 0;
}

ModelView::~ModelView()
{
	if(ObjectList != NULL) delete[] ObjectList;
}


BEGIN_MESSAGE_MAP(ModelView, CWnd)
	//{{AFX_MSG_MAP(ModelView)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// ModelView message handlers



void ModelView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if(ObjectList == NULL) return;
	for(int obj=0; obj<NObjects; obj++){
		CRect rect(ObjectList[obj].x-29995,ObjectList[obj].y-39995,ObjectList[obj].x-30005,ObjectList[obj].y-40005);
		if(ObjectList[obj].Selected<0x10)
			dc.Ellipse(&rect);
		else
			dc.Rectangle(&rect);
	}

}

void ModelView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CursorPoint = point;
	Invalidate(false);
/*	CString str;
	str.Format("Position: X:%d Y:%d",point.x, point.y);
	m_wndStatusBar->SetPaneText(0,str,true);

	
*/	CWnd::OnMouseMove(nFlags, point);
}
