// ResultView.cpp : implementation file
//

#include "stdafx.h"
#include "ModelAnalyser.h"
#include "ResultView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ResultFrm

IMPLEMENT_DYNCREATE(ResultFrm, CFrameWnd)
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	IDS_SPLITTER,
	IDS_SPLITTER,
	IDS_SPLITTER
};

ResultFrm::ResultFrm()
{
}

ResultFrm::~ResultFrm()
{
}


BEGIN_MESSAGE_MAP(ResultFrm, CFrameWnd)
	//{{AFX_MSG_MAP(ResultFrm)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ResultFrm message handlers
int ResultFrm::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndView.Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER|WS_VSCROLL|WS_HSCROLL,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndView.m_wndStatusBar=&m_wndStatusBar;
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}


BOOL ResultFrm::DestroyWindow() 
{
	m_wndView.DestroyWindow();
	return CFrameWnd::DestroyWindow();
}

void ResultFrm::OnSetFocus(CWnd* pOldWnd) 
{
	// TODO: Add your message handler code here
	m_wndView.SetFocus();	
}

BOOL ResultFrm::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	switch(nID){
	case ID_PREPARATION_STEP_LEFT:
	case ID_PREPARATION_STEP_BEGIN:
	case ID_PREPARATION_STEP_RIGHT:
	case ID_PREPARATION_STEP_END:
	case ID_DYNAMIC_PREPARATION_STOP:
	case ID_DYNAMIC_PREPARATION_GO:
	case ID_DYNAMIC_PREPARATION_ONLINE:
	case ID_SETTER:
	case ID_SIMULATION_STEP:
	case ID_SIMULATION_PASS:
	case ID_SIMULATION_GO:
	case ID_SIMULATION_PAUSE:
	case ID_SIMULATION_STOP:
	case ID_OPTIONS:
	case ID_FILE_OPEN:
		return((CMainFrame*)Frame)->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
		break;
	default: 
		return m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////
// ResultView

ResultView::ResultView()
{
}

ResultView::~ResultView()
{
}


BEGIN_MESSAGE_MAP(ResultView, CWnd)
	//{{AFX_MSG_MAP(ResultView)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// ResultView message handlers



void ResultView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	dc.MoveTo(0,0);
	dc.LineTo(100,50);
	CRect Rect(CursorPoint.x-20,CursorPoint.y-20,CursorPoint.x+20,CursorPoint.y+20);
	dc.Ellipse(Rect);

	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}

void ResultView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CursorPoint = point;
	Invalidate(false);
	CString str;
	str.Format("Position: X:%d Y:%d",point.x, point.y);
	m_wndStatusBar->SetPaneText(0,str,true);

	
	CWnd::OnMouseMove(nFlags, point);
}
