// CPS.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "CPS.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPS dialog


CPS::CPS(CWnd* pParent /*=NULL*/)
	: CDialog(CPS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPS)
	m_DirectConst = 0.0;
	m_DirectMax = 0.0;
	m_DirectMin = 0.0;
	m_ReciprocConst = 0.0;
	m_ReciprocList = 0;
	m_DirectList = 0;
	m_ReciprocMax = 0.0;
	m_ReciprocMin = 0.0;
	//}}AFX_DATA_INIT
	DirectData.Cos_L = DirectData.Cos_SD = DirectData.Cos_SF = DirectData.Cos_SMax = 
	DirectData.Cos_SMin = DirectData.Cos_SR = DirectData.Cos_SS = true;

	DirectData.Norm_SD = 5e-3;	
	DirectData.Min_SD = 0;		
	DirectData.Max_SD = 100e-3;	

	DirectData.Norm_SS = 40e-12;	DirectData.Norm_SMax = 150e-12;	DirectData.Norm_SMin = -1e-12;
	DirectData.Min_SS = 1e-12;		DirectData.Min_SMax = 60e-12;	DirectData.Min_SMin = -7e-12;
	DirectData.Max_SS = 100e-12;	DirectData.Max_SMax = 400e-12;	DirectData.Max_SMin = -40e-12;
	
	DirectData.Norm_SR = 2e-3;	DirectData.Norm_SF = 2e-3;		
	DirectData.Norm_LP = DirectData.Norm_LM = 0;
	DirectData.Min_SR = 1e-3;	DirectData.Min_SF = 1e-3;		
	DirectData.Min_LP = DirectData.Min_LM = 0.005;
	DirectData.Max_SR = 5e-3;	DirectData.Max_SF = 20e-3;		
	DirectData.Max_LP = DirectData.Max_LM = 0.17;

	ReciprocData.Cos_L = ReciprocData.Cos_SD = ReciprocData.Cos_SF = ReciprocData.Cos_SMax = 
	ReciprocData.Cos_SMin = ReciprocData.Cos_SR = ReciprocData.Cos_SS = true;

	ReciprocData.Norm_SD = 5e-3;	
	ReciprocData.Min_SD = 0;		
	ReciprocData.Max_SD = 100e-3;	

	ReciprocData.Norm_SS = 40e-12;	ReciprocData.Norm_SMax = 150e-12;	ReciprocData.Norm_SMin = -1e-12;
	ReciprocData.Min_SS = 1e-12;	ReciprocData.Min_SMax = 60e-12;		ReciprocData.Min_SMin = -7e-12;
	ReciprocData.Max_SS = 100e-12;	ReciprocData.Max_SMax = 400e-12;	ReciprocData.Max_SMin = -40e-12;
	
	ReciprocData.Norm_SR = 2e-3;	ReciprocData.Norm_SF = 2e-3;	
	ReciprocData.Norm_LP = ReciprocData.Norm_LM = 0;
	ReciprocData.Min_SR = 1e-3;	ReciprocData.Min_SF = 1e-3;			
	ReciprocData.Min_LP = ReciprocData.Min_LM = 0.005;
	ReciprocData.Max_SR = 5e-3;	ReciprocData.Max_SF = 20e-3;		
	ReciprocData.Max_LP = ReciprocData.Max_LM = 0.17;
	Reciprocally = false;

}


void CPS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPS)
	DDX_Text(pDX, IDC_CPS_CONSTANT, m_DirectConst);
	DDX_Text(pDX, IDC_CPS_DIRECT_MAX, m_DirectMax);
	DDX_Text(pDX, IDC_CPS_DIRECT_MIN, m_DirectMin);
	DDX_Text(pDX, IDC_CPS_RECIPROC_CONSTANT, m_ReciprocConst);
	DDX_LBIndex(pDX, IDC_CPS_RECIPROC_LIST, m_ReciprocList);
	DDX_LBIndex(pDX, IDC_CPS_DIRECT_LIST, m_DirectList);
	DDX_Text(pDX, IDC_CPS_RECIPROC_MAX, m_ReciprocMax);
	DDX_Text(pDX, IDC_CPS_RECIPROC_MIN, m_ReciprocMin);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPS, CDialog)
	//{{AFX_MSG_MAP(CPS)
	ON_BN_CLICKED(IDC_CPS_RECIPROC_CHOOS, OnCpsReciprocChoos)
	ON_BN_CLICKED(IDC_CPS_DIRECT_CHOOS, OnCpsDirectChoos)
	ON_LBN_SELCHANGE(IDC_CPS_DIRECT_LIST, OnSelchangeCpsDirectList)
	ON_LBN_SELCHANGE(IDC_CPS_RECIPROC_LIST, OnSelchangeCpsReciprocList)
	ON_BN_CLICKED(IDC_CPS_DIRECT_SAVE, OnCpsDirectSave)
	ON_BN_CLICKED(IDC_CPS_DIRECT_LOAD, OnCpsDirectLoad)
	ON_BN_CLICKED(IDC_CPS_RECIPROC_LOAD, OnCpsReciprocLoad)
	ON_BN_CLICKED(IDC_CPS_RECIPROC_SAVE, OnCpsReciprocSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPS message handlers

void CPS::OnCpsReciprocChoos() 
{
	switch(m_ReciprocList){
	case 0:
		ReciprocData.Cos_SD = !ReciprocData.Cos_SD;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SD);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SD);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SD);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SD);
		break;
	case 1:
		ReciprocData.Cos_SS = !ReciprocData.Cos_SS;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SS);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SS);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SS);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SS);
		break;
	case 2:
		ReciprocData.Cos_SMin = !ReciprocData.Cos_SMin;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SMin);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SMin);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SMin);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SMin);
		break;
	case 3:
		ReciprocData.Cos_SMax = !ReciprocData.Cos_SMax;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SMax);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SMax);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SMax);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SMax);
		break;
	case 4:
		ReciprocData.Cos_SR = !ReciprocData.Cos_SR;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SR);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SR);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SR);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SR);
		break;
	case 5:
		ReciprocData.Cos_SF = !ReciprocData.Cos_SF;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SF);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SF);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SF);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SF);
		break;
	case 6:
		ReciprocData.Cos_L = !ReciprocData.Cos_L;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_L);
		ReciprocConst->EnableWindow(ReciprocData.Cos_L);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_L);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_L);
		break;
	case 7:
		ReciprocData.Cos_L = !ReciprocData.Cos_L;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_L);
		ReciprocConst->EnableWindow(ReciprocData.Cos_L);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_L);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_L);
		break;
	}	
}

void CPS::OnCpsDirectChoos() 
{
	switch(m_DirectList){
	case 0:
		DirectData.Cos_SD = !DirectData.Cos_SD;
		DirectChoose->SetCheck((int)DirectData.Cos_SD);
		DirectConst->EnableWindow(DirectData.Cos_SD);
		DirectMin->EnableWindow(!DirectData.Cos_SD);
		DirectMax->EnableWindow(!DirectData.Cos_SD);
		break;
	case 1:
		DirectData.Cos_SS = !DirectData.Cos_SS;
		DirectChoose->SetCheck((int)DirectData.Cos_SS);
		DirectConst->EnableWindow(DirectData.Cos_SS);
		DirectMin->EnableWindow(!DirectData.Cos_SS);
		DirectMax->EnableWindow(!DirectData.Cos_SS);
		break;
	case 2:
		DirectData.Cos_SMin = !DirectData.Cos_SMin;
		DirectChoose->SetCheck((int)DirectData.Cos_SMin);
		DirectConst->EnableWindow(DirectData.Cos_SMin);
		DirectMin->EnableWindow(!DirectData.Cos_SMin);
		DirectMax->EnableWindow(!DirectData.Cos_SMin);
		break;
	case 3:
		DirectData.Cos_SMax = !DirectData.Cos_SMax;
		DirectChoose->SetCheck((int)DirectData.Cos_SMax);
		DirectConst->EnableWindow(DirectData.Cos_SMax);
		DirectMin->EnableWindow(!DirectData.Cos_SMax);
		DirectMax->EnableWindow(!DirectData.Cos_SMax);
		break;
	case 4:
		DirectData.Cos_SR = !DirectData.Cos_SR;
		DirectChoose->SetCheck((int)DirectData.Cos_SR);
		DirectConst->EnableWindow(DirectData.Cos_SR);
		DirectMin->EnableWindow(!DirectData.Cos_SR);
		DirectMax->EnableWindow(!DirectData.Cos_SR);
		break;
	case 5:
		DirectData.Cos_SF = !DirectData.Cos_SF;
		DirectChoose->SetCheck((int)DirectData.Cos_SF);
		DirectConst->EnableWindow(DirectData.Cos_SF);
		DirectMin->EnableWindow(!DirectData.Cos_SF);
		DirectMax->EnableWindow(!DirectData.Cos_SF);
		break;
	case 6:
		DirectData.Cos_L = !DirectData.Cos_L;
		DirectChoose->SetCheck((int)DirectData.Cos_L);
		DirectConst->EnableWindow(DirectData.Cos_L);
		DirectMin->EnableWindow(!DirectData.Cos_L);
		DirectMax->EnableWindow(!DirectData.Cos_L);
		break;
	case 7:
		DirectData.Cos_L = !DirectData.Cos_L;
		DirectChoose->SetCheck((int)DirectData.Cos_L);
		DirectConst->EnableWindow(DirectData.Cos_L);
		DirectMin->EnableWindow(!DirectData.Cos_L);
		DirectMax->EnableWindow(!DirectData.Cos_L);
		break;
	}
	
}

void CPS::OnSelchangeCpsDirectList() 
{
	int Pointer = m_DirectList;
	UpdateData(true);

	switch(Pointer){
	case 0:
		DirectData.Norm_SD = m_DirectConst;	
		DirectData.Max_SD = m_DirectMax;		
		DirectData.Min_SD = m_DirectMin;		break;
	case 1:
		DirectData.Norm_SS = m_DirectConst;	
		DirectData.Max_SS = m_DirectMax;		
		DirectData.Min_SS = m_DirectMin;		break;
	case 2:
		DirectData.Norm_SMin = m_DirectConst;	
		DirectData.Max_SMin = m_DirectMax;	
		DirectData.Min_SMin = m_DirectMin;	break;
	case 3:
		DirectData.Norm_SMax = m_DirectConst;	
		DirectData.Max_SMax = m_DirectMax;	
		DirectData.Min_SMax = m_DirectMin;	break;
	case 4:
		DirectData.Norm_SR = m_DirectConst;	
		DirectData.Max_SR = m_DirectMax;		
		DirectData.Min_SR = m_DirectMin;		break;
	case 5:
		DirectData.Norm_SF = m_DirectConst;	
		DirectData.Max_SF = m_DirectMax;		
		DirectData.Min_SF = m_DirectMin;		break;
	case 6:
		DirectData.Norm_LP = m_DirectConst;		
		DirectData.Max_LP = m_DirectMax;		
		DirectData.Min_LP = m_DirectMin;		break;
	case 7:
		DirectData.Norm_LM = m_DirectConst;		
		DirectData.Max_LM = m_DirectMax;		
		DirectData.Min_LM = m_DirectMin;		break;
	}

	switch(m_DirectList){
	case 0:
		m_DirectConst = DirectData.Norm_SD;	
		m_DirectMax = DirectData.Max_SD;		
		m_DirectMin = DirectData.Min_SD;
		DirectChoose->SetCheck((int)DirectData.Cos_SD);
		DirectConst->EnableWindow(DirectData.Cos_SD);
		DirectMin->EnableWindow(!DirectData.Cos_SD);
		DirectMax->EnableWindow(!DirectData.Cos_SD);
		break;
	case 1:
		m_DirectConst = DirectData.Norm_SS;
		m_DirectMax = DirectData.Max_SS;
		m_DirectMin = DirectData.Min_SS;
		DirectChoose->SetCheck((int)DirectData.Cos_SS);
		DirectConst->EnableWindow(DirectData.Cos_SS);
		DirectMin->EnableWindow(!DirectData.Cos_SS);
		DirectMax->EnableWindow(!DirectData.Cos_SS);
		break;
	case 2:
		m_DirectConst = DirectData.Norm_SMin;	
		m_DirectMax = DirectData.Max_SMin;	
		m_DirectMin = DirectData.Min_SMin;
		DirectChoose->SetCheck((int)DirectData.Cos_SMin);
		DirectConst->EnableWindow(DirectData.Cos_SMin);
		DirectMin->EnableWindow(!DirectData.Cos_SMin);
		DirectMax->EnableWindow(!DirectData.Cos_SMin);
		break;
	case 3:
		m_DirectConst = DirectData.Norm_SMax;	
		m_DirectMax = DirectData.Max_SMax;	
		m_DirectMin = DirectData.Min_SMax;
		DirectChoose->SetCheck((int)DirectData.Cos_SMax);
		DirectConst->EnableWindow(DirectData.Cos_SMax);
		DirectMin->EnableWindow(!DirectData.Cos_SMax);
		DirectMax->EnableWindow(!DirectData.Cos_SMax);
		break;
	case 4:
		m_DirectConst = DirectData.Norm_SR;
		m_DirectMax = DirectData.Max_SR;
		m_DirectMin = DirectData.Min_SR;
		DirectChoose->SetCheck((int)DirectData.Cos_SR);
		DirectConst->EnableWindow(DirectData.Cos_SR);
		DirectMin->EnableWindow(!DirectData.Cos_SR);
		DirectMax->EnableWindow(!DirectData.Cos_SR);
		break;
	case 5:
		m_DirectConst = DirectData.Norm_SF;
		m_DirectMax = DirectData.Max_SF;
		m_DirectMin = DirectData.Min_SF;
		DirectChoose->SetCheck((int)DirectData.Cos_SF);
		DirectConst->EnableWindow(DirectData.Cos_SF);
		DirectMin->EnableWindow(!DirectData.Cos_SF);
		DirectMax->EnableWindow(!DirectData.Cos_SF);
		break;
	case 6:
		m_DirectConst = DirectData.Norm_LP;		
		m_DirectMax = DirectData.Max_LP;		
		m_DirectMin = DirectData.Min_LP;
		DirectChoose->SetCheck((int)DirectData.Cos_L);
		DirectConst->EnableWindow(DirectData.Cos_L);
		DirectMin->EnableWindow(!DirectData.Cos_L);
		DirectMax->EnableWindow(!DirectData.Cos_L);
		break;
	case 7:
		m_DirectConst = DirectData.Norm_LM;
		m_DirectMax = DirectData.Max_LM;		
		m_DirectMin = DirectData.Min_LM;
		DirectChoose->SetCheck((int)DirectData.Cos_L);
		DirectConst->EnableWindow(DirectData.Cos_L);
		DirectMin->EnableWindow(!DirectData.Cos_L);
		DirectMax->EnableWindow(!DirectData.Cos_L);
		break;
	}
	UpdateData(false);
}

void CPS::OnSelchangeCpsReciprocList() 
{
	int Pointer = m_ReciprocList;
	UpdateData(true);

	switch(Pointer){
	case 0:
		ReciprocData.Norm_SD = m_ReciprocConst;	
		ReciprocData.Max_SD = m_ReciprocMax;		
		ReciprocData.Min_SD = m_ReciprocMin;		break;
	case 1:
		ReciprocData.Norm_SS = m_ReciprocConst;	
		ReciprocData.Max_SS = m_ReciprocMax;		
		ReciprocData.Min_SS = m_ReciprocMin;		break;
	case 2:
		ReciprocData.Norm_SMin = m_ReciprocConst;	
		ReciprocData.Max_SMin = m_ReciprocMax;	
		ReciprocData.Min_SMin = m_ReciprocMin;	break;
	case 3:
		ReciprocData.Norm_SMax = m_ReciprocConst;	
		ReciprocData.Max_SMax = m_ReciprocMax;	
		ReciprocData.Min_SMax = m_ReciprocMin;	break;
	case 4:
		ReciprocData.Norm_SR = m_ReciprocConst;	
		ReciprocData.Max_SR = m_ReciprocMax;		
		ReciprocData.Min_SR = m_ReciprocMin;		break;
	case 5:
		ReciprocData.Norm_SF = m_ReciprocConst;	
		ReciprocData.Max_SF = m_ReciprocMax;		
		ReciprocData.Min_SF = m_ReciprocMin;		break;
	case 6:
		ReciprocData.Norm_LP = m_ReciprocConst;		
		ReciprocData.Max_LP = m_ReciprocMax;		
		ReciprocData.Min_LP = m_ReciprocMin;		break;
	case 7:
		ReciprocData.Norm_LM = m_ReciprocConst;		
		ReciprocData.Max_LM = m_ReciprocMax;		
		ReciprocData.Min_LM = m_ReciprocMin;		break;
	}

	switch(m_ReciprocList){
	case 0:
		m_ReciprocConst = ReciprocData.Norm_SD;	
		m_ReciprocMax = ReciprocData.Max_SD;		
		m_ReciprocMin = ReciprocData.Min_SD;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SD);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SD);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SD);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SD);
		break;
	case 1:
		m_ReciprocConst = ReciprocData.Norm_SS;
		m_ReciprocMax = ReciprocData.Max_SS;
		m_ReciprocMin = ReciprocData.Min_SS;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SS);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SS);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SS);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SS);
		break;
	case 2:
		m_ReciprocConst = ReciprocData.Norm_SMin;	
		m_ReciprocMax = ReciprocData.Max_SMin;	
		m_ReciprocMin = ReciprocData.Min_SMin;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SMin);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SMin);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SMin);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SMin);
		break;
	case 3:
		m_ReciprocConst = ReciprocData.Norm_SMax;	
		m_ReciprocMax = ReciprocData.Max_SMax;	
		m_ReciprocMin = ReciprocData.Min_SMax;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SMax);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SMax);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SMax);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SMax);
		break;
	case 4:
		m_ReciprocConst = ReciprocData.Norm_SR;
		m_ReciprocMax = ReciprocData.Max_SR;
		m_ReciprocMin = ReciprocData.Min_SR;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SR);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SR);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SR);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SR);
		break;
	case 5:
		m_ReciprocConst = ReciprocData.Norm_SF;
		m_ReciprocMax = ReciprocData.Max_SF;
		m_ReciprocMin = ReciprocData.Min_SF;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_SF);
		ReciprocConst->EnableWindow(ReciprocData.Cos_SF);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_SF);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_SF);
		break;
	case 6:
		m_ReciprocConst = ReciprocData.Norm_LP;
		m_ReciprocMax = ReciprocData.Max_LP;		
		m_ReciprocMin = ReciprocData.Min_LP;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_L);
		ReciprocConst->EnableWindow(ReciprocData.Cos_L);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_L);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_L);
		break;
	case 7:
		m_ReciprocConst = ReciprocData.Norm_LM;
		m_ReciprocMax = ReciprocData.Max_LM;		
		m_ReciprocMin = ReciprocData.Min_LM;
		ReciprocChoose->SetCheck((int)ReciprocData.Cos_L);
		ReciprocConst->EnableWindow(ReciprocData.Cos_L);
		ReciprocMin->EnableWindow(!ReciprocData.Cos_L);
		ReciprocMax->EnableWindow(!ReciprocData.Cos_L);
		break;
	}
	UpdateData(false);
}

BOOL CPS::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CListBox *pLB = (CListBox*)GetDlgItem(IDC_CPS_DIRECT_LIST);
	pLB->InsertString(0,"Synapse Delay Time (sec.)");
	pLB->InsertString(1,"Synapse Initial Injection (A.)");
	pLB->InsertString(2,"Synapse Minimal Injection (A.)");
	pLB->InsertString(3,"Synapse Maximal Injection (A.)");
	pLB->InsertString(4,"Synapse Injection Rising Time (sec.)");
	pLB->InsertString(5,"Synapse Injection Falling Time (sec.)");
	pLB->InsertString(6,"Synapse Learing Parameter(Pluse Branch)");
	pLB->InsertString(7,"Synapse Learing Parameter(Minus Branch)");

	pLB = (CListBox*)GetDlgItem(IDC_CPS_RECIPROC_LIST);
	pLB->InsertString(0,"Synapse Delay Time (sec.)");
	pLB->InsertString(1,"Synapse Initial Injection (A.)");
	pLB->InsertString(2,"Synapse Minimal Injection (A.)");
	pLB->InsertString(3,"Synapse Maximal Injection (A.)");
	pLB->InsertString(4,"Synapse Injection Rising Time (sec.)");
	pLB->InsertString(5,"Synapse Injection Falling Time (sec.)");
	pLB->InsertString(6,"Synapse Learing Parameter(Pluse Branch)");
	pLB->InsertString(7,"Synapse Learing Parameter(Minus Branch)");

	DirectChoose = (CButton*)GetDlgItem(IDC_CPS_DIRECT_CHOOS);
	ReciprocChoose = (CButton*)GetDlgItem(IDC_CPS_RECIPROC_CHOOS);
	DirectConst = (CEdit*)GetDlgItem(IDC_CPS_CONSTANT);
	DirectMin = (CEdit*)GetDlgItem(IDC_CPS_DIRECT_MIN);
	DirectMax = (CEdit*)GetDlgItem(IDC_CPS_DIRECT_MAX);
	ReciprocConst = (CEdit*)GetDlgItem(IDC_CPS_RECIPROC_CONSTANT);
	ReciprocMin = (CEdit*)GetDlgItem(IDC_CPS_RECIPROC_MIN);
	ReciprocMax = (CEdit*)GetDlgItem(IDC_CPS_RECIPROC_MAX);
	
	DirectChoose->SetCheck((int)DirectData.Cos_SD);
	DirectConst->EnableWindow(DirectData.Cos_SD);
	DirectMin->EnableWindow(!DirectData.Cos_SD);
	DirectMax->EnableWindow(!DirectData.Cos_SD);

	ReciprocChoose->SetCheck((int)ReciprocData.Cos_SD);
	ReciprocChoose->EnableWindow(Reciprocally);
	ReciprocConst->EnableWindow(ReciprocData.Cos_SD&Reciprocally);
	ReciprocMin->EnableWindow((!ReciprocData.Cos_SD)&Reciprocally);
	ReciprocMax->EnableWindow((!ReciprocData.Cos_SD)&Reciprocally);
	pLB->EnableWindow(Reciprocally);

	m_DirectConst = DirectData.Norm_SD; 
	m_DirectMin = DirectData.Min_SD;			m_DirectMax = DirectData.Max_SD;

	m_ReciprocConst = ReciprocData.Norm_SD; 
	m_ReciprocMin = ReciprocData.Min_SD;		m_ReciprocMax = ReciprocData.Max_SD;

	CButton* DirLoad = (CButton*)GetDlgItem(IDC_CPS_DIRECT_LOAD);
	CBitmap hBmp; hBmp.LoadBitmap(IDB_LOAD);
	DirLoad->SetBitmap((HBITMAP) hBmp);
	UpdateData(false);	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPS::OnOK() 
{
	OnSelchangeCpsDirectList();
	OnSelchangeCpsReciprocList();
	CDialog::OnOK();
}

void CPS::OnCpsDirectSave() 
{
	CFile File;
	CString FileName;
	CFileDialog FDlg(false,"def","*.def",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Default Cell(*.def)|*.def|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open(FileName ,CFile::modeCreate | CFile::modeWrite,NULL);
		this->SetWindowText(FileName);
		File.Write(&DirectData, sizeof(DirectData));
		File.Close();
	}
}

void CPS::OnCpsDirectLoad() 
{
	CFile File;
	CString FileName;
	CFileDialog FDlg(true,"def","*.def",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Default Cell(*.def)|*.def|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open((LPCTSTR) FileName,CFile::modeRead,NULL);
		this->SetWindowText(FileName);
		File.Read(&DirectData, sizeof(DirectData));
		File.Close();
		m_DirectList = -1;
		OnSelchangeCpsDirectList();
	}
}

void CPS::OnCpsReciprocLoad() 
{
	if(!Reciprocally)return;
	CFile File;
	CString FileName;
	CFileDialog FDlg(true,"def","*.def",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Default Cell(*.def)|*.def|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open((LPCTSTR) FileName,CFile::modeRead,NULL);
		this->SetWindowText(FileName);
		File.Read(&ReciprocData, sizeof(ReciprocData));
		File.Close();
		m_ReciprocList = -1;
		OnSelchangeCpsReciprocList();
	}
}

void CPS::OnCpsReciprocSave() 
{
	if(!Reciprocally)return;
	CFile File;
	CString FileName;
	CFileDialog FDlg(false,"def","*.def",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Default Cell(*.def)|*.def|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open(FileName ,CFile::modeCreate | CFile::modeWrite,NULL);
		this->SetWindowText(FileName);
		File.Write(&ReciprocData, sizeof(ReciprocData));
		File.Close();
	}
}
