/*==========================================================================================*/
/*																							*/
/*							   Integrate-and-Fire Neuron with Synapse						*/
/*                                  by Ruben Tikidji - Hamburyan                            */
/*																							*/
/*==========================================================================================*/

#if !defined(AFX_CELL_H__11564211_37F9_11D5_85C7_5254AB1ABD30__INCLUDED_)
#define AFX_CELL_H__11564211_37F9_11D5_85C7_5254AB1ABD30__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const double FireTime = 2e-3, RefTime = 3e-3;
const double LawTime = 100e-3, MinU = 15e-3, MaxU = 15e-3;

#include "queue"
using namespace std;

struct Synapse
{
	void *An;
	double Delay; queue <double> dDelay;
	double SingleWeight;
	double LearnP, LearnM;
	double MaxWeight, MinWeight;
	double dTime, RisingTime, FallingTime;
	double I;
};

class Cell  
{
public:
	Synapse *Syn;
	int CountSyn, MaxSyn;
	double SynK;
	bool Axon;
	double I;
	double Threshold, ThresholdPTime, ThresholdMTime, ThresholdLevel;
	double FireThresholdTime;
	double Potentioal, Fireing;
	double RC, C;
	double APR, APC, APSingPotential, APPotential;//, APL;
	double LawTimeOut;

	static double TimeStep;
	static double CurrentTime;

	static Cell *First;
	static Cell *Last;
	double PotentialStat;

	bool Fine;

public:
	Cell();
	~Cell();
	virtual void Assemble();
	virtual void Calculate();
	int CreateSynapse();
	void DeleteSynapse(int N);
	void operator =(Cell &N);

//	inline double GetAP();


};

#endif // !defined(AFX_CELL_H__11564211_37F9_11D5_85C7_5254AB1ABD30__INCLUDED_)
