// CellView.cpp : implementation file
//

#include "stdafx.h"
#include "stdio.h"
#include "NeuroCAD.h"
#include "CellView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CellView

IMPLEMENT_DYNCREATE(CellView, CFrameWnd)

CellView::CellView()
{
	pCell = NULL;
	Save = false;
}

CellView::~CellView()
{
}


BEGIN_MESSAGE_MAP(CellView, CFrameWnd)
	//{{AFX_MSG_MAP(CellView)
	ON_WM_PAINT()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_SIMULATOR_SAVE_CELL_VIEW, OnSimulatorSaveCellView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CellView message handlers

void CellView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if(pCell == NULL) return;
	CFont Font, *OldFont;
	Font.CreateFont(12,0,0,0,300,FALSE,FALSE,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_SWISS,NULL);
	OldFont = dc.SelectObject(&Font);
	char Out[10000];
	int p = _snprintf(Out,10000,"Axon:  %d    V:  %E    Threshold:  %E\nAP:  %E\n",
			pCell->Axon,
			pCell->Potentioal,
			pCell->ThresholdLevel,
			pCell->APPotential);
	for(int S=0; S<pCell->CountSyn; S++){
		if(p>=9950) break;
		p+= _snprintf(&Out[p],10000,"S: %d {LT:  %E    I:  %E    SI:  %E}\n",
			    S,
			    (pCell->Syn[S].dDelay.size() != 0) ?
					pCell->Syn[S].dDelay.front()+pCell->Syn[S].Delay-pCell->CurrentTime : 0,
			    pCell->Syn[S].I,
			    pCell->Syn[S].SingleWeight);
	}
	dc.DrawText(&Out[0],-1,CRect(0,0,800,600),DT_BOTTOM);
	if(Save){
		Save = false;
		Saver(Out,p);
	}
	dc.SelectObject(OldFont);
}

void CellView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
}

void CellView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	menu.LoadMenu(IDR_SIMULATOR_M);
	menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON, point.x, point.y, this);   
	
}

void CellView::OnSimulatorSaveCellView() 
{
	Save = true;
	Invalidate(false);
}

void CellView::Saver(char *Out, int Count)
{
	char Buffer[10000];
	for(int i=0; i<Count; i++)Buffer[i]=Out[i];
	CFile File;
	File.Open("Cell.txt",CFile::modeCreate | CFile::modeWrite,NULL);
	File.Write(&Buffer,Count);
	File.Close();
}