// CellPropertyV.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "math.h"
#include "CellPropertyV.h"
#include "CreatorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CellPropertyView

IMPLEMENT_DYNCREATE(CellPropertyView, CFormView)

CellPropertyView::CellPropertyView()
: CFormView(CellPropertyView::IDD)
{
	//{{AFX_DATA_INIT(CellPropertyView)
	m_CellID = 0;
	m_SynapseID = 0;
	//}}AFX_DATA_INIT
}

CellPropertyView::~CellPropertyView()
{
}

void CellPropertyView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	R=Modl->CellList[m_CellID].RC/Modl->CellList[m_CellID].C;
	APRC = Modl->CellList[m_CellID].APC*(Modl->CellList[m_CellID].APR+R);
	//{{AFX_DATA_MAP(CellPropertyView)
	DDX_Text(pDX, IDC_CELL_ID, m_CellID);
	DDX_Text(pDX, IDC_SYNAPSE_ID, m_SynapseID);
	DDX_Text(pDX, IDC_INTEG_C, Modl->CellList[m_CellID].C);
	DDX_Text(pDX, IDC_INTEG_R, R);
	DDX_Text(pDX, IDC_TH_FT, Modl->CellList[m_CellID].FireThresholdTime);
	DDX_Text(pDX, IDC_SYNAPSE_FALLING_TIME, Modl->CellList[m_CellID].Syn[m_SynapseID].FallingTime);
	DDX_Text(pDX, IDC_AFTER_R, Modl->CellList[m_CellID].APR);
	DDX_Text(pDX, IDC_AFTER_C, Modl->CellList[m_CellID].APC);
	DDX_Text(pDX, IDC_AFTER_MAX_AMP, APRC);
	DDX_Text(pDX, IDC_AFTER_SINGLE_AMP, Modl->CellList[m_CellID].APSingPotential);
	DDX_Text(pDX, IDC_FIRING_THP_TIME, Modl->CellList[m_CellID].ThresholdPTime);
	DDX_Text(pDX, IDC_FIRING_THM_TIME, Modl->CellList[m_CellID].ThresholdMTime);
	DDX_Text(pDX, IDC_FIRING_THRESHOLD, Modl->CellList[m_CellID].Threshold);
	DDX_Text(pDX, IDC_INTEG_RC, Modl->CellList[m_CellID].RC);
	DDX_Text(pDX, IDC_SYNAPSE_DELAY, Modl->CellList[m_CellID].Syn[m_SynapseID].Delay);
	DDX_Text(pDX, IDC_SYNAPSE_CUR_IN, Modl->CellList[m_CellID].Syn[m_SynapseID].SingleWeight);
	DDX_Text(pDX, IDC_SYNAPSE_LEARN_P, Modl->CellList[m_CellID].Syn[m_SynapseID].LearnP);
	DDX_Text(pDX, IDC_SYNAPSE_LEARN_M, Modl->CellList[m_CellID].Syn[m_SynapseID].LearnM);
	DDX_Text(pDX, IDC_SYNAPSE_MAX_IN, Modl->CellList[m_CellID].Syn[m_SynapseID].MaxWeight);
	DDX_Text(pDX, IDC_SYNAPSE_MIN_IN, Modl->CellList[m_CellID].Syn[m_SynapseID].MinWeight);
	DDX_Text(pDX, IDC_SYNAPSE_RISING_TIME, Modl->CellList[m_CellID].Syn[m_SynapseID].RisingTime);
	DDX_Text(pDX, IDC_COR_X, Modl->VCellList[m_CellID].Pos.x);
	DDX_Text(pDX, IDC_COR_Y, Modl->VCellList[m_CellID].Pos.y);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CellPropertyView, CFormView)
	//{{AFX_MSG_MAP(CellPropertyView)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_BN_CLICKED(IDC_HIDE, OnHide)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_MESSAGE (WM_REVIEW, OnReView)
	ON_MESSAGE (WM_SHIFTLOCK, OnSiftLock)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDOK, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CellPropertyView diagnostics

#ifdef _DEBUG
void CellPropertyView::AssertValid() const
{
	CFormView::AssertValid();
}

void CellPropertyView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CellPropertyView message handlers

void CellPropertyView::OnApply() 
{	
	UpdateData(true);
	R=Modl->CellList[m_CellID].RC/Modl->CellList[m_CellID].C;
	APRC = Modl->CellList[m_CellID].APC*(Modl->CellList[m_CellID].APR+R);
	UpdateData(false);
	View->SendMessage(WM_REVIEW,m_CellID,m_SynapseID);
}

void CellPropertyView::OnHide() 
{
	((CellPropertyFrm *)Frm)->ShowWindow(SW_MINIMIZE);
}

void CellPropertyView::OnReView(UINT wParam, LONG lParam)
{
	m_CellID = (int)wParam; m_SynapseID = (int) lParam;
	if(m_SynapseID<0) m_SynapseID=0;
	CSpinButtonCtrl* pSpin =(CSpinButtonCtrl*) GetDlgItem(IDC_CELL_SPIN);
	pSpin->SetRange(0,(int) Modl->CurrentCell-1);
	if(m_CellID >= 0){
		R=Modl->CellList[m_CellID].RC/Modl->CellList[m_CellID].C;
		APRC = Modl->CellList[m_CellID].APC*(Modl->CellList[m_CellID].APR+R);
		UpdateData(false);
		pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_SYNAPSE_SPIN);
		if(Modl->CellList[m_CellID].CountSyn>0){
			pSpin->SetRange(0,(int) Modl->CellList[m_CellID].CountSyn-1);
			pSpin->SetPos((int)lParam);
		}
		else pSpin->SetRange(0,0);
	}
	else{
		m_CellID = Modl->CurrentCell; m_SynapseID = 0;
		R=Modl->CellList[m_CellID].RC/Modl->CellList[m_CellID].C;
		APRC = Modl->CellList[m_CellID].APC*(Modl->CellList[m_CellID].APR+R);
		UpdateData(false);
		CString str("Default Cell");SetDlgItemText(IDC_CELL_ID, str);
	}
}

void CellPropertyView::OnSiftLock(UINT wParam, LONG lParam)
{
	CButton *mBut = (CButton *)GetDlgItem(IDC_SELECT);
	mBut->SetCheck ((int)wParam);
}

void CellPropertyView::OnSelect()
{
	((CreatorView*)View)->FixedShift = !((CreatorView*)View)->FixedShift;
	CButton *mBut = (CButton *)GetDlgItem(IDC_SELECT);
	mBut->SetCheck ((int)((CreatorView*)View)->FixedShift);
}

void CellPropertyView::OnDefault()
{
	DefauktSetter DS;
	DS.DD = &Modl->DD;
	if(DS.DoModal()==IDOK)Modl->SetDefault();
}

void CellPropertyView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(pScrollBar==GetDlgItem(IDC_CELL_SPIN)){
		m_CellID=nPos; m_SynapseID = 0;
		R=Modl->CellList[m_CellID].RC/Modl->CellList[m_CellID].C;
		APRC = Modl->CellList[m_CellID].APC*(Modl->CellList[m_CellID].APR+R);
		UpdateData(false);
		View->SendMessage(WM_REVIEW,m_CellID,0);
		CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_SYNAPSE_SPIN);
		if(Modl->CellList[m_CellID].CountSyn>0){
			pSpin->SetRange(0,(int) Modl->CellList[m_CellID].CountSyn-1);
			pSpin->SetPos(0);
		}
		else pSpin->SetRange(0,0);
	}
	if(pScrollBar==GetDlgItem(IDC_SYNAPSE_SPIN)){
		m_SynapseID=nPos;
		R=Modl->CellList[m_CellID].RC/Modl->CellList[m_CellID].C;
		APRC = Modl->CellList[m_CellID].APC*(Modl->CellList[m_CellID].APR+R);
		UpdateData(false);
		if(m_CellID < Modl->CurrentCell)
		View->SendMessage(WM_REVIEW,m_CellID,m_SynapseID);
	}

}

BOOL CellPropertyView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}
/////////////////////////////////////////////////////////////////////////////
// CellPropertyFrm

IMPLEMENT_DYNCREATE(CellPropertyFrm, CFrameWnd)

CellPropertyFrm::CellPropertyFrm()
{
	m_wndView.Frm = this;
}

CellPropertyFrm::~CellPropertyFrm()
{

}


BEGIN_MESSAGE_MAP(CellPropertyFrm, CFrameWnd)
	//{{AFX_MSG_MAP(CellPropertyFrm)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CellPropertyFrm message handlers

BOOL CellPropertyFrm::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;	
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

BOOL CellPropertyFrm::PreCreateWindow(CREATESTRUCT& cs) 
{
return CFrameWnd::PreCreateWindow(cs);
}

int CellPropertyFrm::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndView.Create(NULL, "Cell Property", WS_CHILD|WS_DISABLED,//AFX_WS_DEFAULT_VIEW,
		CRect(0,0,236,740), this, 0, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	else {
		m_wndView.ShowWindow(SW_SHOW);
		m_wndView.OnInitialUpdate();
	}
	
	return 0;
}

void CellPropertyFrm::OnSetFocus(CWnd* pOldWnd) 
{
//	CFrameWnd::OnSetFocus(pOldWnd);
	m_wndView.SetFocus();
}

