/*==========================================================================================*/
/*																							*/
/*                                  by Ruben Tikidji - Hamburyan                            */
/*																							*/
/*==========================================================================================*/

#include "stdafx.h"
#include "stdio.h"
#include "stdlib.h"
#include "math.h"
#include "NeuroCAD.h"
#include "CreatorView.h"
#include "InputMachin.h"
#include "DefuseSetter.h"
#include "DefauktSetter.h"
#include "CPS.h"
#include "NormSetter.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CreatorView

CreatorView::CreatorView()
{
	Condition  = 0;
	Resolution = 1;
	CurrentPoint.x = CurrentPoint.y=0;
	MaxSize.cx = 0;
	ReDraw = false;
	Bmp.CreateBitmap(1,1,1,1,NULL);
	SelectCell =-1; SelectLink =-1;
	Cell_N=RGB(0,128,255); Cell_A=RGB(0,255,255); Cell_B=RGB(255,255,0); Cell_C=RGB(0,255,0);
	Synapse_N=RGB(255,50,0); Synapse_A=RGB(255,255,0); Synapse_B=RGB(255,255,255);
	Input_N=RGB(180,0,255); Input_A=RGB(210,255,0); Input_B = RGB(128,128,128); 
	Input_C = RGB(200,200,200);
	InView = OutView = NumberView = true;
	Gauss = Reciproc = FixedShift = false;
	SelectCount = 0;
	NSelectCell = NULL;
}

CreatorView::~CreatorView()
{
}


BEGIN_MESSAGE_MAP(CreatorView,CWnd )
	//{{AFX_MSG_MAP(CreatorView)
	ON_MESSAGE (WM_REVIEW, OnReView)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(ID_CREATOR_SHAPE, OnUpdateCreatorShape)
	ON_COMMAND(ID_CREATOR_SHAPE, OnCreatorShape)
	ON_COMMAND(ID_CREATOR_NEWCELL, OnCreatorNewcell)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_NEWCELL, OnUpdateCreatorNewcell)
	ON_COMMAND(ID_CREATOR_CELL_END, OnCreatorCellEnd)
	ON_COMMAND(ID_CREATE_NEWLINK, OnCreateNewlink)
	ON_UPDATE_COMMAND_UI(ID_CREATE_NEWLINK, OnUpdateCreateNewlink)
	ON_COMMAND(ID_CREATOR_LINK_VIEW, OnCreatorLinkView)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_LINK_VIEW, OnUpdateCreatorLinkView)
	ON_COMMAND(ID_CREATOR_INPUT, OnCreatorInput)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_INPUT, OnUpdateCreatorInput)
	ON_COMMAND(ID_CREATOR_DELETE_CELL, OnCreatorDeleteCell)
	ON_COMMAND(ID_CREATOR_DELETE_INPUT, OnCreatorDeleteInput)
	ON_COMMAND(ID_CREATOR_DELETE_LINK, OnCreatorDeleteLink)
	ON_COMMAND(ID_CREATOR_TABLE, OnCreatorTable)
	ON_COMMAND(ID_CREATOR_PORJECTION_DIF, OnCreatorPorjectionDif)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_PORJECTION_DIF, OnUpdateCreatorPorjectionDif)
	ON_COMMAND(ID_CREATOR_PORJECTION_REC, OnCreatorPorjectionRec)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_PORJECTION_REC, OnUpdateCreatorPorjectionRec)
	ON_COMMAND(ID_CREATOR_PORJECTION_GAUS, OnCreatorPorjectionGaus)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_PORJECTION_GAUS, OnUpdateCreatorPorjectionGaus)
	ON_COMMAND(ID_CREATOR_STATBLOC, OnCreatorStatbloc)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_STATBLOC, OnUpdateCreatorStatbloc)
	ON_COMMAND(ID_CREATOR_GAUSS, OnCreatorGauss)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_GAUSS, OnUpdateCreatorGauss)
	ON_COMMAND(ID_CREATOR_UNSELECT, OnCreatorUnselect)
	ON_COMMAND(ID_CREATOR_SELECT_CH, OnCreatorSelectCh)
	ON_COMMAND(ID_CREATOR_SH_SYN, OnCreatorShSyn)
	ON_COMMAND(ID_CREATOR_NORM, OnCreatorNorm)
	ON_COMMAND(ID_CREATOR_IF, OnCreatorIf)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_IF, OnUpdateCreatorIf)
	ON_COMMAND(ID_CREATOR_POP_STR, OnCreatorPopStr)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_POP_STR, OnUpdateCreatorPopStr)
	ON_COMMAND(ID_CREATOR_PUSH_STR, OnCreatorPushStr)
	ON_COMMAND(ID_CREATOR_TABLE_SELECT, OnCreatorTableSelect)
	ON_COMMAND(ID_FIXED_SHIFT, OnFixedShift)
	ON_COMMAND(ID_UNFIXED_SHIFT, OnUnfixedShift)
	ON_COMMAND(ID_CREATOR_FANPROJECTION, OnCreatorFanprojection)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_FANPROJECTION, OnUpdateCreatorFanprojection)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_CREATOR_NORM_AUTO, OnCreatorNormAuto)
	ON_UPDATE_COMMAND_UI(ID_CREATOR_NORM_AUTO, OnUpdateCreatorNormAuto)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CreatorView message handlers

BOOL CreatorView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;
	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style |= WS_HSCROLL|WS_VSCROLL;
	cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
		AfxGetApp()->LoadStandardCursor(IDC_ARROW),(HBRUSH)(COLOR_WINDOW +2));
	return TRUE;
}
void CreatorView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	CurSize.cy =cy; CurSize.cx = cx;
	if(MaxSize.cx == 0){
		MaxSize.cx = CurSize.cx * 10;	MaxSize.cy = CurSize.cy * 10; 
		CurrentPoint.x = MaxSize.cx/2;	CurrentPoint.y = MaxSize.cy/2;
	}
	DrawView();
}
void CreatorView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(nSBCode == SB_LINELEFT){
		if((CurrentPoint.x - CurSize.cx/(10*Resolution)) > CurSize.cx/(2*Resolution))
			CurrentPoint.x -= CurSize.cx/(10*Resolution);
		else 
			CurrentPoint.x = CurSize.cx/(2*Resolution);
	}
	if(nSBCode == SB_LINERIGHT){
		CurrentPoint.x += CurSize.cx/(10*Resolution);
		if(CurrentPoint.x + CurSize.cx/(2*Resolution) > MaxSize.cx)
			MaxSize.cx = CurrentPoint.x + CurSize.cx/(Resolution);
	}

	if(nSBCode == SB_PAGELEFT){
		if((CurrentPoint.x - CurSize.cx/(2*Resolution)) > CurSize.cx/(2*Resolution))
			CurrentPoint.x -= CurSize.cx/(2*Resolution);
		else 
			CurrentPoint.x = CurSize.cx/(2*Resolution);
	}
	if(nSBCode == SB_PAGERIGHT){
		CurrentPoint.x += CurSize.cx/(2*Resolution);
		if(CurrentPoint.x + CurSize.cx/(2*Resolution) > MaxSize.cx)
			MaxSize.cx = CurrentPoint.x + CurSize.cx/(Resolution);
	}
	DrawView();
}

void CreatorView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(nSBCode == SB_LINELEFT){
		if((CurrentPoint.y - CurSize.cy/(10*Resolution)) > CurSize.cy/(2*Resolution))
			CurrentPoint.y -= CurSize.cy/(10*Resolution);
		else 
			CurrentPoint.y = CurSize.cy/(2*Resolution);
	}
	if(nSBCode == SB_LINERIGHT){
		CurrentPoint.y += CurSize.cy/(10*Resolution);
		if(CurrentPoint.y + CurSize.cy/(2*Resolution) > MaxSize.cy)
			MaxSize.cy = CurrentPoint.y + CurSize.cy/(Resolution);
	}

	if(nSBCode == SB_PAGELEFT){
		if((CurrentPoint.y - CurSize.cy/(2*Resolution)) > CurSize.cy/(2*Resolution))
			CurrentPoint.y -= CurSize.cy/(2*Resolution);
		else 
			CurrentPoint.y = CurSize.cy/(2*Resolution);
	}
	if(nSBCode == SB_PAGERIGHT){
		CurrentPoint.y += CurSize.cy/(2*Resolution);
		if(CurrentPoint.y + CurSize.cy/(2*Resolution) > MaxSize.cy)
			MaxSize.cy = CurrentPoint.y + CurSize.cy/(Resolution);
	}	
	DrawView();
}

void CreatorView::DrawView()
{
//Scroll
	SetScrollRange(SB_HORZ,CurSize.cx/(2*Resolution),MaxSize.cx*Resolution,true);	
	SetScrollPos(SB_HORZ,CurrentPoint.x*Resolution,true);
	SetScrollRange(SB_VERT,CurSize.cy/(2*Resolution),MaxSize.cy*Resolution,true);	
	SetScrollPos(SB_VERT,CurrentPoint.y*Resolution,true);
	ReDraw = true;
	Invalidate(false);
}
void CreatorView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if(ReDraw){
		CDC mDC; mDC.CreateCompatibleDC(&dc);
		Bmp.DeleteObject();
		Bmp.CreateCompatibleBitmap(&dc, CurSize.cx,CurSize.cy);

		//Draw Cells
		CPoint Ziro(CurrentPoint.x - CurSize.cx/(2*Resolution),
			        CurrentPoint.y - CurSize.cy/(2*Resolution));
		CRect RWnd(CurrentPoint.x - CurSize.cx/(2*Resolution)-7,
			       CurrentPoint.y - CurSize.cy/(2*Resolution)-7,
			       CurrentPoint.x + CurSize.cx/(2*Resolution)+7,
				   CurrentPoint.y + CurSize.cy/(2*Resolution)+7);
		
		CPen	CellPen(PS_SOLID,(Resolution<1)?1:Resolution, RGB(0,0,0)); 
		CBrush	CellBrs(Cell_N);
		CBrush	CellBrsA(Cell_A);
		CBrush	CellBrsB(Cell_B);
		CBrush	CellBrsC(Cell_C);
		CBrush	InBrs(Input_N);
		CBrush	InBrsA(Input_A);
		CBrush	InBrsB(Input_B);
		CBrush	InBrsC(Input_C);
		
		mDC.SelectObject(&Bmp);
		mDC.FillSolidRect(CRect(0,0,CurSize.cx,CurSize.cy),RGB(110,110,110));
		mDC.SetTextColor(RGB(255,255,255));

		CPen *OldPen = mDC.SelectObject(&CellPen); CBrush *OldBrs=mDC.SelectObject(&CellBrs);
		CPoint Pos;
		CPoint Pol[4];int s=4;
		CString str; 
		for(int i=0; i<Mod->CurrentCell; i++){
			Pos = MODtoLP(Mod->VCellList[i].Pos);
			switch(Mod->VCellList[i].Select){
			case 0:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&CellBrs);		
				mDC.Ellipse(Pos.x-10*Resolution,Pos.y-10*Resolution,
				            Pos.x+10*Resolution,Pos.y+10*Resolution);
				break;
			case 1:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&CellBrsA);
				mDC.Ellipse(Pos.x-10*Resolution,Pos.y-10*Resolution,
				            Pos.x+10*Resolution,Pos.y+10*Resolution);
				break;
			case 2:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&CellBrsB);
				mDC.Ellipse(Pos.x-10*Resolution,Pos.y-10*Resolution,
				            Pos.x+10*Resolution,Pos.y+10*Resolution);
				break;
			case 3:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&CellBrsC);
				mDC.Ellipse(Pos.x-10*Resolution,Pos.y-10*Resolution,
				            Pos.x+10*Resolution,Pos.y+10*Resolution);
				break;
			case 0x10:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrs);		
				mDC.Rectangle(Pos.x-20*Resolution,Pos.y-10*Resolution,
				              Pos.x+20*Resolution,Pos.y+10*Resolution);
				if(NumberView){
					str.Format("%d",Mod->Input.GetNumberInput(i));
					mDC.TextOut(Pos.x-18*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x11:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrsA);		
				mDC.Rectangle(Pos.x-20*Resolution,Pos.y-15*Resolution,
				              Pos.x+20*Resolution,Pos.y+15*Resolution);
				if(NumberView){
					str.Format("%d",Mod->Input.GetNumberInput(i));
					mDC.TextOut(Pos.x-18*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x12:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrsA);		
				mDC.Rectangle(Pos.x-20*Resolution,Pos.y-15*Resolution,
				              Pos.x+20*Resolution,Pos.y+15*Resolution);
				if(NumberView){
					str.Format("%d",Mod->Input.GetNumberInput(i));
					mDC.TextOut(Pos.x-18*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x13:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrsC);		
				mDC.Rectangle(Pos.x-20*Resolution,Pos.y-15*Resolution,
				              Pos.x+20*Resolution,Pos.y+15*Resolution);
				if(NumberView){
					str.Format("%d",Mod->Input.GetNumberInput(i));
					mDC.TextOut(Pos.x-18*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x20:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrs);
				Pol[0]=CPoint(Pos.x,Pos.y-10*Resolution);
				Pol[2]=CPoint(Pos.x,Pos.y+10*Resolution);
				Pol[1]=CPoint(Pos.x-20*Resolution,Pos.y);
				Pol[3]=CPoint(Pos.x+20*Resolution,Pos.y);
				mDC.Polygon(Pol, 4 );
				if(NumberView){
					str.Format("%d",Mod->IfModul.GetNumberInput(i));
					mDC.TextOut(Pos.x-10*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x21:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrsA);		
				Pol[0]=CPoint(Pos.x,Pos.y-15*Resolution);
				Pol[2]=CPoint(Pos.x,Pos.y+15*Resolution);
				Pol[1]=CPoint(Pos.x-20*Resolution,Pos.y);
				Pol[3]=CPoint(Pos.x+20*Resolution,Pos.y);
				mDC.Polygon(Pol, 4 );
				if(NumberView){
					str.Format("%d",Mod->IfModul.GetNumberInput(i));
					mDC.TextOut(Pos.x-10*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x22:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrsA);		
				Pol[0]=CPoint(Pos.x,Pos.y-15*Resolution);
				Pol[2]=CPoint(Pos.x,Pos.y+15*Resolution);
				Pol[1]=CPoint(Pos.x-20*Resolution,Pos.y);
				Pol[3]=CPoint(Pos.x+20*Resolution,Pos.y);
				mDC.Polygon(Pol, 4 );
				if(NumberView){
					str.Format("%d",Mod->IfModul.GetNumberInput(i));
					mDC.TextOut(Pos.x-10*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			case 0x23:
				mDC.SelectObject(&CellPen);		mDC.SelectObject(&InBrsC);
				Pol[0]=CPoint(Pos.x,Pos.y-15*Resolution);
				Pol[2]=CPoint(Pos.x,Pos.y+15*Resolution);
				Pol[1]=CPoint(Pos.x-20*Resolution,Pos.y);
				Pol[3]=CPoint(Pos.x+20*Resolution,Pos.y);
				mDC.Polygon(Pol, 4 );
				if(NumberView){
					str.Format("%d",Mod->IfModul.GetNumberInput(i));
					mDC.TextOut(Pos.x-10*Resolution,Pos.y-8*Resolution,str);
				}
				break;
			}
			if((Mod->VCellList[i].Select&0x04 > 1)|(Condition == 8)){
				for(int To=0; To<Mod->CurrentCell; To++){
					if((Mod->ConMap[i][To].Current>0)&OutView){
						DrawSynapse(mDC,i,To,((SelectCell == i)|(SelectCell == To)) ? 1:0);
					}
					if((Mod->ConMap[To][i].Current>0)&InView){
						DrawSynapse(mDC,To,i,((SelectCell == i)|(SelectCell == To)) ? 1:0);
					}
				}
			}

		}
		mDC.SelectObject(OldPen);
		mDC.SelectObject(OldBrs);
		ReDraw = false;
		mDC.DeleteDC();
	}
	
	dc.DrawState(CPoint(0,0), CurSize,&Bmp,DST_BITMAP);
//	dc.SetBkMode(TRANSPARENT);
	if((Condition == 6)&(SelectCell>=0)){
		CPen Line(PS_DOT,(Resolution<1)?1:Resolution, RGB(255,0,0)), *Old;
		Old=dc.SelectObject(&Line);
		dc.MoveTo(MODtoLP(Mod->VCellList[SelectCell].Pos));
		dc.LineTo(CursorPoint);
		dc.SelectObject(Old);
	}
	if((Condition == 0x11)|(Condition == 0x15)|(Condition == 0x31)|(Condition == 0x01)|(Condition == 0x1A)){
		CPen Line(PS_DOT,(Resolution<1)?1:Resolution, RGB(100,100,100)), *Old;
		Old=dc.SelectObject(&Line);
		dc.MoveTo(MODtoLP(From_1));
		dc.LineTo(MODtoLP(From_1).x,CursorPoint.y);
		dc.LineTo(CursorPoint);
		dc.LineTo(CursorPoint.x,MODtoLP(From_1).y);
		dc.LineTo(MODtoLP(From_1));
		dc.SelectObject(Old);
	}
	if((Condition == 0x13)|(Condition == 0x1C)){
		CPen Line(PS_DOT,(Resolution<1)?1:Resolution, RGB(0,255,0)), *Old;
		Old=dc.SelectObject(&Line);
		dc.MoveTo(MODtoLP(To_1));
		dc.LineTo(MODtoLP(To_1).x,CursorPoint.y);
		dc.LineTo(CursorPoint);
		dc.LineTo(CursorPoint.x,MODtoLP(To_1).y);
		dc.LineTo(MODtoLP(To_1));
		dc.SelectObject(Old);
	}
	if(Condition == 0x17){
		CPen Line(PS_DOT,(Resolution<1)?1:Resolution, RGB(0,255,0)), *Old;
		Old=dc.SelectObject(&Line);
		dc.MoveTo(MODtoLP(To_1)); dc.LineTo(CursorPoint);
		dc.SelectObject(Old);
	}
	if(Condition == 0x18){
		CPen Line(PS_DOT,(Resolution<1)?2:Resolution, RGB(0,255,0)), *Old;
		CBrush Brush(HS_DIAGCROSS,RGB(0,255,0)), *OldBrush;
//		CBrush Brush(NULL_BRUSH), *OldBrush;
		Old=dc.SelectObject(&Line);
		OldBrush = dc.SelectObject(&Brush);
		dc.MoveTo(MODtoLP(To_1)); dc.LineTo(MODtoLP(To_2));
		int R = (abs(MODtoLP(To_2).x - CursorPoint.x) > abs(MODtoLP(To_2).y - CursorPoint.y)) ?
			abs(MODtoLP(To_2).x - CursorPoint.x) : abs(MODtoLP(To_2).y - CursorPoint.y);
		CRect rect(MODtoLP(To_2).x + R,MODtoLP(To_2).y + R, MODtoLP(To_2).x - R, MODtoLP(To_2).y - R);
		dc.Ellipse(rect);
		dc.SelectObject(Old);
		dc.SelectObject(OldBrush);
	}
	if(Condition == 0x20){
		CPen Line(PS_DOT,(Resolution<1)?1:Resolution, RGB(0,0,255)), *Old;
		Old=dc.SelectObject(&Line);
		dc.MoveTo(MODtoLP(Mod->VCellList[NSelectCell[0]].Pos)); dc.LineTo(CursorPoint);
		dc.SelectObject(Old);
	}
	if(Condition == 0x1E){
		CBrush Brush(HS_DIAGCROSS,RGB(0,255,0)), *OldBrush;
//		CBrush Brush(NULL_BRUSH), *OldBrush;
		OldBrush = dc.SelectObject(&Brush);
		int R = (abs(MODtoLP(To_3).x - CursorPoint.x) > abs(MODtoLP(To_3).y - CursorPoint.y)) ?
			abs(MODtoLP(To_3).x - CursorPoint.x) : abs(MODtoLP(To_3).y - CursorPoint.y);
		CRect rect(MODtoLP(To_3).x + R,MODtoLP(To_3).y + R, MODtoLP(To_3).x - R, MODtoLP(To_3).y - R);
		dc.Ellipse(rect);
		dc.SelectObject(OldBrush);
	}




}

void CreatorView::OnReView(UINT wParam, LONG lParam)
{
	if((SelectCell>=0)&(!FixedShift)) 
		Mod->VCellList[SelectCell].Select&=0xff0;
	SelectCell = (int) wParam; SelectLink = (int)lParam;
	Mod->VCellList[SelectCell].Select|=0x001;
	ReDraw = true; Invalidate(false);
}



void CreatorView::OnCreatorShape() 
{
	OnCreatorCellEnd();
}

void CreatorView::OnUpdateCreatorShape(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 0));}

void CreatorView::OnCreatorNewcell() 
{
	if(Condition != 3)Condition = 3; 
	else Condition = 0;
}

void CreatorView::OnUpdateCreatorNewcell(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 3));}

void CreatorView::OnCreatorCellEnd() 
{
	if((Condition >0x0F)&(Condition <0x20)){
		for(int c = 0; c<Mod->CurrentCell; c++) Mod->VCellList[c].Select &= 0xff0;
	}

	Condition = 0;
	if(SelectCell>=0)Mod->VCellList[SelectCell].Select&= 0xff0;
	SelectCell = -1; SelectLink = -1;
	CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell, SelectLink);
	ReDraw = true; Invalidate(false);	
}

void CreatorView::OnCreateNewlink() 
{
	if(Condition != 6)		Condition = 6;
	else if(Condition ==6){
		Condition = 0;
		Mod->VCellList[SelectCell].Select--;
		SelectCell = -1; SelectLink = -1;
		CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,-1);
		ReDraw = true; Invalidate(false);
	}
}
void CreatorView::OnUpdateCreateNewlink(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 6));}

void CreatorView::OnCreatorLinkView() 
{
	if(Condition != 8) Condition = 8;	else Condition =0;
	ReDraw = true; Invalidate(false);
}

void CreatorView::OnUpdateCreatorLinkView(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 8));}

void CreatorView::OnCreatorInput() 
{
	if (Condition !=10){	OnCreatorCellEnd();		Condition = 10;	}
	else	OnCreatorCellEnd();		
}

void CreatorView::OnUpdateCreatorInput(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 10));}

void CreatorView::OnCreatorDeleteCell() 
{
	if(SelectCell<0) return;
	if(Mod->VCellList[SelectCell].Select>4)return;
	Mod->VCellList[SelectCell].Select&=0xf0;
	Mod->DeleteCell(SelectCell);
	ReDraw=true;Invalidate(false);
	SelectCell = SelectLink = -1;
	CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
}

void CreatorView::OnCreatorDeleteLink() 
{
	if((SelectCell<0)|(SelectCell>=Mod->CurrentCell))return;
	if((SelectLink<0)|(SelectLink>=Mod->CellList[SelectCell].CountSyn))return;
	Mod->DeleteLink(SelectCell,SelectLink);
	ReDraw=true;Invalidate(false);
	SelectLink = -1;
	CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
}

void CreatorView::OnCreatorDeleteInput() 
{
	if(SelectCell<0) return;
	if(Mod->VCellList[SelectCell].Select<0x10) return;
	Mod->VCellList[SelectCell].Select&=0xf0;
	Mod->DeleteInputM(SelectCell);
	ReDraw=true;Invalidate(false);
	SelectCell = SelectLink = -1;
	CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
}

void CreatorView::OnCreatorPorjectionDif() 
{
	int SC=-1;
	for(int c=0; c<Mod->CurrentCell; c++) 
		if(Mod->VCellList[c].Select&0x00f >0x000) SC = c;

	if( SC < 0)	Condition = 0x10;
	else		Condition = 0x12;
}

void CreatorView::OnUpdateCreatorPorjectionDif(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((Condition == 0)|((Condition>0x0F)&(Condition<0x14)));
	pCmdUI->SetCheck((int)((Condition>0x0F)&(Condition<0x14)));
}

void CreatorView::OnCreatorPorjectionGaus() 
{
	//OnCreatorCellEnd();
	int SC=-1;
	for(int c=0; c<Mod->CurrentCell; c++) 
		if(Mod->VCellList[c].Select&0x00f >0x000) SC = c;

	if( SC < 0)	Condition = 0x14;
	else		Condition = 0x16;
}

void CreatorView::OnUpdateCreatorPorjectionGaus(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((Condition == 0)|((Condition>0x13)&(Condition<0x18)));
	pCmdUI->SetCheck((int)((Condition>0x13)&(Condition<0x18)));
}

void CreatorView::OnCreatorPorjectionRec() 
{	Reciproc = !Reciproc;	}

void CreatorView::OnUpdateCreatorPorjectionRec(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck(Reciproc);	}

void CreatorView::OnCreatorStatbloc() 
{
	if(Condition == 0) Condition = 0x30;
	else if((Condition>=0x30)&(Condition<=0x32)) Condition =0;
}

void CreatorView::OnUpdateCreatorStatbloc(CCmdUI* pCmdUI) 
{
	if((Condition == 0)|((Condition>=0x30)&(Condition<=0x32))) pCmdUI->Enable(true);
	else pCmdUI->Enable(false);
	pCmdUI->SetCheck((int)((Condition>=0x30)&(Condition<=0x32)));
}

void CreatorView::OnCreatorGauss() 
{
	Gauss = !Gauss;
}

void CreatorView::OnUpdateCreatorGauss(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((Condition == 0)|((Condition>0x13)&(Condition<0x18)));
	pCmdUI->SetCheck((int)Gauss);
}

void CreatorView::OnCreatorIf() 
{
	if (Condition !=0x0c){	OnCreatorCellEnd();		Condition = 0x0c;	}
	else	OnCreatorCellEnd();		
}

void CreatorView::OnUpdateCreatorIf(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 0x0c));}

void CreatorView::OnCreatorFanprojection() 
{
	if(Condition == 0){
		int SC=-1;
		for(int c=0; c<Mod->CurrentCell; c++){
			if(Mod->VCellList[c].Select&0x0f > 0) SC = c;
		}
		if(SC < 0)	Condition = 0x19;
		else		Condition = 0x1A;
	}
	else
		OnCreatorCellEnd();
}

void CreatorView::OnUpdateCreatorFanprojection(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((Condition == 0)|((Condition > 0x18)&(Condition < 0x1f)));
	pCmdUI->SetCheck((int)((Condition > 0x18)&(Condition < 0x1f)));
}

void CreatorView::OnMouseMove(UINT nFlags, CPoint point) 
{
	Position RP = LPtoMOD(point); CString str;
	str.Format("Position: X:%d Y:%d",RP.x, RP.y);
	m_StatusBar->SetPaneText(1,str,true);

	if((Condition == 6)&(SelectCell>=0)){
		CursorPoint = point;
		Invalidate(false);
	}
	if((Condition == 0x11)|(Condition == 0x13)|
	   (Condition == 0x15)|(Condition == 0x17)|
	   (Condition == 0x18)|(Condition == 0x31)|
	   (Condition == 0x01)|(Condition == 0x20)|
	   (Condition == 0x1A)|(Condition == 0x1C)|
	   (Condition == 0x1E)){
		CursorPoint = point;
		Invalidate(false);
	}

}

void CreatorView::OnLButtonUp(UINT nFlags, CPoint point)
{
	if((Condition==0x11)|(Condition == 0x15)|(Condition == 0x01)|(Condition == 0x1A)){
		From_2 = LPtoMOD(point);
		if(From_1.x < From_2.x){
			if(From_1.y < From_2.y){
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_1.x)&(Mod->VCellList[C].Pos.x<From_2.x)&
					   (Mod->VCellList[C].Pos.y>From_1.y)&(Mod->VCellList[C].Pos.y<From_2.y))
					   Mod->VCellList[C].Select |= 0x01;
				}
			}
			else{
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_1.x)&(Mod->VCellList[C].Pos.x<From_2.x)&
					   (Mod->VCellList[C].Pos.y>From_2.y)&(Mod->VCellList[C].Pos.y<From_1.y))
					   Mod->VCellList[C].Select |= 0x01;
				}
			}
		}
		else{
			if(From_1.y < From_2.y){
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_2.x)&(Mod->VCellList[C].Pos.x<From_1.x)&
					   (Mod->VCellList[C].Pos.y>From_1.y)&(Mod->VCellList[C].Pos.y<From_2.y))
					   Mod->VCellList[C].Select |= 0x01;
				}
			}
			else{
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_2.x)&(Mod->VCellList[C].Pos.x<From_1.x)&
					   (Mod->VCellList[C].Pos.y>From_2.y)&(Mod->VCellList[C].Pos.y<From_1.y))
					   Mod->VCellList[C].Select |= 0x01;
				}
			}
		}
		switch(Condition){
		case 0x11: Condition = 0x12; break;
		case 0x15: Condition = 0x16; break;
		case 0x01: Condition = 0x00; break;
		case 0x1A: Condition = 0x1B; break;
		}
		ReDraw = true;
		Invalidate(false);
	}
	if((Condition==0x13)|(Condition==0x1C)){
		To_2 = LPtoMOD(point);
		if(To_1.x < To_2.x){
			if(To_1.y < To_2.y){
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>To_1.x)&(Mod->VCellList[C].Pos.x<To_2.x)&
					   (Mod->VCellList[C].Pos.y>To_1.y)&(Mod->VCellList[C].Pos.y<To_2.y))
					   Mod->VCellList[C].Select |= 0x02;
				}
			}
			else{
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>To_1.x)&(Mod->VCellList[C].Pos.x<To_2.x)&
					   (Mod->VCellList[C].Pos.y>To_2.y)&(Mod->VCellList[C].Pos.y<To_1.y))
					   Mod->VCellList[C].Select |= 0x02;
				}
			}
		}
		else{
			if(To_1.y < To_2.y){
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>To_2.x)&(Mod->VCellList[C].Pos.x<To_1.x)&
					   (Mod->VCellList[C].Pos.y>To_1.y)&(Mod->VCellList[C].Pos.y<To_2.y))
					   Mod->VCellList[C].Select |= 0x02;
				}
			}
			else{
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>To_2.x)&(Mod->VCellList[C].Pos.x<To_1.x)&
					   (Mod->VCellList[C].Pos.y>To_2.y)&(Mod->VCellList[C].Pos.y<To_1.y))
					   Mod->VCellList[C].Select |= 0x02;
				}
			}
		}
		if(Condition == 0x1C){
			Condition = 0x1D;
			ReDraw = true;
			Invalidate(false);
			return;
		}
		DefuseSetter DF;
		CPS cps;
		cps.Reciprocally =Reciproc;
		DF.Reciprocal = Reciproc;
		DF.Local = false;

		if((cps.DoModal() == IDOK)&(DF.DoModal() == IDOK)){
			DifProjection(false, DF.m_From, DF.m_To, cps.DirectData);
			if(Reciproc) DifProjection(true, DF.m_From2, DF.m_To2, cps.ReciprocData);
			OnCreatorCellEnd();
			Condition = 8;
			ReDraw = true;
			Invalidate(false);
		}
		else
			OnCreatorCellEnd();
	}
	if(Condition == 0x17){
		To_2 = LPtoMOD(point);
		Condition = 0x18;
		Invalidate(false);
	}
	if(Condition == 0x31){
		From_2 = LPtoMOD(point);
		if(From_1.x < From_2.x){
			if(From_1.y < From_2.y){
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_1.x)&(Mod->VCellList[C].Pos.x<From_2.x)&
					   (Mod->VCellList[C].Pos.y>From_1.y)&(Mod->VCellList[C].Pos.y<From_2.y))
					   Mod->SWatcher.AddCell(C);
				}
			}
			else{
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_1.x)&(Mod->VCellList[C].Pos.x<From_2.x)&
					   (Mod->VCellList[C].Pos.y>From_2.y)&(Mod->VCellList[C].Pos.y<From_1.y))
					   Mod->SWatcher.AddCell(C);
				}
			}
		}
		else{
			if(From_1.y < From_2.y){
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_2.x)&(Mod->VCellList[C].Pos.x<From_1.x)&
					   (Mod->VCellList[C].Pos.y>From_1.y)&(Mod->VCellList[C].Pos.y<From_2.y))
					   Mod->SWatcher.AddCell(C);
				}
			}
			else{
				for(int C=0; C<Mod->CurrentCell; C++){
					if((Mod->VCellList[C].Pos.x>From_2.x)&(Mod->VCellList[C].Pos.x<From_1.x)&
					   (Mod->VCellList[C].Pos.y>From_2.y)&(Mod->VCellList[C].Pos.y<From_1.y))
					   Mod->SWatcher.AddCell(C);
				}
			}
		}
		Condition = 0;
		Invalidate(false);
	}
	if(Condition == 0x1E){
		int Rad= sqrt((LPtoMOD(point).x-To_3.x)*(LPtoMOD(point).x-To_3.x)+
					  (LPtoMOD(point).y-To_3.y)*(LPtoMOD(point).y-To_3.y));

		DefuseSetter DF;
		CPS cps;
		cps.Reciprocally = DF.Reciprocal = Reciproc;
		DF.Local = true;
		
		if((cps.DoModal() == IDOK)&(DF.DoModal() == IDOK)){
			if(Gauss)
				for(int cnt=0; cnt<DF.m_To; cnt++)
					GFanProjection(false, Rad, cps.DirectData);
			else
				for(int cnt=0; cnt<DF.m_To; cnt++)
					FanProjection(false, Rad, cps.DirectData);

			if(Reciproc)
				if(Gauss)
					for(int cnt=0; cnt<DF.m_To2; cnt++)
						GFanProjection(true, Rad, cps.ReciprocData);
				else
					for(int cnt=0; cnt<DF.m_To2; cnt++)
						FanProjection(true, Rad, cps.ReciprocData);

			OnCreatorCellEnd(); OnCreatorUnselect();
			Condition = 8;
			ReDraw = true;
			Invalidate(false);
		}
		else
			OnCreatorCellEnd();	
	}

}


void CreatorView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	Position RPoint = LPtoMOD(point);
	if((Condition == 6)&(SelectCell >=0)){
		int ToCell = -1;
		for(int i=0; i<Mod->CurrentCell; i++){
			if((RPoint.x>Mod->VCellList[i].Pos.x-10/Resolution)&
			   (RPoint.x<Mod->VCellList[i].Pos.x+10/Resolution)&
			   (RPoint.y>Mod->VCellList[i].Pos.y-10/Resolution)&
			   (RPoint.y<Mod->VCellList[i].Pos.y+10/Resolution)){
				ToCell=i;
				break;
			}
		}
		if(Mod->VCellList[ToCell].Select > 0x0f) return;
		if((ToCell>=0)&(ToCell != SelectCell)){
			Mod->VCellList[SelectCell].Select--;
			CellPro->SendMessage(WM_REVIEW,(WPARAM)ToCell,SelectLink = Mod->AddLink(SelectCell,ToCell));
			SelectCell = ToCell;Mod->VCellList[SelectCell].Select++;
			ReDraw = true; Invalidate(false);
		}
		else if(ToCell == SelectCell){
			Mod->VCellList[SelectCell].Select--;
			SelectCell = SelectLink = -1;
			CellPro->SendMessage(WM_REVIEW,(WPARAM)ToCell,SelectLink);
			ReDraw = true; Invalidate(false);
			return;
		}
	}
	if((Condition == 0)|((Condition == 6)&(SelectCell <0))){
		if((SelectCell>=0)&(nFlags == 1))
			Mod->VCellList[SelectCell].Select--;
		for(int i=0; i<Mod->CurrentCell; i++){
			if((RPoint.x>Mod->VCellList[i].Pos.x-10/Resolution)&
			   (RPoint.x<Mod->VCellList[i].Pos.x+10/Resolution)&
			   (RPoint.y>Mod->VCellList[i].Pos.y-10/Resolution)&
			   (RPoint.y<Mod->VCellList[i].Pos.y+10/Resolution)){
				SelectCell=i;
				break;
			}
			else SelectCell = -1;
		}
		SelectLink = -1;
		if(SelectCell>=0){ 
			int SC = SelectCell;
			if((Mod->VCellList[SelectCell].Select&0x0f)>0) OnCreatorUnselect();
			SelectCell = SC;
			CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
			Mod->VCellList[SelectCell].Select++;
			ReDraw = true; Invalidate(false);
		}
		else{
			From_1 = RPoint;
			Condition = 0x01;
		}
	}
	switch(Condition){
	case 0x19: From_1 = RPoint; Condition = 0x1A; break;
	case 0x1B: To_1   = RPoint; Condition = 0x1C; break;
	case 0x1D: To_3   = RPoint; Condition = 0x1E; break;
	}

	if(Condition == 3){
		if(SelectCell>=0)Mod->VCellList[SelectCell].Select--;
		SelectCell=Mod->AddCell(RPoint);
		Mod->VCellList[SelectCell].Select++;
		ReDraw = true; Invalidate(false);
		CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,0);
	}
	if(Condition == 0x0A){
		if(SelectCell>=0)Mod->VCellList[SelectCell].Select--;
		Mod->VCellList[SelectCell = Mod->AddInputM(RPoint)].Select++;
		ReDraw = true; Invalidate(false);
		CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
	}
	if(Condition == 0x0c){
		if(SelectCell>=0)Mod->VCellList[SelectCell].Select--;
		Mod->VCellList[SelectCell = Mod->AddIfM(RPoint)].Select++;
		ReDraw = true; Invalidate(false);
		CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
	}
	if(Condition == 0x10){
		From_1 = RPoint;
		Condition = 0x11;
		Invalidate(false);
	}
	if(Condition == 0x12){
		To_1 = RPoint;
		Condition = 0x13;
		Invalidate(false);
	}
	if(Condition == 0x14){
		From_1 = RPoint;
		Condition = 0x15;
		Invalidate(false);
	}
	if(Condition == 0x16){
		int StartFocus = -1;
		for(int i=0; i<Mod->CurrentCell; i++){
			if((RPoint.x>Mod->VCellList[i].Pos.x-10/Resolution)&
			   (RPoint.x<Mod->VCellList[i].Pos.x+10/Resolution)&
			   (RPoint.y>Mod->VCellList[i].Pos.y-10/Resolution)&
			   (RPoint.y<Mod->VCellList[i].Pos.y+10/Resolution)){
				StartFocus=i;
				break;
			}
			else StartFocus = -1;
		}
		if((StartFocus<0)|((Mod->VCellList[StartFocus].Select&0x0F) != 0x1))return;
		To_1 = RPoint;
		Condition = 0x17;
		Invalidate(false);
	}		
	if(Condition == 0x18){
		To_3 = LPtoMOD(point);
		int Rad = sqrt((To_2.x-To_3.x)*(To_2.x-To_3.x)+
					   (To_2.y-To_3.y)*(To_2.y-To_3.y));
		DefuseSetter DF;
		CPS cps;
		cps.Reciprocally = DF.Reciprocal = Reciproc;
		DF.Local = true;
		
		if((cps.DoModal() == IDOK)&(DF.DoModal() == IDOK)){
			if(Gauss)
				GLocalProjection(false, Rad, To_2.x-To_1.x, To_2.y-To_1.y,
															DF.m_To, cps.DirectData);
			else
				LocalProjection(false, Rad, To_2.x-To_1.x, To_2.y-To_1.y,
															DF.m_To, cps.DirectData);

			if(Reciproc)
				if(Gauss)
					GLocalProjection(true, Rad, To_2.x-To_1.x, To_2.y-To_1.y,
														 DF.m_To2, cps.ReciprocData);
				else
					LocalProjection(true, Rad, To_2.x-To_1.x, To_2.y-To_1.y,
														 DF.m_To2, cps.ReciprocData);

			OnCreatorCellEnd();
			Condition = 8;
			ReDraw = true;
			Invalidate(false);
		}
		else
			OnCreatorCellEnd();
	}
	if(Condition == 0x30){
		int SCell = -1;
		for(int i=0; i<Mod->CurrentCell; i++){
			if((RPoint.x>Mod->VCellList[i].Pos.x-10/Resolution)&
			   (RPoint.x<Mod->VCellList[i].Pos.x+10/Resolution)&
			   (RPoint.y>Mod->VCellList[i].Pos.y-10/Resolution)&
			   (RPoint.y<Mod->VCellList[i].Pos.y+10/Resolution)){
				SCell=i;
				break;
			}
		}
		if(SCell>=0){
			Mod->SWatcher.AddCell(SCell);
			Condition = 0;
		}
		else{
			From_1 = LPtoMOD(point);
			Condition = 0x31;
		}
	}
	if(Condition == 0x20){
		Position Shift = RPoint - Mod->VCellList[NSelectCell[0]].Pos;
		for(int c=0; c<SelectCount; c++){
			switch(Mod->VCellList[NSelectCell[c]].Select & 0xf0){
			case 0x00:
				Mod->AddCell(Mod->VCellList[NSelectCell[c]].Pos+Shift);
				break;
			case 0x10:
				Mod->AddInputM(Mod->VCellList[NSelectCell[c]].Pos+Shift);
				break;
			case 0x20:
				Mod->AddIfM(Mod->VCellList[NSelectCell[c]].Pos+Shift);
				break;
			}
		}
			OnCreatorCellEnd();
			ReDraw = true;
			Invalidate(false);
	}
}

void CreatorView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	if(Condition == 0){
		Position RPoint = LPtoMOD(point);
		int C = -1;
		for(int i=0; i<Mod->CurrentCell; i++){
			if((RPoint.x>Mod->VCellList[i].Pos.x-10/Resolution)&
			   (RPoint.x<Mod->VCellList[i].Pos.x+10/Resolution)&
			   (RPoint.y>Mod->VCellList[i].Pos.y-10/Resolution)&
			   (RPoint.y<Mod->VCellList[i].Pos.y+10/Resolution)){
				C=i;
				break;
			}
		}
		if(C>=0) {
			if((Mod->VCellList[C].Select>=0x10)&(Mod->VCellList[C].Select<=0x1f)){
				InputMachin Im; Im.IM = &Mod->Input;
				Im.DoModal();
			}
			if((Mod->VCellList[C].Select>=0x20)&(Mod->VCellList[C].Select<=0x2f)){
				Mod->IfModul.EditCondition(Mod);
			}
		}
	}


	if((Condition==3)|(Condition == 6)|(Condition == 10)) OnCreatorShape();
}

void CreatorView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	POINT P = (POINT)point; ::ScreenToClient(this->m_hWnd,&P);
	
	Position RPoint = LPtoMOD((CPoint)P);
	if(SelectCell>=0) Mod->VCellList[SelectCell].Select&=0xf0;
	SelectCell = -1;
	for(int i=0; i<Mod->CurrentCell; i++){
		if((RPoint.x>Mod->VCellList[i].Pos.x-10/Resolution)&
		   (RPoint.x<Mod->VCellList[i].Pos.x+10/Resolution)&
		   (RPoint.y>Mod->VCellList[i].Pos.y-10/Resolution)&
		   (RPoint.y<Mod->VCellList[i].Pos.y+10/Resolution)){
			SelectCell=i;
			break;
		}
	}
	if(SelectCell>=0) {
		Mod->VCellList[SelectCell].Select|=1;
		ReDraw=true; Invalidate(false);
	}
	CMenu menu;
	menu.LoadMenu(IDR_CREATOR_M);
	menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON, point.x, point.y, this);   
}


/*===========================================================================================*/
Position CreatorView::LPtoMOD(CPoint point)
{
	return(	Position(CurrentPoint.x+(2*point.x-CurSize.cx)/(2*Resolution),
					 CurrentPoint.y+(2*point.y-CurSize.cy)/(2*Resolution)));
}

CPoint CreatorView::MODtoLP(Position point)
{
	return(
		CPoint((point.x - CurrentPoint.x) * Resolution + CurSize.cx/2,
			   (point.y - CurrentPoint.y) * Resolution + CurSize.cy/2));
}


void CreatorView::DrawSynapse(CDC &dc, int &From, int &To, int Select)
{
	if(Mod->ConMap[From][To].Current == 0) return;//???
	Position Res;
	CPen	SynPen(PS_SOLID,(Resolution<1)?1:Resolution, Synapse_N); 
	CBrush	SynBrs(Synapse_N);
	CPen	SynPenA(PS_SOLID,(Resolution<1)?1:Resolution, Synapse_A); 
	CBrush	SynBrsA(Synapse_A);

	double Kx=((double)Mod->VCellList[From].Pos.y - (double)Mod->VCellList[To].Pos.y)/
		      ((double)Mod->VCellList[From].Pos.x - (double)Mod->VCellList[To].Pos.x);
	double Ky=((double)Mod->VCellList[From].Pos.x - (double)Mod->VCellList[To].Pos.x)/
		      ((double)Mod->VCellList[From].Pos.y - (double)Mod->VCellList[To].Pos.y);
	const double R=10;
	double dx, dy;
	if((Mod->ConMap[From][To].Current == 1)&(Mod->ConMap[To][From].Current == 0)){
		dx = (Mod->VCellList[From].Pos.x > Mod->VCellList[To].Pos.x) ? 
							R/sqrt(1+Kx*Kx): -R/sqrt(1+Kx*Kx);
		dy = (Mod->VCellList[From].Pos.y > Mod->VCellList[To].Pos.y) ? 
							R/sqrt(1+Ky*Ky): -R/sqrt(1+Ky*Ky);
		Res.x=Mod->VCellList[To].Pos.x + (int)dx;		  
		Res.y=Mod->VCellList[To].Pos.y + (int)dy;		  
		Position Blo(Res.x-2,Res.y-2), Tlo(Res.x+2,Res.y+2);

		if((To == SelectCell)&(Mod->ConMap[From][To].List[0] == SelectLink)){
			dc.SelectObject(&SynPenA); dc.SelectObject(&SynBrsA);
		}
		else{
			dc.SelectObject(&SynPen); dc.SelectObject(&SynBrs);
		}
		dc.MoveTo(MODtoLP(Mod->VCellList[From].Pos));
		dc.LineTo(MODtoLP(Res));
		dc.Ellipse(MODtoLP(Tlo).x,MODtoLP(Tlo).y,MODtoLP(Blo).x,MODtoLP(Blo).y);
	}
	else if((Mod->ConMap[From][To].Current == 1)&(Mod->ConMap[To][From].Current >= 1)){
		dx = (Mod->VCellList[From].Pos.x > Mod->VCellList[To].Pos.x) ? 
							R/sqrt(1+Ky*Ky): -R/sqrt(1+Ky*Ky);
		dy = (Mod->VCellList[From].Pos.y > Mod->VCellList[To].Pos.y) ? 
							R/sqrt(1+Kx*Kx): -R/sqrt(1+Kx*Kx);
		Res.x=Mod->VCellList[To].Pos.x + (int)dx;		  
		Res.y=Mod->VCellList[To].Pos.y + (int)dy;		  
		Position Blo(Res.x-2,Res.y-2), Tlo(Res.x+2,Res.y+2);

		if((To == SelectCell)&(Mod->ConMap[From][To].List[0] == SelectLink)){
			dc.SelectObject(&SynPenA); dc.SelectObject(&SynBrsA);
		}
		else{
			dc.SelectObject(&SynPen); dc.SelectObject(&SynBrs);
		}
		dc.MoveTo(MODtoLP(Mod->VCellList[From].Pos));
		dc.LineTo(MODtoLP(Res));
		dc.Ellipse(MODtoLP(Tlo).x,MODtoLP(Tlo).y,MODtoLP(Blo).x,MODtoLP(Blo).y);
	}
	else if((Mod->ConMap[From][To].Current > 1)&(Mod->ConMap[To][From].Current == 0)){
		for(int S=0; S<Mod->ConMap[From][To].Current; S++){
			dx = (Mod->VCellList[From].Pos.x > Mod->VCellList[To].Pos.x) ? 
								(S*4+R)/sqrt(1+Kx*Kx): -(S*4+R)/sqrt(1+Kx*Kx);
			dy = (Mod->VCellList[From].Pos.y > Mod->VCellList[To].Pos.y) ? 
								(S*4+R)/sqrt(1+Ky*Ky): -(S*4+R)/sqrt(1+Ky*Ky);
			Res.x=Mod->VCellList[To].Pos.x + (int)dx;		  
			Res.y=Mod->VCellList[To].Pos.y + (int)dy;		  
			Position Blo(Res.x-2,Res.y-2), Tlo(Res.x+2,Res.y+2);

			if((To == SelectCell)&(Mod->ConMap[From][To].List[S] == SelectLink)){
				dc.SelectObject(&SynPenA); dc.SelectObject(&SynBrsA);
			}
			else{
				dc.SelectObject(&SynPen); dc.SelectObject(&SynBrs);
			}
			dc.MoveTo(MODtoLP(Mod->VCellList[From].Pos));
			dc.LineTo(MODtoLP(Res));
			dc.Ellipse(MODtoLP(Tlo).x,MODtoLP(Tlo).y,MODtoLP(Blo).x,MODtoLP(Blo).y);
		}
	}
	else if((Mod->ConMap[From][To].Current > 1)&(Mod->ConMap[To][From].Current >=1)){
		for(int S=0; S<Mod->ConMap[From][To].Current; S++){
			dx = (Mod->VCellList[From].Pos.x > Mod->VCellList[To].Pos.x) ? 
								(S*4+R)/sqrt(1+Ky*Ky): -(S*4+R)/sqrt(1+Ky*Ky);
			dy = (Mod->VCellList[From].Pos.y > Mod->VCellList[To].Pos.y) ? 
								(S*4+R)/sqrt(1+Kx*Kx): -(S*4+R)/sqrt(1+Kx*Kx);
			Res.x=Mod->VCellList[To].Pos.x + (int)dx;		  
			Res.y=Mod->VCellList[To].Pos.y + (int)dy;		  
			Position Blo(Res.x-2,Res.y-2), Tlo(Res.x+2,Res.y+2);

			if((To == SelectCell)&(Mod->ConMap[From][To].List[S] == SelectLink)){
				dc.SelectObject(&SynPenA); dc.SelectObject(&SynBrsA);
			}
			else{
				dc.SelectObject(&SynPen); dc.SelectObject(&SynBrs);
			}
			dc.MoveTo(MODtoLP(Mod->VCellList[From].Pos));
			dc.LineTo(MODtoLP(Res));
			dc.Ellipse(MODtoLP(Tlo).x,MODtoLP(Tlo).y,MODtoLP(Blo).x,MODtoLP(Blo).y);
		}
	}

}

void CreatorView::DifProjection(bool Direction, int FromL, int ToL, DefaultData &DD)
{
	int *FromSet_i = new int[Mod->CurrentCell], *ToSet_i = new int[Mod->CurrentCell];
	int FromCount = 0, ToCount = 0;
	if(Direction){
		for(int c=0; c<Mod->CurrentCell; c++){
			if((Mod->VCellList[c].Select & 0x02) > 0) FromSet_i[FromCount++] = c;
			if((Mod->VCellList[c].Select & 0x01) > 0) ToSet_i[ToCount++] = c;
		}
	}
	else{
		for(int c=0; c<Mod->CurrentCell; c++){
			if((Mod->VCellList[c].Select & 0x01) > 0) FromSet_i[FromCount++] = c;
			if((Mod->VCellList[c].Select & 0x02) > 0) ToSet_i[ToCount++] = c;
		}
	}

	CellChoosen *FromSet = new CellChoosen[FromCount];
	float Step = (float)RAND_MAX/(float)(FromCount);
	for(int c = 0; c<FromCount; c++){
		FromSet[c].NCell = FromSet_i[c];
		if(c == 0) FromSet[c].L = 0;
		else FromSet[c].L = FromSet[c-1].R+1;
		FromSet[c].R =(int)((float)FromSet[c].L + Step);
		FromSet[c].Count = 0;
	}
	delete[] FromSet_i;

	CellChoosen *ToSet = new CellChoosen[ToCount];
	Step = (float)RAND_MAX/(float)(ToCount);
	for(c = 0; c<ToCount; c++){
		ToSet[c].NCell = ToSet_i[c];
		if(c == 0) ToSet[c].L = 0;
		else ToSet[c].L = ToSet[c-1].R+1;
		ToSet[c].R =(int)((float)ToSet[c].L + Step);
		ToSet[c].Count = 0;
	}
	delete[] ToSet_i;

	int FromMax = FromCount * FromL, ToMax = ToCount * ToL;
	int FromC = 0,  ToC = 0, Count=0;

	srand( (unsigned)time( NULL ) );
	while((FromC<=FromMax)&(ToC <= ToMax)&(Count <= FromL*ToL*10000)){
		int Rnd = rand();
		int Fp=-1, Tp = -1; 
		for(int c=0; c<FromCount; c++){
			if((FromSet[c].L<Rnd)&(FromSet[c].R>=Rnd)){Fp = c;break;}
		}
		Rnd = rand();
		for(c=0; c<ToCount; c++){
			if((ToSet[c].L<Rnd)&(ToSet[c].R>=Rnd)){Tp = c;break;}
		}
		if((Fp != Tp)&(Fp>=0)&(Tp>=0)&(Fp<FromCount)&(Tp<ToCount)){
			if((FromSet[Fp].Count < FromL) & (ToSet[Tp].Count < ToL)){
				unsigned RND = 0;
				int S = Mod->AddLink(FromSet[Fp].NCell, ToSet[Tp].NCell);

				if(DD.Cos_SD)
					Mod->CellList[ToSet[Tp].NCell].Syn[S].Delay= DD.Norm_SD;
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[ToSet[Tp].NCell].Syn[S].Delay = 
						DD.Min_SD+RND*(DD.Max_SD - DD.Min_SD)/0xffffffff;
				}
				RND = (((rand()<<15)|rand())<<2)^rand();
				if(DD.Cos_SS)
					Mod->CellList[ToSet[Tp].NCell].Syn[S].SingleWeight= DD.Norm_SS;
				else{
					Mod->CellList[ToSet[Tp].NCell].Syn[S].SingleWeight = 
						DD.Min_SS+RND*(DD.Max_SS - DD.Min_SS)/0xffffffff;
				}
				if(DD.Cos_SMin)
					Mod->CellList[ToSet[Tp].NCell].Syn[S].MinWeight= DD.Norm_SMin;
				else{
					Mod->CellList[ToSet[Tp].NCell].Syn[S].MinWeight = 
						DD.Min_SMin+RND*(DD.Max_SMin - DD.Min_SMin)/0xffffffff;
				}
				if(DD.Cos_SMax)
					Mod->CellList[ToSet[Tp].NCell].Syn[S].MaxWeight= DD.Norm_SMax;
				else{
					Mod->CellList[ToSet[Tp].NCell].Syn[S].MaxWeight = 
						DD.Min_SMax+RND*(DD.Max_SMax - DD.Min_SMax)/0xffffffff;
				}
				RND = (((rand()<<15)|rand())<<2)^rand();
				if(DD.Cos_SR)
					Mod->CellList[ToSet[Tp].NCell].Syn[S].RisingTime= DD.Norm_SR;
				else{
					Mod->CellList[ToSet[Tp].NCell].Syn[S].RisingTime = 
						DD.Min_SR+RND*(DD.Max_SR - DD.Min_SR)/0xffffffff;
				}
				if(DD.Cos_SF)
					Mod->CellList[ToSet[Tp].NCell].Syn[S].FallingTime= DD.Norm_SF;
				else{
					Mod->CellList[ToSet[Tp].NCell].Syn[S].FallingTime = 
						DD.Min_SF+RND*(DD.Max_SF - DD.Min_SF)/0xffffffff;
				}
				if(DD.Cos_L) {
					Mod->CellList[ToSet[Tp].NCell].Syn[S].LearnP= DD.Norm_LP;
					Mod->CellList[ToSet[Tp].NCell].Syn[S].LearnM= DD.Norm_LM;
				}
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[ToSet[Tp].NCell].Syn[S].LearnP = 
						DD.Min_LP+RND*(DD.Max_LP - DD.Min_LP)/0xffffffff;
					Mod->CellList[ToSet[Tp].NCell].Syn[S].LearnM = 
						DD.Min_LM+RND*(DD.Max_LM - DD.Min_LM)/0xffffffff;
				}

				FromSet[Fp].Count++; ToSet[Tp].Count++;
				FromC++; ToC++;
			}
		}
		Count++;
	}
}

void CreatorView::LocalProjection(bool Direction, int Rad,  int Vx, int Vy, 
								  int ToL, DefaultData &DD)
{
	int *FromSet_i = new int[Mod->CurrentCell];
	int FromCount = 0;
	for(int c=0; c<Mod->CurrentCell; c++){
		if((Mod->VCellList[c].Select & 0x01) > 0) FromSet_i[FromCount++] = c;
	}
	
	for(int Fp=0; Fp<FromCount; Fp++){
		for(int Tp=0; Tp<Mod->CurrentCell; Tp++){
			for(int Sp=0; Sp<ToL; Sp++){
				unsigned RND = 0;
				int S,N;
				if(sqrt((Mod->VCellList[FromSet_i[Fp]].Pos.x-Mod->VCellList[Tp].Pos.x+Vx)*
					(Mod->VCellList[FromSet_i[Fp]].Pos.x-Mod->VCellList[Tp].Pos.x+Vx)+
					(Mod->VCellList[FromSet_i[Fp]].Pos.y-Mod->VCellList[Tp].Pos.y+Vy)*
					(Mod->VCellList[FromSet_i[Fp]].Pos.y-Mod->VCellList[Tp].Pos.y+Vy))>=Rad)
					break;
				if(FromSet_i[Fp] == ToL) break;
				if(Direction){
					if(Mod->VCellList[N = FromSet_i[Fp]].Select>0x0f) break;
					if((Mod->VCellList[Tp].Select & 0x01)>0) break;
					S = Mod->AddLink(Tp, N);
				}
				else{
					if(Mod->VCellList[N = Tp].Select>0x0f) break;
					if((Mod->VCellList[N].Select & 0x01)>0) break;
					S = Mod->AddLink(FromSet_i[Fp], N);
				}

				if(Mod->VCellList[N].Select>0x0f) break;
				if(DD.Cos_SD) Mod->CellList[N].Syn[S].Delay= DD.Norm_SD;
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[N].Syn[S].Delay = 
						DD.Min_SD+RND*(DD.Max_SD - DD.Min_SD)/0xffffffff;
				}
				RND = (((rand()<<15)|rand())<<2)^rand();
				if(DD.Cos_SS) Mod->CellList[N].Syn[S].SingleWeight= DD.Norm_SS;
				else{
					Mod->CellList[N].Syn[S].SingleWeight = 
						DD.Min_SS+RND*(DD.Max_SS - DD.Min_SS)/0xffffffff;
				}
				if(DD.Cos_SMin) Mod->CellList[N].Syn[S].MinWeight= DD.Norm_SMin;
				else{
					Mod->CellList[N].Syn[S].MinWeight = 
						DD.Min_SMin+RND*(DD.Max_SMin - DD.Min_SMin)/0xffffffff;
				}
				if(DD.Cos_SMax) Mod->CellList[N].Syn[S].MaxWeight= DD.Norm_SMax;
				else{
					Mod->CellList[N].Syn[S].MaxWeight = 
						DD.Min_SMax+RND*(DD.Max_SMax - DD.Min_SMax)/0xffffffff;
				}
				RND = (((rand()<<15)|rand())<<2)^rand();
				if(DD.Cos_SR) Mod->CellList[N].Syn[S].RisingTime= DD.Norm_SR;
				else{
					Mod->CellList[N].Syn[S].RisingTime = 
						DD.Min_SR+RND*(DD.Max_SR - DD.Min_SR)/0xffffffff;
				}
				if(DD.Cos_SF) Mod->CellList[N].Syn[S].FallingTime= DD.Norm_SF;
				else{
					Mod->CellList[N].Syn[S].FallingTime = 
						DD.Min_SF+RND*(DD.Max_SF - DD.Min_SF)/0xffffffff;
				}
				if(DD.Cos_L){
					Mod->CellList[N].Syn[S].LearnP= DD.Norm_LP;
					Mod->CellList[N].Syn[S].LearnM= DD.Norm_LM;
				}
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[N].Syn[S].LearnP = 
						DD.Min_LP+RND*(DD.Max_LP - DD.Min_LP)/0xffffffff;
					Mod->CellList[N].Syn[S].LearnM = 
						DD.Min_LM+RND*(DD.Max_LM - DD.Min_LM)/0xffffffff;
				}
			}
		}
	}
	delete[] FromSet_i;
}

void CreatorView::GLocalProjection(bool Direction, int Rad, int Vx, int Vy, 
								   int ToL, DefaultData &DD)
{
	int *FromSet_i = new int[Mod->CurrentCell];
	int FromCount = 0;
	for(int c=0; c<Mod->CurrentCell; c++){
		if((Mod->VCellList[c].Select & 0x01) > 0) FromSet_i[FromCount++] = c;
	}
	
	for(int Fp=0; Fp<FromCount; Fp++){
		for(int Tp=0; Tp<Mod->CurrentCell; Tp++){
			for(int Sp=0; Sp<ToL; Sp++){
				double RND = (double)sqrt(
					(Mod->VCellList[FromSet_i[Fp]].Pos.x-Mod->VCellList[Tp].Pos.x+Vx)*
					(Mod->VCellList[FromSet_i[Fp]].Pos.x-Mod->VCellList[Tp].Pos.x+Vx)+
					(Mod->VCellList[FromSet_i[Fp]].Pos.y-Mod->VCellList[Tp].Pos.y+Vy)*
					(Mod->VCellList[FromSet_i[Fp]].Pos.y-Mod->VCellList[Tp].Pos.y+Vy));
				int S,N;
				if(((int)RND>=Rad)|(FromSet_i[Fp] == ToL)) break;
				if(Direction){
					if(Mod->VCellList[N = FromSet_i[Fp]].Select>0x0f) break;
					if((Mod->VCellList[Tp].Select & 0x01)>0) break;
					S = Mod->AddLink(Tp, N);
				}
				else{
					if(Mod->VCellList[N = Tp].Select>0x0f) break;
					if((Mod->VCellList[N].Select & 0x01)>0) break;
					S = Mod->AddLink(FromSet_i[Fp], N);
				}

				RND = exp(-RND*RND*7.389056099/(double)(Rad*Rad));
				if(DD.Cos_SD) 
					Mod->CellList[N].Syn[S].Delay= DD.Norm_SD;
				else{
					Mod->CellList[N].Syn[S].Delay = 
						DD.Min_SD+RND*(DD.Max_SD - DD.Min_SD);
				}
				if(DD.Cos_SS) Mod->CellList[N].Syn[S].SingleWeight= DD.Norm_SS;
				else{
					Mod->CellList[N].Syn[S].SingleWeight = 
						DD.Min_SS+RND*(DD.Max_SS - DD.Min_SS);
				}
				if(DD.Cos_SMin) Mod->CellList[N].Syn[S].MinWeight= DD.Norm_SMin;
				else{
					Mod->CellList[N].Syn[S].MinWeight = 
						DD.Min_SMin+RND*(DD.Max_SMin - DD.Min_SMin);
				}
				if(DD.Cos_SMax) Mod->CellList[N].Syn[S].MaxWeight= DD.Norm_SMax;
				else{
					Mod->CellList[N].Syn[S].MaxWeight = 
						DD.Min_SMax+RND*(DD.Max_SMax - DD.Min_SMax);
				}
				if(DD.Cos_SR) Mod->CellList[N].Syn[S].RisingTime= DD.Norm_SR;
				else{
					Mod->CellList[N].Syn[S].RisingTime = 
						DD.Min_SR+RND*(DD.Max_SR - DD.Min_SR);
				}
				if(DD.Cos_SF) Mod->CellList[N].Syn[S].FallingTime= DD.Norm_SF;
				else{
					Mod->CellList[N].Syn[S].FallingTime = 
						DD.Min_SF+RND*(DD.Max_SF - DD.Min_SF);
				}
				if(DD.Cos_L){
					Mod->CellList[N].Syn[S].LearnP= DD.Norm_LP;
					Mod->CellList[N].Syn[S].LearnM= DD.Norm_LM;
				}
				else{
					Mod->CellList[N].Syn[S].LearnP = 
						DD.Min_LP+RND*(DD.Max_LP - DD.Min_LP);
					Mod->CellList[N].Syn[S].LearnM = 
						DD.Min_LM+RND*(DD.Max_LM - DD.Min_LM);
				}
			}
		}
	}
	delete[] FromSet_i;
}

void CreatorView::FanProjection(bool Direction, int Rad,DefaultData &DD)
{
	int FromXmin, FromXmax, FromYmin, FromYmax;
	int ToXmin, ToXmax, ToYmin, ToYmax;
	float PresX = 0.0f, PresY = 0.0f;
	FromXmin = ToXmin = MaxSize.cx;	FromXmax = ToXmax = 0;
	ToYmin = FromYmin = MaxSize.cy;	ToYmax = FromYmax = 0;
	for(int c=0; c<Mod->CurrentCell; c++){
		if((Mod->VCellList[c].Select&0xf) == 1){
			if(Mod->VCellList[c].Pos.x >FromXmax)
				FromXmax = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.x <FromXmin)
				FromXmin = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.y >FromYmax)
				FromYmax = Mod->VCellList[c].Pos.y;
			if(Mod->VCellList[c].Pos.y <FromYmin)
				FromYmin = Mod->VCellList[c].Pos.y;
		}
		if((Mod->VCellList[c].Select&0xf) == 2){
			if(Mod->VCellList[c].Pos.x >ToXmax)
				ToXmax = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.x <ToXmin)
				ToXmin = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.y >ToYmax)
				ToYmax = Mod->VCellList[c].Pos.y;
			if(Mod->VCellList[c].Pos.y <ToYmin)
				ToYmin = Mod->VCellList[c].Pos.y;
		}
	}
	PresX = ((float)ToXmax - (float)ToXmin)/((float)FromXmax - (float)FromXmin);
	PresY = ((float)ToYmax - (float)ToYmin)/((float)FromYmax - (float)FromYmin);

	for(int FC = 0; FC < Mod->CurrentCell; FC++){
		if((Mod->VCellList[FC].Select&0x0F) == 1){
			Position NewPos; 
			NewPos.x = ToXmin + (Mod->VCellList[FC].Pos.x - FromXmin)*PresX;
			NewPos.y = ToYmin + (Mod->VCellList[FC].Pos.y - FromYmin)*PresY;
			for(int TC=0; TC<Mod->CurrentCell; TC++){
				if(((Mod->VCellList[TC].Select&0x0F) == 2)&
					(sqrt((Mod->VCellList[TC].Pos.x-NewPos.x)*
					      (Mod->VCellList[TC].Pos.x-NewPos.x)+
						  (Mod->VCellList[TC].Pos.y-NewPos.y)*
						  (Mod->VCellList[TC].Pos.y-NewPos.y)) <= Rad)){
					unsigned RND = 0;
					int S,N;
					if(Direction)	S=Mod->AddLink(TC,N=FC);
					else			S=Mod->AddLink(FC,N=TC);

					if(Mod->VCellList[N].Select>0x0f) break;
					if(DD.Cos_SD) Mod->CellList[N].Syn[S].Delay= DD.Norm_SD;
					else{
						RND = (((rand()<<15)|rand())<<2)^rand();
						Mod->CellList[N].Syn[S].Delay = 
							DD.Min_SD+RND*(DD.Max_SD - DD.Min_SD)/0xffffffff;
					}
					RND = (((rand()<<15)|rand())<<2)^rand();
					if(DD.Cos_SS) Mod->CellList[N].Syn[S].SingleWeight= DD.Norm_SS;
					else{
						Mod->CellList[N].Syn[S].SingleWeight = 
							DD.Min_SS+RND*(DD.Max_SS - DD.Min_SS)/0xffffffff;
					}
					if(DD.Cos_SMin) Mod->CellList[N].Syn[S].MinWeight= DD.Norm_SMin;
					else{
						Mod->CellList[N].Syn[S].MinWeight = 
							DD.Min_SMin+RND*(DD.Max_SMin - DD.Min_SMin)/0xffffffff;
					}
					if(DD.Cos_SMax) Mod->CellList[N].Syn[S].MaxWeight= DD.Norm_SMax;
					else{
						Mod->CellList[N].Syn[S].MaxWeight = 
							DD.Min_SMax+RND*(DD.Max_SMax - DD.Min_SMax)/0xffffffff;
					}
					RND = (((rand()<<15)|rand())<<2)^rand();
					if(DD.Cos_SR) Mod->CellList[N].Syn[S].RisingTime= DD.Norm_SR;
					else{
						Mod->CellList[N].Syn[S].RisingTime = 
							DD.Min_SR+RND*(DD.Max_SR - DD.Min_SR)/0xffffffff;
					}
					if(DD.Cos_SF) Mod->CellList[N].Syn[S].FallingTime= DD.Norm_SF;
					else{
						Mod->CellList[N].Syn[S].FallingTime = 
							DD.Min_SF+RND*(DD.Max_SF - DD.Min_SF)/0xffffffff;
					}
					if(DD.Cos_L){
						Mod->CellList[N].Syn[S].LearnP= DD.Norm_LP;
						Mod->CellList[N].Syn[S].LearnM= DD.Norm_LM;
					}
					else{
						RND = (((rand()<<15)|rand())<<2)^rand();
						Mod->CellList[N].Syn[S].LearnP = 
							DD.Min_LP+RND*(DD.Max_LP - DD.Min_LP)/0xffffffff;
						Mod->CellList[N].Syn[S].LearnM = 
							DD.Min_LM+RND*(DD.Max_LM - DD.Min_LM)/0xffffffff;
					}
				}
			}
		}
	}
}

void CreatorView::GFanProjection(bool Direction, int Rad, DefaultData &DD)
{
	int FromXmin, FromXmax, FromYmin, FromYmax;
	int ToXmin, ToXmax, ToYmin, ToYmax;
	float PresX = 0.0f, PresY = 0.0f;
	FromXmin = ToXmin = MaxSize.cx;	FromXmax = ToXmax = 0;
	ToYmin = FromYmin = MaxSize.cy;	ToYmax = FromYmax = 0;
	for(int c=0; c<Mod->CurrentCell; c++){
		if((Mod->VCellList[c].Select&0xf) == 1){
			if(Mod->VCellList[c].Pos.x >FromXmax)
				FromXmax = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.x <FromXmin)
				FromXmin = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.y >FromYmax)
				FromYmax = Mod->VCellList[c].Pos.y;
			if(Mod->VCellList[c].Pos.y <FromYmin)
				FromYmin = Mod->VCellList[c].Pos.y;
		}
		if((Mod->VCellList[c].Select&0xf) == 2){
			if(Mod->VCellList[c].Pos.x >ToXmax)
				ToXmax = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.x <ToXmin)
				ToXmin = Mod->VCellList[c].Pos.x;
			if(Mod->VCellList[c].Pos.y >ToYmax)
				ToYmax = Mod->VCellList[c].Pos.y;
			if(Mod->VCellList[c].Pos.y <ToYmin)
				ToYmin = Mod->VCellList[c].Pos.y;
		}
	}
	PresX = ((float)ToXmax - (float)ToXmin)/((float)FromXmax - (float)FromXmin);
	PresY = ((float)ToYmax - (float)ToYmin)/((float)FromYmax - (float)FromYmin);

	for(int FC = 0; FC < Mod->CurrentCell; FC++){
		if((Mod->VCellList[FC].Select&0x0F) == 1){
			Position NewPos; 
			NewPos.x = (int)((float)ToXmin + ((float)Mod->VCellList[FC].Pos.x - (float)FromXmin)*PresX);
			NewPos.y = (int)((float)ToYmin + ((float)Mod->VCellList[FC].Pos.y - (float)FromYmin)*PresY);
			for(int TC=0; TC<Mod->CurrentCell; TC++){
				double RND= sqrt((Mod->VCellList[TC].Pos.x-NewPos.x)*
				                 (Mod->VCellList[TC].Pos.x-NewPos.x)+
					             (Mod->VCellList[TC].Pos.y-NewPos.y)*
					             (Mod->VCellList[TC].Pos.y-NewPos.y));
				if(((int)RND<=Rad)&(FC != TC)&((Mod->VCellList[TC].Select&0x0F) == 2)){
					int S,N;
					if(Direction)	S=Mod->AddLink(TC,N=FC);
					else			S=Mod->AddLink(FC,N=TC);

					RND = exp(-RND*RND*7.389056099/(double)(Rad*Rad));
					if(DD.Cos_SD) 
						Mod->CellList[N].Syn[S].Delay= DD.Norm_SD;
					else{
						Mod->CellList[N].Syn[S].Delay = 
							DD.Min_SD+RND*(DD.Max_SD - DD.Min_SD);
					}
					if(DD.Cos_SS) Mod->CellList[N].Syn[S].SingleWeight= DD.Norm_SS;
					else{
						Mod->CellList[N].Syn[S].SingleWeight = 
							DD.Min_SS+RND*(DD.Max_SS - DD.Min_SS);
					}
					if(DD.Cos_SMin) Mod->CellList[N].Syn[S].MinWeight= DD.Norm_SMin;
					else{
						Mod->CellList[N].Syn[S].MinWeight = 
							DD.Min_SMin+RND*(DD.Max_SMin - DD.Min_SMin);
					}
					if(DD.Cos_SMax) Mod->CellList[N].Syn[S].MaxWeight= DD.Norm_SMax;
					else{
						Mod->CellList[N].Syn[S].MaxWeight = 
							DD.Min_SMax+RND*(DD.Max_SMax - DD.Min_SMax);
					}
					if(DD.Cos_SR) Mod->CellList[N].Syn[S].RisingTime= DD.Norm_SR;
					else{
						Mod->CellList[N].Syn[S].RisingTime = 
							DD.Min_SR+RND*(DD.Max_SR - DD.Min_SR);
					}
					if(DD.Cos_SF) Mod->CellList[N].Syn[S].FallingTime= DD.Norm_SF;
					else{
						Mod->CellList[N].Syn[S].FallingTime = 
							DD.Min_SF+RND*(DD.Max_SF - DD.Min_SF);
					}
					if(DD.Cos_L){
						Mod->CellList[N].Syn[S].LearnP= DD.Norm_LP;
						Mod->CellList[N].Syn[S].LearnM= DD.Norm_LM;
					}
					else{
						Mod->CellList[N].Syn[S].LearnP = 
							DD.Min_LP+RND*(DD.Max_LP - DD.Min_LP);
						Mod->CellList[N].Syn[S].LearnM = 
							DD.Min_LM+RND*(DD.Max_LM - DD.Min_LM);
					}
				}
			}
		}
	}
}

/*===========================================================================================*/

void CreatorView::Save(CFile &File)
{
	File.Write(&MaxSize,sizeof(MaxSize));
	File.Write(&CurrentPoint,sizeof(CurrentPoint));
	File.Write(&InView,sizeof(InView));File.Write(&OutView,sizeof(OutView));
	File.Write(&NumberView,sizeof(NumberView));
	File.Write(&Cell_N,sizeof(Cell_N));
	File.Write(&Cell_A,sizeof(Cell_A));
	File.Write(&Cell_B,sizeof(Cell_B));
	File.Write(&Synapse_N,sizeof(Synapse_N));
	File.Write(&Synapse_A,sizeof(Synapse_A));
	File.Write(&Synapse_B,sizeof(Synapse_B));
	File.Write(&Input_N,sizeof(Input_N));
	File.Write(&Input_A,sizeof(Input_A));
	File.Write(&Input_B,sizeof(Input_B));
	File.Write(&SelectCell,4);File.Write(&SelectLink,4);
	File.Write(&Resolution,8);
}
void CreatorView::Load(CFile &File)
{
	File.Read(&MaxSize,sizeof(MaxSize));
	File.Read(&CurrentPoint,sizeof(CurrentPoint));
	File.Read(&InView,sizeof(InView));File.Read(&OutView,sizeof(OutView));
	File.Read(&NumberView,sizeof(NumberView));
	File.Read(&Cell_N,sizeof(Cell_N));
	File.Read(&Cell_A,sizeof(Cell_A));
	File.Read(&Cell_B,sizeof(Cell_B));
	File.Read(&Synapse_N,sizeof(Synapse_N));
	File.Read(&Synapse_A,sizeof(Synapse_A));
	File.Read(&Synapse_B,sizeof(Synapse_B));
	File.Read(&Input_N,sizeof(Input_N));
	File.Read(&Input_A,sizeof(Input_A));
	File.Read(&Input_B,sizeof(Input_B));
	File.Read(&SelectCell,4);File.Read(&SelectLink,4);
	File.Read(&Resolution,8);
	CellPro->SendMessage(WM_REVIEW,(WPARAM)SelectCell,SelectLink);
	ReDraw=true; Invalidate(false);
}

void CreatorView::OnCreatorTable() 
{
	CFileDialog FDlg(false,"xls","*.xls",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Text_Excel(*.xls)|*.xls|(*.*)|*.*||");
	if(FDlg.DoModal() != IDOK) return;
	CFile File; File.Open(FDlg.GetPathName(),CFile::modeCreate|CFile::modeWrite,NULL);
	char Out[200];
	File.Write(&Out,sprintf(Out, "Number of Neurons:\t%d\n",Mod->CurrentCell));
	for(int N=0; N<Mod->CurrentCell; N++){
		if(Mod->VCellList[N].Select<0x0f){
			File.Write(&Out,sprintf(Out,"Neuron:\t%d\n",N));
			File.Write(&Out,sprintf(Out,"  Capacity:\t%E\n",Mod->CellList[N].C));
			File.Write(&Out,sprintf(Out,"  Resistance:\t%E\n",
												Mod->CellList[N].RC/Mod->CellList[N].C));
			File.Write(&Out,sprintf(Out,"  RC:\t%f\n",
												Mod->CellList[N].RC));
			File.Write(&Out,sprintf(Out,"  Threshold:\t%f\n",
												Mod->CellList[N].Threshold));
			File.Write(&Out,sprintf(Out,"  Threshold Rising Time:\t%f\n",
												Mod->CellList[N].ThresholdPTime));
			File.Write(&Out,sprintf(Out,"  Threshold Falling Time:\t%f\n",
												Mod->CellList[N].ThresholdMTime));
			File.Write(&Out,sprintf(Out,"  Threshold Fire Time:\t%f\n",
												Mod->CellList[N].FireThresholdTime));
			File.Write(&Out,sprintf(Out,"  AP R:\t%E\n",Mod->CellList[N].APR));
			File.Write(&Out,sprintf(Out,"  AP C:\t%E\n",Mod->CellList[N].APC));
			File.Write(&Out,sprintf(Out,"  AP RC:\t%f\n",
				Mod->CellList[N].APC*
				(Mod->CellList[N].APR+Mod->CellList[N].RC/Mod->CellList[N].C)));
			File.Write(&Out,sprintf(Out,"  AP Single:\t%f\n",
												Mod->CellList[N].APSingPotential));
			File.Write(&Out,sprintf(Out,"  Number of Synapses:\t%d\n",
												Mod->CellList[N].CountSyn));
			for(int S=0; S<Mod->CellList[N].CountSyn; S++){
				File.Write(&Out,sprintf(Out,"   Synapse:\t%d\n",S));
				int From=-1;
				for(int F=0; F<Mod->CurrentCell; F++){
					if(Mod->ConMap[F][N].Current !=0){
						for(int I=0; I<Mod->ConMap[F][N].Current; I++){
							if(Mod->ConMap[F][N].List[I] == S){
								From = F;	break;
							}
						}
					}
					if(From>0) break;
				}
				File.Write(&Out,sprintf(Out,"    From:\t%d\n",From));
				File.Write(&Out,sprintf(Out,"    Delay:\t%f\n",Mod->CellList[N].Syn[S].Delay));
				File.Write(&Out,sprintf(Out,"    Max Weight:\t%E\n",
												Mod->CellList[N].Syn[S].MaxWeight));
				File.Write(&Out,sprintf(Out,"    Initial Weight:\t%E\n",
												Mod->CellList[N].Syn[S].SingleWeight));
				File.Write(&Out,sprintf(Out,"    Min Weight:\t%E\n",
												Mod->CellList[N].Syn[S].MinWeight));
				File.Write(&Out,sprintf(Out,"    Rising Time:\t%f\n",
												Mod->CellList[N].Syn[S].RisingTime));
				File.Write(&Out,sprintf(Out,"    Falling Time:\t%f\n",
												Mod->CellList[N].Syn[S].FallingTime));
				File.Write(&Out,sprintf(Out,"    Learn (Plus):\t%E\n",
												Mod->CellList[N].Syn[S].LearnP));
				File.Write(&Out,sprintf(Out,"    Learn (Minus):\t%E\n",
												Mod->CellList[N].Syn[S].LearnM));
			}
			File.Write(&Out,sprintf(Out,"\n"));
		}
		else
			File.Write(&Out,sprintf(Out,"Neuron: %d\t InputM %d\n",
												N,Mod->Input.GetNumberInput(N)));
	}
	File.Write(&Out,sprintf(Out,"\n\n"));
	File.Write(&Out,sprintf(Out,"==================Input Machine============\n"));
	File.Write(&Out,sprintf(Out,"All Levels:\t%d\n",Mod->Input.LevelCount));
	for(int L=0; L<Mod->Input.LevelCount; L++){
		File.Write(&Out,sprintf(Out,"Level:\t%d\n",L));
		File.Write(&Out,sprintf(Out,"  All Patterns:\t%d\n",Mod->Input.Levels[L].PaternCount));
		for(int P=0; P<Mod->Input.Levels[L].PaternCount; P++){
			File.Write(&Out,sprintf(Out,"    Pattern:\t%d\n",P));
			File.Write(&Out,sprintf(Out,"    Probability:\t%e\n",
								Mod->Input.Levels[L].Paterns[P].Probability));
			File.Write(&Out,sprintf(Out,"        All Events:\t%d\n",
								Mod->Input.Levels[L].Paterns[P].EventCount));
			for(int E=0; E<Mod->Input.Levels[L].Paterns[P].EventCount; E++){
				File.Write(&Out,sprintf(Out,"        Event:\t%d\n         Input:\t%d\n         Time:\t%f\n",
					E,
					Mod->Input.Levels[L].Paterns[P].Events[E].Input,
					Mod->Input.Levels[L].Paterns[P].Events[E].Time));
			}
		}
	}
	File.Close();
}

void CreatorView::OnCreatorUnselect()
{
	for(int c=0; c<Mod->CurrentCell; c++)
		Mod->VCellList[c].Select &= 0xf0;
	SelectCell = -1;
	ReDraw = true;
	Invalidate(false);
}

void CreatorView::OnCreatorSelectCh() 
{
	DefaultData DD = Mod->DD;
	DefauktSetter DS;
	DS.DD = &DD;
	if(DS.DoModal()!=IDOK) return;
	unsigned RND;
	for(int C=0; C<Mod->CurrentCell; C++){
		if((Mod->VCellList[C].Select&0x01) > 0){
			if(!DD.DC_RC){
				if(DD.Cos_RC) Mod->CellList[C].RC= DD.Norm_RC;
					else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[C].RC = 
						DD.Min_RC+RND*(DD.Max_RC - DD.Min_RC)/0xffffffff;
				}
			}
			if(!DD.DC_C){
				if(DD.Cos_C) Mod->CellList[C].C= DD.Norm_C;
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[C].C = 
						DD.Min_C+RND*(DD.Max_C - DD.Min_C)/0xffffffff;
				}
			}
			if(!DD.DC_TH){
				if(DD.Cos_TH) Mod->CellList[C].Threshold= DD.Norm_TH;
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[C].Threshold = 
						DD.Min_TH+RND*(DD.Max_TH - DD.Min_TH)/0xffffffff;
				}
			}
			RND = (((rand()<<15)|rand())<<2)^rand();
			if(!DD.DC_THTime){
				if(DD.Cos_THTime){ 
					Mod->CellList[C].ThresholdPTime= DD.Norm_THPTime;
					Mod->CellList[C].ThresholdMTime= DD.Norm_THMTime;
				}
				else{
					RND = (((rand()<<15)|rand())<<2)^rand();
					Mod->CellList[C].ThresholdPTime = 
						DD.Min_THPTime+RND*(DD.Max_THPTime - DD.Min_THPTime)/0xffffffff;
					Mod->CellList[C].ThresholdMTime = 
						DD.Min_THMTime+RND*(DD.Max_THMTime - DD.Min_THMTime)/0xffffffff;
				}
			}
			RND = (((rand()<<15)|rand())<<2)^rand();
			if(!DD.DC_APS){
				if(DD.Cos_APS) Mod->CellList[C].APSingPotential = DD.Norm_APS;
				else{
					Mod->CellList[C].APSingPotential = 
						DD.Min_APS+RND*(DD.Max_APS - DD.Min_APS)/0xffffffff;
				}
			}
			if(!DD.DC_APM){
				if(DD.Cos_APM) Mod->CellList[C].FireThresholdTime = DD.Norm_APM;
				else{
					Mod->CellList[C].FireThresholdTime = 
						DD.Min_APM+RND*(DD.Max_APM - DD.Min_APM)/0xffffffff;
				}
			}
			RND = (((rand()<<15)|rand())<<2)^rand();
			if(!DD.DC_APR){
				if(DD.Cos_APR) Mod->CellList[C].APR= DD.Norm_APR;
				else{
					Mod->CellList[C].APR = 
						DD.Min_APR+RND*(DD.Max_APR - DD.Min_APR)/0xffffffff;
				}
			}
			if(!DD.DC_APC){
				if(DD.Cos_APC) Mod->CellList[C].APC = DD.Norm_APC;
				else{
					Mod->CellList[C].APC = 
						DD.Min_APC+RND*(DD.Max_APC - DD.Min_APC)/0xffffffff;
				}
			}
		}
	}
	OnCreatorUnselect();
}


void CreatorView::OnCreatorShSyn() 
{
	DefaultData DD = Mod->DD;
	DefauktSetter DS;
	DS.DD = &DD;
	if(DS.DoModal()!=IDOK) return;
	unsigned RND;
	for(int C=0; C<Mod->CurrentCell; C++){
		if((Mod->VCellList[C].Select&0x01) > 0){
			for(int S= 0; S<Mod->CellList[C].CountSyn; S++){
				if(!DD.DC_SD){
					if(DD.Cos_SD) Mod->CellList[C].Syn[S].Delay= DD.Norm_SD;
					else{
						RND = (((rand()<<15)|rand())<<2)^rand();
						Mod->CellList[C].Syn[S].Delay = 
							DD.Min_SD+RND*(DD.Max_SD - DD.Min_SD)/0xffffffff;
					}
				}
				RND = (((rand()<<15)|rand())<<2)^rand();
				if(!DD.DC_SS){
					if(DD.Cos_SS) Mod->CellList[C].Syn[S].SingleWeight= DD.Norm_SS;
					else{
						Mod->CellList[C].Syn[S].SingleWeight = 
							DD.Min_SS+RND*(DD.Max_SS - DD.Min_SS)/0xffffffff;
					}
				}
				if(!DD.DC_SMin){
					if(DD.Cos_SMin) Mod->CellList[C].Syn[S].MinWeight= DD.Norm_SMin;
					else{
						Mod->CellList[C].Syn[S].MinWeight = 
							DD.Min_SMin+RND*(DD.Max_SMin - DD.Min_SMin)/0xffffffff;
					}
				}
				if(!DD.DC_SMax){
					if(DD.Cos_SMax) Mod->CellList[C].Syn[S].MaxWeight= DD.Norm_SMax;
					else{
					Mod->CellList[C].Syn[S].MaxWeight = 
							DD.Min_SMax+RND*(DD.Max_SMax - DD.Min_SMax)/0xffffffff;
					}
				}
				RND = (((rand()<<15)|rand())<<2)^rand();
				if(!DD.DC_SR){
					if(DD.Cos_SR) Mod->CellList[C].Syn[S].RisingTime= DD.Norm_SR;
					else{
						Mod->CellList[C].Syn[S].RisingTime = 
							DD.Min_SR+RND*(DD.Max_SR - DD.Min_SR)/0xffffffff;
					}
				}
				if(!DD.DC_SF){
					if(DD.Cos_SF) Mod->CellList[C].Syn[S].FallingTime= DD.Norm_SF;
					else{
						Mod->CellList[C].Syn[S].FallingTime = 
							DD.Min_SF+RND*(DD.Max_SF - DD.Min_SF)/0xffffffff;
					}
				}
				if(!DD.DC_L){
					if(DD.Cos_L){
						Mod->CellList[C].Syn[S].LearnP= DD.Norm_LP;
						Mod->CellList[C].Syn[S].LearnM= DD.Norm_LM;
					}
					else{
						RND = (((rand()<<15)|rand())<<2)^rand();
						Mod->CellList[C].Syn[S].LearnP = 
							DD.Min_LP+RND*(DD.Max_LP - DD.Min_LP)/0xffffffff;
						Mod->CellList[C].Syn[S].LearnM = 
							DD.Min_LM+RND*(DD.Max_LM - DD.Min_LM)/0xffffffff;
					}
				}
			}
		}
	}
	OnCreatorUnselect();
}

void CreatorView::OnCreatorNorm() 
{
	for(int c=0; c<Mod->CurrentCell; c++){
		if(((Mod->VCellList[c].Select&0x01)>0)&(Mod->VCellList[c].Select<0xf)){
			NormSetter NS; 
			NS.C = &(Mod->CellList[c]);
			NS.NCell = c;
			NS.DoModal();
		}
	}
}

void CreatorView::OnCreatorNormAuto() 
{
	int SC=-1;
	for(int c=0; c<Mod->CurrentCell; c++)
		if(((Mod->VCellList[c].Select&0x01)>0)&(Mod->VCellList[c].Select<0xf)){
			SC = c;
			break;
		}
	if(SC<0) return;

	Mod->VCellList[SC].Select&=0xff0;
	NormSetter NS;
	NS.Auto = true; NS.C = &Mod->CellList[SC]; NS.NCell = SC;
	if(NS.DoModal() != IDOK) return;
	for(c=SC+1; c<Mod->CurrentCell; c++){
		if(((Mod->VCellList[c].Select&0x01)>0)&(Mod->VCellList[c].Select<0xf)){
			NormSetter NSA; NSA.Auto = NSA.AutoStart = true;
			NSA = NS;
			NSA.C= &Mod->CellList[c]; NSA.NCell = c;
			if(NSA.m_To >= Mod->CellList[c].CountSyn)NSA.m_To = Mod->CellList[c].CountSyn - 1;
			if(NSA.m_From >= Mod->CellList[c].CountSyn)NSA.m_From = Mod->CellList[c].CountSyn - 1;
			NSA.DoModal();
			Mod->VCellList[c].Select&=0xff0;
		}
	}
	SelectCell = -1;
	ReDraw = true;
	Invalidate(false);
}

void CreatorView::OnUpdateCreatorNormAuto(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}


void CreatorView::OnCreatorPopStr() 
{
	if((SelectCount ==0)|(NSelectCell == NULL))return;
	if (Condition !=0x20){	OnCreatorCellEnd();		Condition = 0x20;	}
	else	OnCreatorCellEnd();
}

void CreatorView::OnUpdateCreatorPopStr(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck((int)(Condition == 0x20));}

void CreatorView::OnCreatorPushStr() 
{
	if((SelectCount !=0)|(NSelectCell != NULL)){
		delete[] NSelectCell; SelectCount=0;
	}
	for(int c=0; c<Mod->CurrentCell; c++)
		if((Mod->VCellList[c].Select&0x01)>0) SelectCount++;

	NSelectCell = new int[SelectCount];
	int sc = 0;
	for( c=0; c<Mod->CurrentCell; c++)
		if((Mod->VCellList[c].Select&0x01)>0){
			NSelectCell[sc++] = c;
			Mod->VCellList[c].Select &= 0xff0;
		}

}
void CreatorView::OnEditCopy() 
{OnCreatorPushStr();}

void CreatorView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
//	pCmdUI->Enable((SelectCount !=0)&(NSelectCell != NULL));
	
}

void CreatorView::OnEditPaste() 
{OnCreatorPopStr();}

void CreatorView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((SelectCount !=0)&(NSelectCell != NULL));
	pCmdUI->SetCheck((int)(Condition == 0x20));
}

void CreatorView::OnCreatorTableSelect() 
{
//	File.Write(&Out,sprintf(Out,"Neuron:\t%d\n",N));

	CFileDialog FDlg(false,"xls","*.xls",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Text_Excel(*.xls)|*.xls|(*.*)|*.*||");
	if(FDlg.DoModal() != IDOK) return;
	CFile File; File.Open(FDlg.GetPathName(),CFile::modeCreate|CFile::modeWrite,NULL);
	char Out[10000];
// N:
	File.Write(&Out,sprintf(Out,"N:"));
	for(int c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%d",c));
	}
	File.Write(&Out,sprintf(Out,"\t\n"));
// RC:
	File.Write(&Out,sprintf(Out,"RC:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].RC));
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
// C:
	File.Write(&Out,sprintf(Out,"C:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].C));
	}
	File.Write(&Out,sprintf(Out,"\tF.\n"));
	
// R:
	File.Write(&Out,sprintf(Out,"R:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].RC/Mod->CellList[c].C));
	}
	File.Write(&Out,sprintf(Out,"\tOm.\n"));
// Th:
	File.Write(&Out,sprintf(Out,"Th:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].Threshold));
	}
	File.Write(&Out,sprintf(Out,"\tVolt.\n"));
// ThP:
	File.Write(&Out,sprintf(Out,"ThP:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].ThresholdPTime));
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
// ThM:
	File.Write(&Out,sprintf(Out,"ThM:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].ThresholdMTime));
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
// ThFire:
	File.Write(&Out,sprintf(Out,"ThFire:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].FireThresholdTime));
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
// APS:
	File.Write(&Out,sprintf(Out,"APS:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].APSingPotential));
	}
	File.Write(&Out,sprintf(Out,"\tVolt.\n"));
// APC:
	File.Write(&Out,sprintf(Out,"APC:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].APC));
	}
	File.Write(&Out,sprintf(Out,"\tF.\n"));
// APR:
	File.Write(&Out,sprintf(Out,"APR:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",Mod->CellList[c].APR));
	}
	File.Write(&Out,sprintf(Out,"\tOm.\n"));
// APRC:
	File.Write(&Out,sprintf(Out,"APRC:"));
	for(c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select & 0x0f > 0)
			File.Write(&Out,sprintf(Out,"\t%E",
			Mod->CellList[c].APC*(Mod->CellList[c].APR+Mod->CellList[c].RC/Mod->CellList[c].C)));
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));

//Connections
	File.Write(&Out,sprintf(Out,"Connections at whole:\n"));
	double Aver;
//Delay:
	File.Write(&Out,sprintf(Out,"AverageTD:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].Delay;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//IW:
	File.Write(&Out,sprintf(Out,"AverageIW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].SingleWeight;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//MaxW:
	File.Write(&Out,sprintf(Out,"AverageMaxW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].MaxWeight;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//MinW:
	File.Write(&Out,sprintf(Out,"AverageMinW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].MinWeight;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//RTime:
	File.Write(&Out,sprintf(Out,"AverageRTime:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].RisingTime;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//FTime:
	File.Write(&Out,sprintf(Out,"AverageFTime:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].FallingTime;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//LP:
	File.Write(&Out,sprintf(Out,"AverageLP:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].LearnP;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\t___.\n"));
//LM:
	File.Write(&Out,sprintf(Out,"AverageLM:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				Aver+=Mod->CellList[c].Syn[s].LearnM;
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Mod->CellList[c].CountSyn));
		}
	}
	File.Write(&Out,sprintf(Out,"\t___.\n"));

//Inhibitory
	File.Write(&Out,sprintf(Out,"Inhibit Connections:\n"));
	int Count = 0;
//Delay:
	File.Write(&Out,sprintf(Out,"AverageTD:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].Delay;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//IW:
	File.Write(&Out,sprintf(Out,"AverageIW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].SingleWeight;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//MaxW:
	File.Write(&Out,sprintf(Out,"AverageMaxW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].MaxWeight;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//MinW:
	File.Write(&Out,sprintf(Out,"AverageMinW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].MinWeight;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//RTime:
	File.Write(&Out,sprintf(Out,"AverageRTime:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].RisingTime;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//FTime:
	File.Write(&Out,sprintf(Out,"AverageFTime:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].FallingTime;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//LP:
	File.Write(&Out,sprintf(Out,"AverageLP:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].LearnP;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\t___.\n"));
//LM:
	File.Write(&Out,sprintf(Out,"AverageLM:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight <0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].LearnM;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\t___.\n"));

//Excite Connections
	File.Write(&Out,sprintf(Out,"Excite Connections:\n"));
//Delay:
	File.Write(&Out,sprintf(Out,"AverageTD:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].Delay;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//IW:
	File.Write(&Out,sprintf(Out,"AverageIW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].SingleWeight;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//MaxW:
	File.Write(&Out,sprintf(Out,"AverageMaxW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].MaxWeight;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//MinW:
	File.Write(&Out,sprintf(Out,"AverageMinW:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].MinWeight;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tAmp.\n"));
//RTime:
	File.Write(&Out,sprintf(Out,"AverageRTime:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].RisingTime;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//FTime:
	File.Write(&Out,sprintf(Out,"AverageFTime:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].FallingTime;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\tsec.\n"));
//LP:
	File.Write(&Out,sprintf(Out,"AverageLP:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].LearnP;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\t___.\n"));
//LM:
	File.Write(&Out,sprintf(Out,"AverageLM:"));
	for(c=0; c<Mod->CurrentCell; c++){
		Aver = 0.0; Count = 0;
		if(Mod->VCellList[c].Select & 0x0f > 0){
			for(int s=0; s< Mod->CellList[c].CountSyn; s++) 
				if(Mod->CellList[c].Syn[s].SingleWeight > 0){
					Count++;
					Aver+=Mod->CellList[c].Syn[s].LearnM;
				}
			File.Write(&Out,sprintf(Out,"\t%E",Aver/Count));
		}
	}
	File.Write(&Out,sprintf(Out,"\t___.\n"));

	File.Close();
}

void CreatorView::OnFixedShift() 
{
	FixedShift = true;
	CellPro->SendMessage(WM_SHIFTLOCK,(WPARAM)FixedShift,0);
}

void CreatorView::OnUnfixedShift() 
{
	FixedShift = false;
	CellPro->SendMessage(WM_SHIFTLOCK,(WPARAM)FixedShift,0);	
}
