/*==========================================================================================*/
/*																							*/
/*                                  by Ruben Tikidji - Hamburyan                            */
/*																							*/
/*==========================================================================================*/

#if !defined(AFX_CREATORVIEW_H__24CDC55D_37D3_11D5_85C6_5254AB1ABD30__INCLUDED_)
#define AFX_CREATORVIEW_H__24CDC55D_37D3_11D5_85C6_5254AB1ABD30__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct CellChoosen {
	int NCell,Count, L, R;
};

#include "Model.h"
#include "CellPropertyV.h"
/////////////////////////////////////////////////////////////////////////////
// CreatorView window

class CreatorView : public CWnd
{
// Construction
public:
	CreatorView();
// Attributes
public:
	Model *Mod;

// View Attributes
	CSize MaxSize, CurSize;
	double Resolution;
	CPoint CurrentPoint, CursorPoint;
	bool ReDraw;
	bool InView, OutView, NumberView;
	CBitmap Bmp;
	COLORREF Cell_N, Cell_A, Cell_B, Cell_C;
	COLORREF Synapse_N, Synapse_A, Synapse_B;
	COLORREF Input_N, Input_A, Input_B, Input_C;
	COLORREF UserColor[10];
	CStatusBar  *m_StatusBar;
	bool FixedShift;

//Condition of Creator
	int Condition;

//Cell Property
	CellPropertyView *CellPro;
	int SelectCell;
	int SelectLink;

//Clipboard
	int SelectCount;
	int *NSelectCell;

// Operations
public:
	void DrawView();
	virtual void Save(CFile &File);
	virtual void Load(CFile &File);

protected:
	Position LPtoMOD(CPoint p);
	CPoint MODtoLP(Position p);
	void DrawSynapse(CDC &dc, int &From, int &To, int Select);
	void DifProjection(bool Direction, int FromL, int ToL, DefaultData &DD);
	void LocalProjection(bool Direction, int Rad, int Vx, int Vy, int ToL, DefaultData &DD);
	void GLocalProjection(bool Direction, int Rad, int Vx, int Vy, int ToL, DefaultData &DD);
	void FanProjection(bool Direction, int Rad, DefaultData &DD);
	void GFanProjection(bool Direction, int Rad, DefaultData &DD);

	Position From_1, From_2, To_1, To_2, To_3;
	bool Reciproc, Gauss;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CreatorView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CreatorView();

	// Generated message map functions
protected:
	//{{AFX_MSG(CreatorView)
	afx_msg void OnReView(UINT wParam, LONG lParam);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnUpdateCreatorShape(CCmdUI* pCmdUI);
	afx_msg void OnCreatorShape();
	afx_msg void OnCreatorNewcell();
	afx_msg void OnUpdateCreatorNewcell(CCmdUI* pCmdUI);
	afx_msg void OnCreatorCellEnd();
	afx_msg void OnCreateNewlink();
	afx_msg void OnUpdateCreateNewlink(CCmdUI* pCmdUI);
	afx_msg void OnCreatorLinkView();
	afx_msg void OnUpdateCreatorLinkView(CCmdUI* pCmdUI);
	afx_msg void OnCreatorInput();
	afx_msg void OnUpdateCreatorInput(CCmdUI* pCmdUI);
	afx_msg void OnCreatorDeleteCell();
	afx_msg void OnCreatorDeleteInput();
	afx_msg void OnCreatorDeleteLink();
	afx_msg void OnCreatorTable();
	afx_msg void OnCreatorPorjectionDif();
	afx_msg void OnUpdateCreatorPorjectionDif(CCmdUI* pCmdUI);
	afx_msg void OnCreatorPorjectionRec();
	afx_msg void OnUpdateCreatorPorjectionRec(CCmdUI* pCmdUI);
	afx_msg void OnCreatorPorjectionGaus();
	afx_msg void OnUpdateCreatorPorjectionGaus(CCmdUI* pCmdUI);
	afx_msg void OnCreatorStatbloc();
	afx_msg void OnUpdateCreatorStatbloc(CCmdUI* pCmdUI);
	afx_msg void OnCreatorGauss();
	afx_msg void OnUpdateCreatorGauss(CCmdUI* pCmdUI);
	afx_msg void OnCreatorUnselect();
	afx_msg void OnCreatorSelectCh();
	afx_msg void OnCreatorShSyn();
	afx_msg void OnCreatorNorm();
	afx_msg void OnCreatorIf();
	afx_msg void OnUpdateCreatorIf(CCmdUI* pCmdUI);
	afx_msg void OnCreatorPopStr();
	afx_msg void OnUpdateCreatorPopStr(CCmdUI* pCmdUI);
	afx_msg void OnCreatorPushStr();
	afx_msg void OnCreatorTableSelect();
	afx_msg void OnFixedShift();
	afx_msg void OnUnfixedShift();
	afx_msg void OnCreatorFanprojection();
	afx_msg void OnUpdateCreatorFanprojection(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnCreatorNormAuto();
	afx_msg void OnUpdateCreatorNormAuto(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CREATORVIEW_H__24CDC55D_37D3_11D5_85C6_5254AB1ABD30__INCLUDED_)
