// DefauktSetter.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "DefauktSetter.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DefauktSetter dialog


DefauktSetter::DefauktSetter(CWnd* pParent /*=NULL*/)
	: CDialog(DefauktSetter::IDD, pParent)
{
	//{{AFX_DATA_INIT(DefauktSetter)
	m_Costant = 0.0;
	m_Max = 0.0;
	m_Min = 0.0;
	m_Nset = 0;
	//}}AFX_DATA_INIT
}


void DefauktSetter::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DefauktSetter)
	DDX_Text(pDX, IDC_DEFAULT_CONST, m_Costant);
	DDX_Text(pDX, IDC_DEFAULT_MAX, m_Max);
	DDX_Text(pDX, IDC_DEFAULT_MIN, m_Min);
	DDX_LBIndex(pDX, IDC_DEFAULT_SETTER, m_Nset);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DefauktSetter, CDialog)
	//{{AFX_MSG_MAP(DefauktSetter)
	ON_LBN_SELCHANGE(IDC_DEFAULT_SETTER, OnSelchangeDefaultSetter)
	ON_BN_CLICKED(IDC_DN_CHANGE, OnDnChange)
	ON_BN_CLICKED(IDC_DEFAULT_COSTANT, OnDefaultCostant)
	ON_BN_CLICKED(IDC_DEFUALT_SAVE, OnDefualtSave)
	ON_BN_CLICKED(IDC_DEFAULT_LOAD, OnDefaultLoad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DefauktSetter message handlers

void DefauktSetter::OnSelchangeDefaultSetter() 
{
	int Pointer = m_Nset;
	UpdateData(true);

	switch(Pointer){
	case 0:
		DD->Norm_RC = m_Costant;	DD->Max_RC = m_Max;	DD->Min_RC = m_Min;	break;
	case 1:
		DD->Norm_C = m_Costant;		DD->Max_C = m_Max;	DD->Min_C = m_Min;	break;
	case 2:
		DD->Norm_TH = m_Costant;	DD->Max_TH = m_Max; DD->Min_TH = m_Min;	break;
	case 3:
		DD->Norm_THPTime = m_Costant;
		DD->Max_THPTime = m_Max; DD->Min_THPTime = m_Min;	break;
	case 4:
		DD->Norm_THMTime = m_Costant;
		DD->Max_THMTime = m_Max; DD->Min_THMTime = m_Min;	break;
	case 6:
		DD->Norm_APS = m_Costant;	DD->Max_APS = m_Max;	DD->Min_APS = m_Min;	break;
	case 5:
		DD->Norm_APM = m_Costant;	DD->Max_APM = m_Max;	DD->Min_APM = m_Min;	break;
	case 7:
		DD->Norm_APR = m_Costant;	DD->Max_APR = m_Max;	DD->Min_APR = m_Min;	break;
	case 8:
		DD->Norm_APC = m_Costant;	DD->Max_APC = m_Max;	DD->Min_APC = m_Min;	break;
	case 9:
		DD->Norm_SD = m_Costant;	DD->Max_SD = m_Max;		DD->Min_SD = m_Min;		break;
	case 10:
		DD->Norm_SS = m_Costant;	DD->Max_SS = m_Max;		DD->Min_SS = m_Min;		break;
	case 11:
		DD->Norm_SMin = m_Costant;	DD->Max_SMin = m_Max;	DD->Min_SMin = m_Min;	break;
	case 12:
		DD->Norm_SMax = m_Costant;	DD->Max_SMax = m_Max;	DD->Min_SMax = m_Min;	break;
	case 13:
		DD->Norm_SR = m_Costant;	DD->Max_SR = m_Max;		DD->Min_SR = m_Min;		break;
	case 14:
		DD->Norm_SF = m_Costant;	DD->Max_SF = m_Max;		DD->Min_SF = m_Min;		break;
	case 15:
		DD->Norm_LP = m_Costant;		DD->Max_LP = m_Max;		DD->Min_LP = m_Min;		break;
	case 16:
		DD->Norm_LM = m_Costant;		DD->Max_LM = m_Max;		DD->Min_LM = m_Min;		break;
	}

	switch(m_Nset){
	case 0:
		m_Costant = DD->Norm_RC;	m_Max = DD->Max_RC;	m_Min = DD->Min_RC;
		pDC->SetCheck((int)DD->DC_RC);
		pConst->SetCheck((int)DD->Cos_RC);	pConst->EnableWindow(!DD->DC_RC);
		pNorm->EnableWindow((!DD->DC_RC)&DD->Cos_RC);
		pMin->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
		pMax->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
		break;
	case 1:
		m_Costant = DD->Norm_C;		m_Max = DD->Max_C;	m_Min = DD->Min_C;
		pDC->SetCheck((int)DD->DC_C);
		pConst->SetCheck((int)DD->Cos_C);	pConst->EnableWindow(!DD->DC_C);
		pNorm->EnableWindow((!DD->DC_C)&DD->Cos_C);
		pMin->EnableWindow((!DD->DC_C)&(!DD->Cos_C));
		pMax->EnableWindow((!DD->DC_C)&(!DD->Cos_C));
		break;
	case 2:
		m_Costant = DD->Norm_TH;	m_Max = DD->Max_TH; m_Min = DD->Min_TH;
		pDC->SetCheck((int)DD->DC_TH);
		pConst->SetCheck((int)DD->Cos_TH);	pConst->EnableWindow(!DD->DC_TH);
		pNorm->EnableWindow((!DD->DC_TH)&DD->Cos_TH);
		pMin->EnableWindow((!DD->DC_TH)&(!DD->Cos_TH));
		pMax->EnableWindow((!DD->DC_TH)&(!DD->Cos_TH));
		break;
	case 3:
		m_Costant = DD->Norm_THPTime;m_Max = DD->Max_THPTime; m_Min = DD->Min_THPTime;
		pDC->SetCheck((int)DD->DC_THTime);
		pConst->SetCheck((int)DD->Cos_THTime);	pConst->EnableWindow(!DD->DC_THTime);
		pNorm->EnableWindow((!DD->DC_THTime)&DD->Cos_THTime);
		pMin->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		pMax->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		break;
	case 4:
		m_Costant = DD->Norm_THMTime;m_Max = DD->Max_THMTime; m_Min = DD->Min_THMTime;
		pDC->SetCheck((int)DD->DC_THTime);
		pConst->SetCheck((int)DD->Cos_THTime);	pConst->EnableWindow(!DD->DC_THTime);
		pNorm->EnableWindow((!DD->DC_THTime)&DD->Cos_THTime);
		pMin->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		pMax->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		break;
	case 6:
		m_Costant = DD->Norm_APS;	m_Max = DD->Max_APS;	m_Min = DD->Min_APS;
		pDC->SetCheck((int)DD->DC_APS);
		pConst->SetCheck((int)DD->Cos_APS);	pConst->EnableWindow(!DD->DC_APS);
		pNorm->EnableWindow((!DD->DC_APS)&DD->Cos_APS);
		pMin->EnableWindow((!DD->DC_APS)&(!DD->Cos_APS));
		pMax->EnableWindow((!DD->DC_APS)&(!DD->Cos_APS));
		break;
	case 5:
		m_Costant = DD->Norm_APM;	m_Max = DD->Max_APM;	m_Min = DD->Min_APM;
		pDC->SetCheck((int)DD->DC_APM);
		pConst->SetCheck((int)DD->Cos_APM);	pConst->EnableWindow(!DD->DC_APM);
		pNorm->EnableWindow((!DD->DC_APM)&DD->Cos_APM);
		pMin->EnableWindow((!DD->DC_APM)&(!DD->Cos_APM));
		pMax->EnableWindow((!DD->DC_APM)&(!DD->Cos_APM));
		break;
	case 7:
		m_Costant = DD->Norm_APR;	m_Max = DD->Max_APR;	m_Min = DD->Min_APR;
		pDC->SetCheck((int)DD->DC_APR);
		pConst->SetCheck((int)DD->Cos_APR);	pConst->EnableWindow(!DD->DC_APR);
		pNorm->EnableWindow((!DD->DC_APR)&DD->Cos_APR);
		pMin->EnableWindow((!DD->DC_APR)&(!DD->Cos_APR));
		pMax->EnableWindow((!DD->DC_APR)&(!DD->Cos_APR));
		break;
	case 8:
		m_Costant = DD->Norm_APC;	m_Max = DD->Max_APC;	m_Min = DD->Min_APC;
		pDC->SetCheck((int)DD->DC_APC);
		pConst->SetCheck((int)DD->Cos_APC);	pConst->EnableWindow(!DD->DC_APC);
		pNorm->EnableWindow((!DD->DC_APC)&DD->Cos_APC);
		pMin->EnableWindow((!DD->DC_APC)&(!DD->Cos_APC));
		pMax->EnableWindow((!DD->DC_APC)&(!DD->Cos_APC));
		break;
	case 9:
		m_Costant = DD->Norm_SD;	m_Max = DD->Max_SD;		m_Min = DD->Min_SD;
		pDC->SetCheck((int)DD->DC_SD);
		pConst->SetCheck((int)DD->Cos_SD);	pConst->EnableWindow(!DD->DC_SD);
		pNorm->EnableWindow((!DD->DC_SD)&DD->Cos_SD);
		pMin->EnableWindow((!DD->DC_SD)&(!DD->Cos_SD));
		pMax->EnableWindow((!DD->DC_SD)&(!DD->Cos_SD));
		break;
	case 10:
		m_Costant = DD->Norm_SS;	m_Max = DD->Max_SS;		m_Min = DD->Min_SS;
		pDC->SetCheck((int)DD->DC_SS);
		pConst->SetCheck((int)DD->Cos_SS);	pConst->EnableWindow(!DD->DC_SS);
		pNorm->EnableWindow((!DD->DC_SS)&DD->Cos_SS);
		pMin->EnableWindow((!DD->DC_SS)&(!DD->Cos_SS));
		pMax->EnableWindow((!DD->DC_SS)&(!DD->Cos_SS));
		break;
	case 11:
		m_Costant = DD->Norm_SMin;	m_Max = DD->Max_SMin;	m_Min = DD->Min_SMin;
		pDC->SetCheck((int)DD->DC_SMin);
		pConst->SetCheck((int)DD->Cos_SMin);	pConst->EnableWindow(!DD->DC_SMin);
		pNorm->EnableWindow((!DD->DC_SMin)&DD->Cos_SMin);
		pMin->EnableWindow((!DD->DC_SMin)&(!DD->Cos_SMin));
		pMax->EnableWindow((!DD->DC_SMin)&(!DD->Cos_SMin));
		break;
	case 12:
		m_Costant = DD->Norm_SMax;	m_Max = DD->Max_SMax;	m_Min = DD->Min_SMax;
		pDC->SetCheck((int)DD->DC_SMax);
		pConst->SetCheck((int)DD->Cos_SMax);	pConst->EnableWindow(!DD->DC_SMax);
		pNorm->EnableWindow((!DD->DC_SMax)&DD->Cos_SMax);
		pMin->EnableWindow((!DD->DC_SMax)&(!DD->Cos_SMax));
		pMax->EnableWindow((!DD->DC_SMax)&(!DD->Cos_SMax));
		break;
	case 13:
		m_Costant = DD->Norm_SR;	m_Max = DD->Max_SR;		m_Min = DD->Min_SR;
		pDC->SetCheck((int)DD->DC_SR);
		pConst->SetCheck((int)DD->Cos_SR);	pConst->EnableWindow(!DD->DC_SR);
		pNorm->EnableWindow((!DD->DC_SR)&DD->Cos_SR);
		pMin->EnableWindow((!DD->DC_SR)&(!DD->Cos_SR));
		pMax->EnableWindow((!DD->DC_SR)&(!DD->Cos_SR));
		break;
	case 14:
		m_Costant = DD->Norm_SF;	m_Max = DD->Max_SF;		m_Min = DD->Min_SF;
		pDC->SetCheck((int)DD->DC_SF);
		pConst->SetCheck((int)DD->Cos_SF);	pConst->EnableWindow(!DD->DC_SF);
		pNorm->EnableWindow((!DD->DC_SF)&DD->Cos_SF);
		pMin->EnableWindow((!DD->DC_SF)&(!DD->Cos_SF));
		pMax->EnableWindow((!DD->DC_SF)&(!DD->Cos_SF));
		break;
	case 15:
		m_Costant = DD->Norm_LP;		m_Max = DD->Max_LP;		m_Min = DD->Min_LP;
		pDC->SetCheck((int)DD->DC_L);
		pConst->SetCheck((int)DD->Cos_L);	pConst->EnableWindow(!DD->DC_L);
		pNorm->EnableWindow((!DD->DC_L)&DD->Cos_L);
		pMin->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		pMax->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		break;
	case 16:
		m_Costant = DD->Norm_LM;		m_Max = DD->Max_LM;		m_Min = DD->Min_LM;
		pDC->SetCheck((int)DD->DC_L);
		pConst->SetCheck((int)DD->Cos_L);	pConst->EnableWindow(!DD->DC_L);
		pNorm->EnableWindow((!DD->DC_L)&DD->Cos_L);
		pMin->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		pMax->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		break;
	}
	UpdateData(false);
}

BOOL DefauktSetter::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CListBox* pLB = (CListBox*)GetDlgItem(IDC_DEFAULT_SETTER);
	pLB->InsertString(0,"Membrane Time RC (sec.)");
	pLB->InsertString(1,"Membrane Capacity C (F.)");
	pLB->InsertString(2,"Threshold Potential (V.)");
	pLB->InsertString(3,"Threshold Rising Time (sec.)");
	pLB->InsertString(4,"Threshold Falling Time (sec.)");
	pLB->InsertString(5,"Fire Threshold Time ()");
	pLB->InsertString(6,"After Polarization Single Amplitude (V.)");
	pLB->InsertString(7,"After Polarization Resistance (Om.)");
	pLB->InsertString(8,"After Polarization Capacitance (F.)");
	pLB->InsertString(9,"Synapse Delay Time (sec.)");
	pLB->InsertString(10,"Synapse Initial Injection (A.)");
	pLB->InsertString(11,"Synapse Minimal Injection (A.)");
	pLB->InsertString(12,"Synapse Maximal Injection (A.)");
	pLB->InsertString(13,"Synapse Injection Rising Time (sec.)");
	pLB->InsertString(14,"Synapse Injection Falling Time (sec.)");
	pLB->InsertString(15,"Synapse Learing Parameter (Plus Branch)");
	pLB->InsertString(16,"Synapse Learing Parameter (Minus Branch)");
	pDC = (CButton*)GetDlgItem(IDC_DN_CHANGE);
	pConst = (CButton*)GetDlgItem(IDC_DEFAULT_COSTANT);
	pNorm = (CEdit*)GetDlgItem(IDC_DEFAULT_CONST);
	pMin = (CEdit*)GetDlgItem(IDC_DEFAULT_MIN);
	pMax = (CEdit*)GetDlgItem(IDC_DEFAULT_MAX);
	pDC->SetCheck((int)DD->DC_RC);
	pConst->SetCheck((int)DD->Cos_RC);
	pConst->EnableWindow(!DD->DC_RC);
	pNorm->EnableWindow((!DD->DC_RC)&DD->Cos_RC);
	pMin->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
	pMax->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
	m_Costant = DD->Norm_RC;
	m_Min = DD->Min_RC;
	m_Max = DD->Max_RC;
	UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DefauktSetter::OnDnChange() 
{
	switch(m_Nset){
	case 0:
		DD->DC_RC = !DD->DC_RC;
		pDC->SetCheck((int)DD->DC_RC);
		pConst->SetCheck((int)DD->Cos_RC);	pConst->EnableWindow(!DD->DC_RC);
		pNorm->EnableWindow((!DD->DC_RC)&DD->Cos_RC);
		pMin->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
		pMax->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
		break;
	case 1:
		DD->DC_C = !DD->DC_C;
		pDC->SetCheck((int)DD->DC_C);
		pConst->SetCheck((int)DD->Cos_C);	pConst->EnableWindow(!DD->DC_C);
		pNorm->EnableWindow((!DD->DC_C)&DD->Cos_C);
		pMin->EnableWindow((!DD->DC_C)&(!DD->Cos_C));
		pMax->EnableWindow((!DD->DC_C)&(!DD->Cos_C));
		break;
	case 2:
		DD->DC_TH = !DD->DC_TH;
		pDC->SetCheck((int)DD->DC_TH);
		pConst->SetCheck((int)DD->Cos_TH);	pConst->EnableWindow(!DD->DC_TH);
		pNorm->EnableWindow((!DD->DC_TH)&DD->Cos_TH);
		pMin->EnableWindow((!DD->DC_TH)&(!DD->Cos_TH));
		pMax->EnableWindow((!DD->DC_TH)&(!DD->Cos_TH));
		break;
	case 3:
		DD->DC_THTime = !DD->DC_THTime;
		pDC->SetCheck((int)DD->DC_THTime);
		pConst->SetCheck((int)DD->Cos_THTime);	pConst->EnableWindow(!DD->DC_THTime);
		pNorm->EnableWindow((!DD->DC_THTime)&DD->Cos_THTime);
		pMin->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		pMax->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		break;
	case 4:
		DD->DC_THTime = !DD->DC_THTime;
		pDC->SetCheck((int)DD->DC_THTime);
		pConst->SetCheck((int)DD->Cos_THTime);	pConst->EnableWindow(!DD->DC_THTime);
		pNorm->EnableWindow((!DD->DC_THTime)&DD->Cos_THTime);
		pMin->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		pMax->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		break;
	case 6:
		DD->DC_APS = !DD->DC_APS;
		pDC->SetCheck((int)DD->DC_APS);
		pConst->SetCheck((int)DD->Cos_APS);	pConst->EnableWindow(!DD->DC_APS);
		pNorm->EnableWindow((!DD->DC_APS)&DD->Cos_APS);
		pMin->EnableWindow((!DD->DC_APS)&(!DD->Cos_APS));
		pMax->EnableWindow((!DD->DC_APS)&(!DD->Cos_APS));
		break;
	case 5:
		DD->DC_APM = !DD->DC_APM;
		pDC->SetCheck((int)DD->DC_APM);
		pConst->SetCheck((int)DD->Cos_APM);	pConst->EnableWindow(!DD->DC_APM);
		pNorm->EnableWindow((!DD->DC_APM)&DD->Cos_APM);
		pMin->EnableWindow((!DD->DC_APM)&(!DD->Cos_APM));
		pMax->EnableWindow((!DD->DC_APM)&(!DD->Cos_APM));
		break;
	case 7:
		DD->DC_APR = !DD->DC_APR;
		pDC->SetCheck((int)DD->DC_APR);
		pConst->SetCheck((int)DD->Cos_APR);	pConst->EnableWindow(!DD->DC_APR);
		pNorm->EnableWindow((!DD->DC_APR)&DD->Cos_APR);
		pMin->EnableWindow((!DD->DC_APR)&(!DD->Cos_APR));
		pMax->EnableWindow((!DD->DC_APR)&(!DD->Cos_APR));
		break;
	case 8:
		DD->DC_APC = !DD->DC_APC;
		pDC->SetCheck((int)DD->DC_APC);
		pConst->SetCheck((int)DD->Cos_APC);	pConst->EnableWindow(!DD->DC_APC);
		pNorm->EnableWindow((!DD->DC_APC)&DD->Cos_APC);
		pMin->EnableWindow((!DD->DC_APC)&(!DD->Cos_APC));
		pMax->EnableWindow((!DD->DC_APC)&(!DD->Cos_APC));
		break;
	case 9:
		DD->DC_SD = !DD->DC_SD;
		pDC->SetCheck((int)DD->DC_SD);
		pConst->SetCheck((int)DD->Cos_SD);	pConst->EnableWindow(!DD->DC_SD);
		pNorm->EnableWindow((!DD->DC_SD)&DD->Cos_SD);
		pMin->EnableWindow((!DD->DC_SD)&(!DD->Cos_SD));
		pMax->EnableWindow((!DD->DC_SD)&(!DD->Cos_SD));
		break;
	case 10:
		DD->DC_SS = !DD->DC_SS;
		pDC->SetCheck((int)DD->DC_SS);
		pConst->SetCheck((int)DD->Cos_SS);	pConst->EnableWindow(!DD->DC_SS);
		pNorm->EnableWindow((!DD->DC_SS)&DD->Cos_SS);
		pMin->EnableWindow((!DD->DC_SS)&(!DD->Cos_SS));
		pMax->EnableWindow((!DD->DC_SS)&(!DD->Cos_SS));
		break;
	case 11:
		DD->DC_SMin = !DD->DC_SMin;
		pDC->SetCheck((int)DD->DC_SMin);
		pConst->SetCheck((int)DD->Cos_SMin);	pConst->EnableWindow(!DD->DC_SMin);
		pNorm->EnableWindow((!DD->DC_SMin)&DD->Cos_SMin);
		pMin->EnableWindow((!DD->DC_SMin)&(!DD->Cos_SMin));
		pMax->EnableWindow((!DD->DC_SMin)&(!DD->Cos_SMin));
		break;
	case 12:
		DD->DC_SMax = !DD->DC_SMax;
		pDC->SetCheck((int)DD->DC_SMax);
		pConst->SetCheck((int)DD->Cos_SMax);	pConst->EnableWindow(!DD->DC_SMax);
		pNorm->EnableWindow((!DD->DC_SMax)&DD->Cos_SMax);
		pMin->EnableWindow((!DD->DC_SMax)&(!DD->Cos_SMax));
		pMax->EnableWindow((!DD->DC_SMax)&(!DD->Cos_SMax));
		break;
	case 13:
		DD->DC_SR = !DD->DC_SR;
		pDC->SetCheck((int)DD->DC_SR);
		pConst->SetCheck((int)DD->Cos_SR);	pConst->EnableWindow(!DD->DC_SR);
		pNorm->EnableWindow((!DD->DC_SR)&DD->Cos_SR);
		pMin->EnableWindow((!DD->DC_SR)&(!DD->Cos_SR));
		pMax->EnableWindow((!DD->DC_SR)&(!DD->Cos_SR));
		break;
	case 14:
		DD->DC_SF = !DD->DC_SF;
		pDC->SetCheck((int)DD->DC_SF);
		pConst->SetCheck((int)DD->Cos_SF);	pConst->EnableWindow(!DD->DC_SF);
		pNorm->EnableWindow((!DD->DC_SF)&DD->Cos_SF);
		pMin->EnableWindow((!DD->DC_SF)&(!DD->Cos_SF));
		pMax->EnableWindow((!DD->DC_SF)&(!DD->Cos_SF));
		break;
	case 15:
		DD->DC_L = !DD->DC_L;
		pDC->SetCheck((int)DD->DC_L);
		pConst->SetCheck((int)DD->Cos_L);	pConst->EnableWindow(!DD->DC_L);
		pNorm->EnableWindow((!DD->DC_L)&DD->Cos_L);
		pMin->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		pMax->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		break;
	case 16:
		DD->DC_L = !DD->DC_L;
		pDC->SetCheck((int)DD->DC_L);
		pConst->SetCheck((int)DD->Cos_L);	pConst->EnableWindow(!DD->DC_L);
		pNorm->EnableWindow((!DD->DC_L)&DD->Cos_L);
		pMin->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		pMax->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		break;
	}
}

void DefauktSetter::OnDefaultCostant() 
{
	switch(m_Nset){
	case 0:
		DD->Cos_RC = !DD->Cos_RC;
		pDC->SetCheck((int)DD->DC_RC);
		pConst->SetCheck((int)DD->Cos_RC);	pConst->EnableWindow(!DD->DC_RC);
		pNorm->EnableWindow((!DD->DC_RC)&DD->Cos_RC);
		pMin->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
		pMax->EnableWindow((!DD->DC_RC)&(!DD->Cos_RC));
		break;
	case 1:
		DD->Cos_C = !DD->Cos_C;
		pDC->SetCheck((int)DD->DC_C);
		pConst->SetCheck((int)DD->Cos_C);	pConst->EnableWindow(!DD->DC_C);
		pNorm->EnableWindow((!DD->DC_C)&DD->Cos_C);
		pMin->EnableWindow((!DD->DC_C)&(!DD->Cos_C));
		pMax->EnableWindow((!DD->DC_C)&(!DD->Cos_C));
		break;
	case 2:
		DD->Cos_TH = !DD->Cos_TH;
		pDC->SetCheck((int)DD->DC_TH);
		pConst->SetCheck((int)DD->Cos_TH);	pConst->EnableWindow(!DD->DC_TH);
		pNorm->EnableWindow((!DD->DC_TH)&DD->Cos_TH);
		pMin->EnableWindow((!DD->DC_TH)&(!DD->Cos_TH));
		pMax->EnableWindow((!DD->DC_TH)&(!DD->Cos_TH));
		break;
	case 3:
		DD->Cos_THTime = !DD->Cos_THTime;
		pDC->SetCheck((int)DD->DC_THTime);
		pConst->SetCheck((int)DD->Cos_THTime);	pConst->EnableWindow(!DD->DC_THTime);
		pNorm->EnableWindow((!DD->DC_THTime)&DD->Cos_THTime);
		pMin->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		pMax->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		break;
	case 4:
		DD->Cos_THTime = !DD->Cos_THTime;
		pDC->SetCheck((int)DD->DC_THTime);
		pConst->SetCheck((int)DD->Cos_THTime);	pConst->EnableWindow(!DD->DC_THTime);
		pNorm->EnableWindow((!DD->DC_THTime)&DD->Cos_THTime);
		pMin->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		pMax->EnableWindow((!DD->DC_THTime)&(!DD->Cos_THTime));
		break;
	case 6:
		DD->Cos_APS = !DD->Cos_APS;
		pDC->SetCheck((int)DD->DC_APS);
		pConst->SetCheck((int)DD->Cos_APS);	pConst->EnableWindow(!DD->DC_APS);
		pNorm->EnableWindow((!DD->DC_APS)&DD->Cos_APS);
		pMin->EnableWindow((!DD->DC_APS)&(!DD->Cos_APS));
		pMax->EnableWindow((!DD->DC_APS)&(!DD->Cos_APS));
		break;
	case 5:
		DD->Cos_APM = !DD->Cos_APM;
		pDC->SetCheck((int)DD->DC_APM);
		pConst->SetCheck((int)DD->Cos_APM);	pConst->EnableWindow(!DD->DC_APM);
		pNorm->EnableWindow((!DD->DC_APM)&DD->Cos_APM);
		pMin->EnableWindow((!DD->DC_APM)&(!DD->Cos_APM));
		pMax->EnableWindow((!DD->DC_APM)&(!DD->Cos_APM));
		break;
	case 7:
		DD->Cos_APR = !DD->Cos_APR;
		pDC->SetCheck((int)DD->DC_APR);
		pConst->SetCheck((int)DD->Cos_APR);	pConst->EnableWindow(!DD->DC_APR);
		pNorm->EnableWindow((!DD->DC_APR)&DD->Cos_APR);
		pMin->EnableWindow((!DD->DC_APR)&(!DD->Cos_APR));
		pMax->EnableWindow((!DD->DC_APR)&(!DD->Cos_APR));
		break;
	case 8:
		DD->Cos_APC = !DD->Cos_APC;
		pDC->SetCheck((int)DD->DC_APC);
		pConst->SetCheck((int)DD->Cos_APC);	pConst->EnableWindow(!DD->DC_APC);
		pNorm->EnableWindow((!DD->DC_APC)&DD->Cos_APC);
		pMin->EnableWindow((!DD->DC_APC)&(!DD->Cos_APC));
		pMax->EnableWindow((!DD->DC_APC)&(!DD->Cos_APC));
		break;
	case 9:
		DD->Cos_SD = !DD->Cos_SD;
		pDC->SetCheck((int)DD->DC_SD);
		pConst->SetCheck((int)DD->Cos_SD);	pConst->EnableWindow(!DD->DC_SD);
		pNorm->EnableWindow((!DD->DC_SD)&DD->Cos_SD);
		pMin->EnableWindow((!DD->DC_SD)&(!DD->Cos_SD));
		pMax->EnableWindow((!DD->DC_SD)&(!DD->Cos_SD));
		break;
	case 10:
		DD->Cos_SS = !DD->Cos_SS;
		pDC->SetCheck((int)DD->DC_SS);
		pConst->SetCheck((int)DD->Cos_SS);	pConst->EnableWindow(!DD->DC_SS);
		pNorm->EnableWindow((!DD->DC_SS)&DD->Cos_SS);
		pMin->EnableWindow((!DD->DC_SS)&(!DD->Cos_SS));
		pMax->EnableWindow((!DD->DC_SS)&(!DD->Cos_SS));
		break;
	case 11:
		DD->Cos_SMin = !DD->Cos_SMin;
		pDC->SetCheck((int)DD->DC_SMin);
		pConst->SetCheck((int)DD->Cos_SMin);	pConst->EnableWindow(!DD->DC_SMin);
		pNorm->EnableWindow((!DD->DC_SMin)&DD->Cos_SMin);
		pMin->EnableWindow((!DD->DC_SMin)&(!DD->Cos_SMin));
		pMax->EnableWindow((!DD->DC_SMin)&(!DD->Cos_SMin));
		break;
	case 12:
		DD->Cos_SMax = !DD->Cos_SMax;
		pDC->SetCheck((int)DD->DC_SMax);
		pConst->SetCheck((int)DD->Cos_SMax);	pConst->EnableWindow(!DD->DC_SMax);
		pNorm->EnableWindow((!DD->DC_SMax)&DD->Cos_SMax);
		pMin->EnableWindow((!DD->DC_SMax)&(!DD->Cos_SMax));
		pMax->EnableWindow((!DD->DC_SMax)&(!DD->Cos_SMax));
		break;
	case 13:
		DD->Cos_SR = !DD->Cos_SR;
		pDC->SetCheck((int)DD->DC_SR);
		pConst->SetCheck((int)DD->Cos_SR);	pConst->EnableWindow(!DD->DC_SR);
		pNorm->EnableWindow((!DD->DC_SR)&DD->Cos_SR);
		pMin->EnableWindow((!DD->DC_SR)&(!DD->Cos_SR));
		pMax->EnableWindow((!DD->DC_SR)&(!DD->Cos_SR));
		break;
	case 14:
		DD->Cos_SF = !DD->Cos_SF;
		pDC->SetCheck((int)DD->DC_SF);
		pConst->SetCheck((int)DD->Cos_SF);	pConst->EnableWindow(!DD->DC_SF);
		pNorm->EnableWindow((!DD->DC_SF)&DD->Cos_SF);
		pMin->EnableWindow((!DD->DC_SF)&(!DD->Cos_SF));
		pMax->EnableWindow((!DD->DC_SF)&(!DD->Cos_SF));
		break;
	case 15:
		DD->Cos_L = !DD->Cos_L;
		pDC->SetCheck((int)DD->DC_L);
		pConst->SetCheck((int)DD->Cos_L);	pConst->EnableWindow(!DD->DC_L);
		pNorm->EnableWindow((!DD->DC_L)&DD->Cos_L);
		pMin->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		pMax->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		break;
	case 16:
		DD->Cos_L = !DD->Cos_L;
		pDC->SetCheck((int)DD->DC_L);
		pConst->SetCheck((int)DD->Cos_L);	pConst->EnableWindow(!DD->DC_L);
		pNorm->EnableWindow((!DD->DC_L)&DD->Cos_L);
		pMin->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		pMax->EnableWindow((!DD->DC_L)&(!DD->Cos_L));
		break;
	}
}

void DefauktSetter::OnDefualtSave() 
{
	OnSelchangeDefaultSetter();
	CFile File;
	CString FileName;
	CFileDialog FDlg(false,"def","*.def",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Default Cell(*.def)|*.def|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open(FileName ,CFile::modeCreate | CFile::modeWrite,NULL);
		this->SetWindowText(FileName);
		File.Write(DD, sizeof(*DD));
		File.Close();
	}
}

void DefauktSetter::OnDefaultLoad() 
{
	CFile File;
	CString FileName;
	CFileDialog FDlg(true,"def","*.def",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Default Cell(*.def)|*.def|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open((LPCTSTR) FileName,CFile::modeRead,NULL);
		this->SetWindowText(FileName);
		File.Read(DD, sizeof(*DD));
		File.Close();
		m_Nset = -1;
		OnSelchangeDefaultSetter();	
	}
}

void DefauktSetter::OnOK() 
{
	OnSelchangeDefaultSetter();	
	CDialog::OnOK();
}
