// IfM.h: interface for the IfM class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IFM_H__A55BEB1C_96B9_402C_A3CB_B981CCA5C3D0__INCLUDED_)
#define AFX_IFM_H__A55BEB1C_96B9_402C_A3CB_B981CCA5C3D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Cell.h"

class ConditionConf : public CDialog
{
// Construction
public:
	ConditionConf(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(ConditionConf)
	enum { IDD = IDD_IFDIALOG };
	CString	*m_EditString;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ConditionConf)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ConditionConf)

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class Condition{
public:
	int NCell, *pNCell;
	int CellCount;
	int CellMax;
	char AND_OR_ADD;
	bool MORE_LESS;
	short Variable;		//0-Time; 1-Potentioal; 2-AP; 3-Th; 4-Firing; 5-Axon;
	float Value;

	Condition();
	~Condition();

	bool Calculate(void *M);
	int Interpret(char * String);
};

struct ConditionPointer{
	void *Condition;
	bool CON_BLOC;
	char Operation;		//&-AND |-OR ^-XOR !-NOT _-fail operation
};

class ConditionBloc{
public:
	ConditionPointer *pCondition;
	int ConditionCount;
	int ConditionMax;

	ConditionBloc();
	~ConditionBloc();

	bool Calculate(void *M);
	int Interpret(char * String);

protected:
	inline int AddCon();
};

struct IfDrive{
	float Rate, TimeOut, CT;
	int SpikeCount, SC;
	IfDrive() {
		this->Rate = 0.004f; this->TimeOut = 0.01f;
		this->SpikeCount = 4; this->CT = 0.0f; this->SC = 0;
	};
};
class IfM 
{
public:
	CString	m_String;
	ConditionConf CC;

	int *InputList, InputCount;
	ConditionBloc *Command;
	int *IfCommand;
	int CommandCounter, CommandMax;
	IfDrive *IfDriver;


public:
	IfM();
	virtual ~IfM();
	
	void Assemble(void *MDL);
	void Calculate(void *MDL);

	void EditCondition(void *MDL);

	int GetNumberInput(int NCell);
	int AddInput(int NCell);
	void DeleteInput(int NInput);

	void SaveIFMachine(CFile &File);
	void LoadIFMachine(CFile &File);

protected:
	inline void ErrorFlash(int NR);
	inline int AddCommand();
};

#endif // !defined(AFX_IFM_H__A55BEB1C_96B9_402C_A3CB_B981CCA5C3D0__INCLUDED_)

