// InputMachin.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "InputMachin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// InputMachin dialog


InputMachin::InputMachin(CWnd* pParent /*=NULL*/)
	: CDialog(InputMachin::IDD, pParent)
{
	//{{AFX_DATA_INIT(InputMachin)
	m_EIn = 0;
	m_ET = 0.0;
	m_PP = 0.0;
	//}}AFX_DATA_INIT
	IM = NULL;
	m_Lev = m_Pat = m_Eve = 0;
}


void InputMachin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(InputMachin)
	DDX_Text(pDX, IDC_EVENT_INPUT, m_EIn);
	DDX_Text(pDX, IDC_EVENT_TIME, m_ET);
	DDX_Text(pDX, IDC_PATERN_PROBABILITY, m_PP);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(InputMachin, CDialog)
	//{{AFX_MSG_MAP(InputMachin)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(IM_ADD_PATERN, OnAddPatern)
	ON_COMMAND(IM_ADD_LEVEL, OnAddLevel)
	ON_COMMAND(IM_ADD_EVENT, OnAddEvent)
	ON_NOTIFY(TVN_SELCHANGED, IDC_LEVEL, OnSelchangedLevel)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_COMMAND(IM_DELETE_EVENT, OnDeleteEvent)
	ON_COMMAND(IM_DELETE_LEVEL, OnDeleteLevel)
	ON_COMMAND(IM_DELETE_PATERN, OnDeletePatern)
	ON_BN_CLICKED(IDC_IMPORT, OnImport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// InputMachin message handlers

BOOL InputMachin::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ILst.Create(16,16,0,8,8);
	HICON Ico[3]; 
	Ico[0]=AfxGetApp()->LoadIcon(IDI_LEVEL);
	Ico[1]=AfxGetApp()->LoadIcon(IDI_PATERN);
	Ico[2]=AfxGetApp()->LoadIcon(IDI_EVENT);
	for(int i=0; i<3; i++) ILst.Add(Ico[i]);
	pTree = (CTreeCtrl*)GetDlgItem(IDC_LEVEL);
	pTree->SetImageList(&ILst,TVSIL_NORMAL);
	if(!UpD()){
		CString str("Error!");
		return FALSE;
	}
	if(IM->LevelCount !=0){
		if(IM->Levels[0].PaternCount !=0){
			m_PP = IM->Levels[0].Paterns[0].Probability;
			if(IM->Levels[0].Paterns[0].EventCount !=0){
				m_EIn = IM->Levels[0].Paterns[0].Events[0].Input ;
				m_ET = IM->Levels[0].Paterns[0].Events[0].Time;
			}
		}
	}
	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*) GetDlgItem(IDC_EVENT_INPUT_SPIN);
	pSpin->SetRange(0,IM->InputCount-1);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int InputMachin::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
	return CDialog::DoModal();
}

bool InputMachin::UpD()
{
	if(IM == NULL) return false;
	pTree->DeleteAllItems();

	if(IM->LevelCount == 0) return true;
	CString LName, PName, EName;
	HTREEITEM hLevel, hPatern;
	for(int L=0; L<IM->LevelCount; L++){
		LName.Format("Level_%d",L);
		hLevel = pTree->InsertItem(TVIF_SELECTEDIMAGE|TVIF_IMAGE|TVIF_TEXT|TVIF_PARAM,
								   LName,0,0,NULL,NULL,(L*0x1000000+0xffffff),
								   TVI_ROOT,TVI_LAST);
		if(IM->Levels[L].PaternCount !=0){
			for(int P=0; P<IM->Levels[L].PaternCount; P++){
				PName.Format("Patern_%d",P);
				hPatern=pTree->InsertItem(TVIF_SELECTEDIMAGE|TVIF_IMAGE|TVIF_TEXT|TVIF_PARAM,
										  PName,1,1,NULL,NULL,(L*0x1000000+P*0x10000+0xffff),
										  hLevel,TVI_LAST);
				if(IM->Levels[L].Paterns[P].EventCount !=0){
					for(int E=0; E<IM->Levels[L].Paterns[P].EventCount; E++){
						EName.Format("Event_%d",E);
						pTree->InsertItem(TVIF_SELECTEDIMAGE|TVIF_IMAGE|TVIF_TEXT|TVIF_PARAM,
										 EName,2,2,NULL,NULL,L*0x1000000+P*0x10000+E,
										 hPatern,TVI_LAST);
					}
				}
				pTree->Expand(hPatern,TVE_EXPAND);
			}
			pTree->Expand(hLevel,TVE_EXPAND);
		}
	}

	return true;
}

void InputMachin::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	menu.LoadMenu(IDR_CREATOR_M);
	menu.GetSubMenu(1)->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON, point.x, point.y, this);   
	
}

void InputMachin::OnAddPatern() 
{
	IM->AddPatern(m_Lev);
	UpD();
}

void InputMachin::OnAddLevel() 
{
	IM->AddLevel();UpD();
}

void InputMachin::OnAddEvent() 
{
	IM->AddEvent(m_Lev,m_Pat);UpD();
}

void InputMachin::OnSelchangedLevel(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	CString LName, PName, EName;
	if(pNMTreeView->itemNew.hItem != NULL){
		if(pNMTreeView->itemOld.hItem != NULL)UpdateData(true);
		if((IM->LevelCount !=0)&(m_Lev<IM->LevelCount)){
			if((IM->Levels[m_Lev].PaternCount!=0)&(m_Pat<IM->Levels[m_Lev].PaternCount)){
				IM->Levels[m_Lev].Paterns[m_Pat].Probability = m_PP;
					if((IM->Levels[m_Lev].Paterns[m_Pat].EventCount !=0)&
					   (m_Eve<IM->Levels[m_Lev].Paterns[m_Pat].EventCount)){
						IM->Levels[m_Lev].Paterns[m_Pat].Events[m_Eve].Input = m_EIn;
						IM->Levels[m_Lev].Paterns[m_Pat].Events[m_Eve].Time = m_ET;
					}
			}
		}

		m_Lev = (pNMTreeView->itemNew.lParam & 0xff000000)/0x1000000;
		m_Pat = (pNMTreeView->itemNew.lParam & 0x00ff0000)/0x0010000;
		m_Eve = (pNMTreeView->itemNew.lParam & 0x0000ffff);

		if((IM->LevelCount !=0)&(m_Lev<IM->LevelCount)){
			LName.Format("Level: %d",m_Lev); SetDlgItemText(IDC_LEVEL_VIEW,LName);
			if((IM->Levels[m_Lev].PaternCount!=0)&(m_Pat<IM->Levels[m_Lev].PaternCount)){
				PName.Format("Patern: %d",m_Pat);SetDlgItemText(IDC_PATERN_VIEW,PName);
				m_PP = IM->Levels[m_Lev].Paterns[m_Pat].Probability;
					if((IM->Levels[m_Lev].Paterns[m_Pat].EventCount !=0)&
					   (m_Eve<IM->Levels[m_Lev].Paterns[m_Pat].EventCount)){
						EName.Format("Event: %d",m_Pat);SetDlgItemText(IDC_EVENT_VIEW,EName);
						m_EIn=IM->Levels[m_Lev].Paterns[m_Pat].Events[m_Eve].Input;
						m_ET=IM->Levels[m_Lev].Paterns[m_Pat].Events[m_Eve].Time;
					}
			}
		}
		UpdateData(false);
	}
	*pResult = 0;
}

void InputMachin::OnSave() 
{
	CFile File; CString FileName;
	CFileDialog FDlg(false,"im","*.im",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"InputMachin(*.im)|*.im|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK)	FileName = FDlg.GetPathName();
	else return;
	File.Open((LPCTSTR) FileName,CFile::modeCreate | CFile::modeWrite,NULL);
	IM->ExportMachine(File);
	File.Write(&m_Lev,4);File.Write(&m_Pat,4);File.Write(&m_Eve,4);
	File.Write(&m_EIn,4);File.Write(&m_ET,4);File.Write(&m_PP,4);
	File.Close();
}

void InputMachin::OnLoad() 
{
	CFile File;
	CFileDialog FDlg(true,"im","*.im",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"InputMachin(*.im)|*.im|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		File.Open((LPCTSTR) FDlg.GetPathName(),CFile::modeRead,NULL);
		IM->ImportMachine(File);
		File.Read(&m_Lev,4);File.Read(&m_Pat,4);File.Read(&m_Eve,4);
		File.Read(&m_EIn,4);File.Read(&m_ET,4);File.Read(&m_PP,4);
		File.Close();
		UpD();
		UpdateData(false);
	}
}

void InputMachin::OnDeleteEvent() 
{	if(m_Eve<0xffff){IM->DeleteEvent(m_Lev,m_Pat,m_Eve);UpD();}	}

void InputMachin::OnDeleteLevel() 
{	IM->DeleteLevel(m_Lev);UpD();	}

void InputMachin::OnDeletePatern() 
{	if(m_Pat<0xff){IM->DeletePatern(m_Lev,m_Pat);UpD();}	}

void InputMachin::OnOK() 
{
	UpD();	
	CDialog::OnOK();
}

void InputMachin::OnImport() 
{
//	CFile File;CString
	CFileDialog FDlg(true,"txt","*.txt",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Text (*.txt)|*.txt|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		HANDLE hRecord = ::CreateFile(FDlg.GetFileName().GetBuffer(FDlg.GetFileName().GetLength()),
							GENERIC_READ, 0, NULL,
							OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hRecord == INVALID_HANDLE_VALUE)  return;

		HANDLE hMapRecord = ::CreateFileMapping(hRecord,NULL,PAGE_READONLY,0,0,NULL);
		int MaxFileSize = ::GetFileSize(hRecord,NULL);
		::CloseHandle(hRecord);

		if(hMapRecord == INVALID_HANDLE_VALUE) return;
		void *pStartData = ::MapViewOfFile(hMapRecord,FILE_MAP_READ,0,0,0);
		::CloseHandle(hMapRecord);
		if(pStartData == NULL) return;
		char *String = (char*)pStartData;
		IM->Interpret(String, MaxFileSize);
		::UnmapViewOfFile(pStartData);
		UpD();
		UpdateData(false);
	}
}
