#include "stdafx.h"
#include "NeuroCAD.h"
#include "MainFrm.h"
#include "Option.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_BLANKET_ZOOMIN, OnBlanketZoomin)
	ON_UPDATE_COMMAND_UI(ID_BLANKET_ZOOMIN, OnUpdateBlanketZoomin)
	ON_COMMAND(ID_BLANKET_ZOOMUOT, OnBlanketZoomuot)
	ON_COMMAND(ID_BLANKET_SIMULATE, OnBlanketSimulate)
	ON_COMMAND(ID_BLANKET_CREATOR, OnBlanketCreator)
	ON_UPDATE_COMMAND_UI(ID_BLANKET_CREATOR, OnUpdateBlanketCreator)
	ON_UPDATE_COMMAND_UI(ID_BLANKET_SIMULATE, OnUpdateBlanketSimulate)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_COMMAND(ID_BLANKET_VIEW_INTPUT, OnBlanketViewIntput)
	ON_UPDATE_COMMAND_UI(ID_BLANKET_VIEW_INTPUT, OnUpdateBlanketViewIntput)
	ON_COMMAND(ID_BLANKET_VIEW_NUMBER_INPUT, OnBlanketViewNumberInput)
	ON_UPDATE_COMMAND_UI(ID_BLANKET_VIEW_NUMBER_INPUT, OnUpdateBlanketViewNumberInput)
	ON_COMMAND(ID_BLANKET_VIEW_OUTPUT, OnBlanketViewOutput)
	ON_UPDATE_COMMAND_UI(ID_BLANKET_VIEW_OUTPUT, OnUpdateBlanketViewOutput)
	ON_WM_TIMER()
	ON_COMMAND(ID_MAIN_BACK, OnMainBack)
	ON_UPDATE_COMMAND_UI(ID_MAIN_BACK, OnUpdateMainBack)
	ON_COMMAND(ID_MAIN_Option, OnMAINOption)
	ON_COMMAND(ID_FILE_OPEN_OLD, OnFileOpenOld)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN_OLD, OnUpdateFileOpenOld)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	p_wndView = new CreatorView;
	((CreatorView*)p_wndView)->Mod = &Mod;
	CellProView = new CellPropertyFrm;
	CellProView->m_wndView.Modl = &Mod;
	if(CellProView->Create(NULL,"Cell Property",WS_CAPTION|WS_CLIPSIBLINGS)){
		CellProView->SetWindowPos(&wndTop,0,0,240,745,SWP_SHOWWINDOW);
		((CreatorView*)p_wndView)->CellPro = &(CellProView->m_wndView);
		CellProView->m_wndView.View = p_wndView;
	}
	Condition = false;
	FileName.Empty();
	BackFlg = false;
	BackCount = 0;
	BackSpeed = 5;
}

CMainFrame::~CMainFrame()
{
	delete p_wndView;
	delete CellProView;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!p_wndView->Create(NULL, "NeuroCAD-", AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	if (!LeftToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_LEFT
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!LeftToolBar.LoadToolBar(IDR_CREATOR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	((CreatorView*)p_wndView)->m_StatusBar = &m_wndStatusBar;
	
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	LeftToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&LeftToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	p_wndView->SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (p_wndView->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnBlanketZoomin() 
{
	if(Condition){
		((SimulatorView*)p_wndView)->Resolution *=2;
		((SimulatorView*)p_wndView)->DrawView();
	}
	else{
		((CreatorView*)p_wndView)->Resolution *=2;
		((CreatorView*)p_wndView)->DrawView();
	}
}

void CMainFrame::OnUpdateBlanketZoomin(CCmdUI* pCmdUI) 
{
	if(Condition){
		if((((SimulatorView*)p_wndView)->CurSize.cx/((SimulatorView*)p_wndView)->Resolution  > 50)&
		   (((SimulatorView*)p_wndView)->CurSize.cy/((SimulatorView*)p_wndView)->Resolution  > 50))
		pCmdUI->Enable(true);
		else pCmdUI->Enable(false);
	}
	else{
		if((((CreatorView*)p_wndView)->CurSize.cx/((CreatorView*)p_wndView)->Resolution  > 50)&
		   (((CreatorView*)p_wndView)->CurSize.cy/((CreatorView*)p_wndView)->Resolution  > 50))
		pCmdUI->Enable(true);
		else pCmdUI->Enable(false);
	}
}

void CMainFrame::OnBlanketZoomuot() 
{
	if(Condition){
		((SimulatorView*)p_wndView)->Resolution /=2;
		((SimulatorView*)p_wndView)->DrawView();
	}
	else{
		((CreatorView*)p_wndView)->Resolution /=2;
		((CreatorView*)p_wndView)->DrawView();
	}
}

void CMainFrame::OnBlanketSimulate() 
{
	Condition = true;	
	CellProView->ShowWindow(SW_HIDE);
	OnFileSave();
	
	Mod.Assemble();
	LeftToolBar.LoadToolBar(IDR_SIMULATOR);
	CWnd* New = (CWnd*) new SimulatorView(this);
	((SimulatorView*)New)->m_StatusBar = &m_wndStatusBar;
	p_wndView->DestroyWindow();
	((SimulatorView*)New)->CurrentPoint=((CreatorView*)p_wndView)->CurrentPoint;
	((SimulatorView*)New)->CurSize=((CreatorView*)p_wndView)->CurSize;
	((SimulatorView*)New)->InView=((CreatorView*)p_wndView)->InView;
	((SimulatorView*)New)->MaxSize=((CreatorView*)p_wndView)->MaxSize;
	((SimulatorView*)New)->NumberView=((CreatorView*)p_wndView)->NumberView;
	((SimulatorView*)New)->OutView=((CreatorView*)p_wndView)->OutView;
	((SimulatorView*)New)->Resolution=((CreatorView*)p_wndView)->Resolution;
	((SimulatorView*)New)->SelectCell=((CreatorView*)p_wndView)->SelectCell;
	((SimulatorView*)New)->SelectLink=((CreatorView*)p_wndView)->SelectLink;
	New->Create(NULL, "NeuroCAD-", AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL);	
	((SimulatorView*)New)->Mod = &Mod;
	delete p_wndView;
	p_wndView=New;

	p_wndView->ShowWindow(SW_SHOW);
	RecalcLayout();
}

void CMainFrame::OnBlanketCreator() 
{
	Condition = false;	
	LeftToolBar.LoadToolBar(IDR_CREATOR);
	CWnd* New = (CWnd*) new CreatorView();
	p_wndView->DestroyWindow();
	delete p_wndView;
	p_wndView=New;

	CFile File;
	File.Open((LPCTSTR) FileName,CFile::modeRead,NULL);
	Mod.LoadModel(File);

	

	CellProView->m_wndView.View = p_wndView;
	CellProView->ShowWindow(SW_SHOW);	
	((CreatorView*)p_wndView)->m_StatusBar = &m_wndStatusBar;
	((CreatorView*)p_wndView)->CellPro = &(CellProView->m_wndView);
	((CreatorView*)p_wndView)->Mod = &Mod;
	CString str("NeuroCAD - ["+FileName+"]");
	p_wndView->Create(NULL, str, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL);	
	((CreatorView*)p_wndView)->Load(File);
	p_wndView->ShowWindow(SW_SHOW);
	File.Close();
	RecalcLayout();

}

void CMainFrame::OnUpdateBlanketCreator(CCmdUI* pCmdUI) 
{	if(Condition)pCmdUI->SetCheck(0);	else pCmdUI->SetCheck(1);}

void CMainFrame::OnUpdateBlanketSimulate(CCmdUI* pCmdUI) 
{	if(Condition)pCmdUI->SetCheck(1);	else pCmdUI->SetCheck(0);}

void CMainFrame::OnFileSave() 
{
	if(BackFlg)
		OnTimer(1);
	CFile File;
	if(FileName.GetLength() == 0){
		CFileDialog FDlg(false,"ifm","*.ifm",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"NeuroModel(*.ifm)|*.ifm|(*.*)|*.*||");
		if(FDlg.DoModal() == IDOK){
			FileName = FDlg.GetPathName();
			CString str("NeuroCAD - ["+FileName+"]");
			this->SetWindowText(str);
		}
		else
			return;
	}
	File.Open((LPCTSTR) FileName,CFile::modeCreate | CFile::modeWrite,NULL);
	Mod.SaveModel(File);
	((CreatorView*)p_wndView)->Save(File);
	Mod.IfModul.SaveIFMachine(File);
	File.Close();
}

void CMainFrame::OnFileSaveAs() 
{
	CFile File;
	CFileDialog FDlg(false,"ifm","*.ifm",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"NeuroModel(*.ifm)|*.ifm|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		File.Open((LPCTSTR) FDlg.GetPathName(),CFile::modeCreate | CFile::modeWrite,NULL);
		Mod.SaveModel(File);
		((CreatorView*)p_wndView)->Save(File);
		Mod.IfModul.SaveIFMachine(File);
		File.Close();
	}
}

void CMainFrame::OnFileNew() 
{
	Mod.NewModel();
	p_wndView->SendMessage(WM_REVIEW,-1,-1);
}

void CMainFrame::OnFileOpen() 
{
	Condition = false;
	CFile File;
	CFileDialog FDlg(true,"ifm","*.ifm",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"NeuroModel(*.ifm)|*.ifm|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open((LPCTSTR) FileName,CFile::modeRead,NULL);
		CString str("NeuroCAD - ["+FileName+"]");
		this->SetWindowText(str);
		Mod.LoadModel(File);
		((CreatorView*)p_wndView)->Load(File);
		Mod.IfModul.LoadIFMachine(File);
		File.Close();
	}
}

void CMainFrame::OnFileOpenOld() 
{
	Condition = false;
	CFile File;
	CFileDialog FDlg(true,"ifm","*.ifm",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"NeuroModel(*.ifm)|*.ifm|(*.*)|*.*||");
	if(FDlg.DoModal() == IDOK){
		FileName = FDlg.GetPathName();
		File.Open((LPCTSTR) FileName,CFile::modeRead,NULL);
		CString str("NeuroCAD 2.01 - ["+FileName+"]");
		this->SetWindowText(str);
		Mod.LoadModel_Old(File);
		((CreatorView*)p_wndView)->Load(File);
		Mod.IfModul.LoadIFMachine(File);
		File.Close();
	}
}

void CMainFrame::OnUpdateFileNew(CCmdUI* pCmdUI) 
{pCmdUI->Enable(!Condition);}
void CMainFrame::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{pCmdUI->Enable(!Condition);}
void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI) 
{pCmdUI->Enable(!Condition);}
void CMainFrame::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{pCmdUI->Enable(!Condition);}
void CMainFrame::OnUpdateFileOpenOld(CCmdUI* pCmdUI) 
{pCmdUI->Enable(!Condition);}


void CMainFrame::OnBlanketViewIntput() 
{
	if(Condition){
		((SimulatorView*)p_wndView)->InView = !((SimulatorView*)p_wndView)->InView;
		((SimulatorView*)p_wndView)->ReDraw = true; 
		((SimulatorView*)p_wndView)->Invalidate(false);
	}
	else{
		((CreatorView*)p_wndView)->InView = !((CreatorView*)p_wndView)->InView;
		((CreatorView*)p_wndView)->ReDraw = true; 
		((CreatorView*)p_wndView)->Invalidate(false);
	}
}

void CMainFrame::OnUpdateBlanketViewIntput(CCmdUI* pCmdUI) 
{
	if(Condition)
		pCmdUI->SetCheck((int)((SimulatorView*)p_wndView)->InView);
	else
		pCmdUI->SetCheck((int)((CreatorView*)p_wndView)->InView);
}

void CMainFrame::OnBlanketViewNumberInput() 
{
	if(Condition){
		((SimulatorView*)p_wndView)->NumberView = !((SimulatorView*)p_wndView)->NumberView;
		((SimulatorView*)p_wndView)->ReDraw = true; 
		((SimulatorView*)p_wndView)->Invalidate(false);
	}
	else{
		((CreatorView*)p_wndView)->NumberView = !((CreatorView*)p_wndView)->NumberView;
		((CreatorView*)p_wndView)->ReDraw = true; 
		((CreatorView*)p_wndView)->Invalidate(false);
	}
}

void CMainFrame::OnUpdateBlanketViewNumberInput(CCmdUI* pCmdUI) 
{
	if(Condition)
		pCmdUI->SetCheck((int)((SimulatorView*)p_wndView)->NumberView);
	else
		pCmdUI->SetCheck((int)((CreatorView*)p_wndView)->NumberView);
}

void CMainFrame::OnBlanketViewOutput() 
{
	if(Condition){
		((SimulatorView*)p_wndView)->OutView = !((SimulatorView*)p_wndView)->OutView;
		((SimulatorView*)p_wndView)->ReDraw = true; 
		((SimulatorView*)p_wndView)->Invalidate(false);
	}
	else{
		((CreatorView*)p_wndView)->OutView = !((CreatorView*)p_wndView)->OutView;
		((CreatorView*)p_wndView)->ReDraw = true; 
		((CreatorView*)p_wndView)->Invalidate(false);
	}
}

void CMainFrame::OnUpdateBlanketViewOutput(CCmdUI* pCmdUI) 
{
	if(Condition)
		pCmdUI->SetCheck((int)((SimulatorView*)p_wndView)->OutView);
	else
		pCmdUI->SetCheck((int)((CreatorView*)p_wndView)->OutView);
}


void CMainFrame::OnTimer(UINT nIDEvent) 
{
	if(Condition){
		KillTimer(1);
		BackFlg = false;
		return;
	}
	CString str; str.Format("%sBackUp%d.ifm",BackPath, BackCount++);
	CFile File;
	if(!File.Open(str,CFile::modeCreate | CFile::modeWrite,NULL))return;
	Mod.SaveModel(File);
	((CreatorView*)p_wndView)->Save(File);
	Mod.IfModul.SaveIFMachine(File);
	File.Close();
	char lpszSection[] = "NeuroCAD BackUp";
	char lpszBackUp_cnt[]   = "BackUp_cnt";
	((CNeuroCADApp*)App)->WriteProfileInt(lpszSection, lpszBackUp_cnt, BackCount);
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnMainBack() 
{
	if(BackFlg){
		KillTimer(1);
		BackFlg = false;
	}
	else{
		int T=SetTimer(1, BackSpeed * 60000, NULL);
		BackFlg = true;
		CString str; str.Format("%sBackUp%d.ifm",BackPath, BackCount++);
		CFile File;
		if(!File.Open(str,CFile::modeCreate | CFile::modeWrite,NULL))return;
		Mod.SaveModel(File);
		((CreatorView*)p_wndView)->Save(File);
		Mod.IfModul.SaveIFMachine(File);
		File.Close();
		char lpszSection[] = "NeuroCAD BackUp";
		char lpszBackUp_cnt[]   = "BackUp_cnt";
		((CNeuroCADApp*)App)->WriteProfileInt(lpszSection, lpszBackUp_cnt, BackCount);
	}
}

void CMainFrame::OnUpdateMainBack(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!Condition);
	pCmdUI->SetCheck((int)BackFlg);
}

void CMainFrame::OnMAINOption() 
{
	Option Op; Op.m_Timer = BackSpeed;
	Op.m_BackUpPath = BackPath;
	if(Op.DoModal() == IDOK){
		BackSpeed = Op.m_Timer;
		BackPath = Op.m_BackUpPath;
		char lpszSection[] = "NeuroCAD BackUp";
		char lpszBPath[]   = "BackUp_path";
		((CNeuroCADApp*)App)->WriteProfileString(lpszSection, lpszBPath, 
						BackPath.GetBuffer(BackPath.GetLength()));
	}
}
