// NormSetter.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "NormSetter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// NormSetter dialog


NormSetter::NormSetter(CWnd* pParent /*=NULL*/)
	: CDialog(NormSetter::IDD, pParent)
{
	//{{AFX_DATA_INIT(NormSetter)
	NCell = 0;
	m_From = 0;
	m_To = 0;
	m_Delay_Cur = 0.0;
	m_Delay_Flg = FALSE;
	m_Delay_Set = 1.0;
	m_InW_Cur = 0.0;
	m_InW_Flg = FALSE;
	m_InW_Set = 1.0;
	m_LM_Cur = 0.0;
	m_LM_Flg = FALSE;
	m_LM_Set = 1.0;
	m_LP_Cur = 0.0;
	m_LP_Flg = FALSE;
	m_LP_Set = 1.0;
	m_MaxW_Cur = 0.0;
	m_MaxW_Flg = FALSE;
	m_MaxW_Set = 1.0;
	m_MinW_Cur = 0.0;
	m_MinW_Flg = FALSE;
	m_MinW_Set = 1.0;
	m_TypeSyn = 0;
	m_Scaling = TRUE;
	m_Falling_Flg = FALSE;
	m_Falling_Set = 1.0;
	m_Falling_Cur = 0.0;
	m_Rising_Cur = 0.0;
	m_Rising_Flg = FALSE;
	m_Rising_Set = 1.0;
	//}}AFX_DATA_INIT
	C= NULL;	Auto = AutoStart=false;

}


void NormSetter::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(NormSetter)
	DDX_Control(pDX, IDC_WORK, m_Work);
	DDX_Control(pDX, IDC_NORM_TO_SPIN, m_ToSpin);
	DDX_Control(pDX, IDC_NORM_FROM_SPIN, m_FromSpin);
	DDX_Text(pDX, IDC_NORM_FROM_EDIT, m_From);
	DDX_Text(pDX, IDC_NORM_TO_EDIT, m_To);
	DDX_Text(pDX, IDC_DELAY_CUR, m_Delay_Cur);
	DDX_Check(pDX, IDC_DELAY_FLG, m_Delay_Flg);
	DDX_Text(pDX, IDC_DELAY_SET, m_Delay_Set);
	DDX_Text(pDX, IDC_INW_CUR, m_InW_Cur);
	DDX_Check(pDX, IDC_INW_FLG, m_InW_Flg);
	DDX_Text(pDX, IDC_INW_SET, m_InW_Set);
	DDX_Text(pDX, IDC_LM_CUR, m_LM_Cur);
	DDX_Check(pDX, IDC_LM_FLG, m_LM_Flg);
	DDX_Text(pDX, IDC_LM_SET, m_LM_Set);
	DDX_Text(pDX, IDC_LP_CUR, m_LP_Cur);
	DDX_Check(pDX, IDC_LP_FLG, m_LP_Flg);
	DDX_Text(pDX, IDC_LP_SET, m_LP_Set);
	DDX_Text(pDX, IDC_MAXW_CUR, m_MaxW_Cur);
	DDX_Check(pDX, IDC_MAXW_FLG, m_MaxW_Flg);
	DDX_Text(pDX, IDC_MAXW_SET, m_MaxW_Set);
	DDX_Text(pDX, IDC_MINW_CUR, m_MinW_Cur);
	DDX_Check(pDX, IDC_MINW_FLG, m_MinW_Flg);
	DDX_Text(pDX, IDC_MINW_SET, m_MinW_Set);
	DDX_Radio(pDX, IDC_SELECT_SYN, m_TypeSyn);
	DDX_Check(pDX, IDC_SCALING, m_Scaling);
	DDX_Check(pDX, IDC_FT_FLG, m_Falling_Flg);
	DDX_Text(pDX, IDC_FT_SET, m_Falling_Set);
	DDX_Text(pDX, IDC_FT_CUR, m_Falling_Cur);
	DDX_Text(pDX, IDC_RT_CUR, m_Rising_Cur);
	DDX_Check(pDX, IDC_RT_FLG, m_Rising_Flg);
	DDX_Text(pDX, IDC_RT_SET, m_Rising_Set);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NormSetter, CDialog)
	//{{AFX_MSG_MAP(NormSetter)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_DELAY_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_INW_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_MINW_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_MAXW_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_RT_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_FT_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_LP_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_LM_FLG, OnReCalculate)
	ON_BN_CLICKED(IDC_SELECT_SYN, OnReCalculate)
	ON_BN_CLICKED(IDC_RADIO2, OnReCalculate)
	ON_BN_CLICKED(IDC_RADIO3, OnReCalculate)
	ON_BN_CLICKED(IDC_SCALING, OnScaling)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NormSetter message handlers

BOOL NormSetter::OnInitDialog() 
{
	CDialog::OnInitDialog();
	if(C == NULL) return FALSE;
	CString str; str.Format("Set NORM for %d cell", NCell);
	SetWindowText(str);
	if(Auto){
		m_Scaling = true;
		CButton *But = (CButton *)GetDlgItem(IDC_SCALING);
		But->EnableWindow(false);
	}
	m_FromSpin.SetRange(0, C->CountSyn-1);
	m_ToSpin.SetRange(0, C->CountSyn-1);

	if(AutoStart)
		UpdateData(false);
	else{
		m_ToSpin.SetPos(0);m_FromSpin.SetPos(C->CountSyn-1);
	}

	OnReCalculate();
	if(AutoStart)OnOK();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void NormSetter::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void NormSetter::OnOK() 
{
	UpdateData(true);
	if(!m_Scaling){
		m_Delay_Set = (m_Delay_Set != 0) ? m_Delay_Cur/m_Delay_Set : 1.0;
		m_InW_Set = (m_InW_Set != 0) ? m_InW_Cur/m_InW_Set : 1.0;
		m_MaxW_Set = (m_MaxW_Set !=0) ? m_MaxW_Cur/m_MaxW_Set : 1.0;
		m_MinW_Set = (m_MinW_Set !=0) ? m_MinW_Cur/m_MinW_Set : 1.0;
		m_Rising_Set = (m_Rising_Set != 0) ? m_Rising_Cur/m_Rising_Set : 1.0;
		m_Falling_Set = (m_Falling_Set != 0) ? m_Falling_Cur/m_Falling_Set :1.0;
		m_LP_Set = (m_LP_Set != 0) ? m_LP_Cur/m_LP_Set : 1.0;
		m_LM_Set = (m_LM_Set != 0) ? m_LM_Cur/m_LM_Set :1.0;
	}
	m_Work.SetRange(m_From, m_To);
	int s;
	switch(m_TypeSyn){
	case -1:
		for(s=m_From; s<=m_To; s++){
			if(m_Delay_Flg)C->Syn[s].Delay *= m_Delay_Set;
			if(m_InW_Flg)C->Syn[s].SingleWeight *= m_InW_Set;
			if(m_MinW_Flg)C->Syn[s].MinWeight *= m_MinW_Set;
			if(m_MaxW_Flg)C->Syn[s].MaxWeight *= m_MaxW_Set;
			if(m_Falling_Flg)C->Syn[s].FallingTime *= m_Falling_Set;
			if(m_Rising_Flg)C->Syn[s].RisingTime *= m_Rising_Set;
			if(m_LP_Flg)C->Syn[s].LearnP *= m_LP_Set;
			if(m_LM_Flg)C->Syn[s].LearnM *= m_LM_Set;
			m_Work.SetPos(s);
		}
		break;
	case 0:
		for(s=0; s<=C->CountSyn; s++){
			if(m_Delay_Flg)C->Syn[s].Delay *= m_Delay_Set;
			if(m_InW_Flg)C->Syn[s].SingleWeight *= m_InW_Set;
			if(m_MinW_Flg)C->Syn[s].MinWeight *= m_MinW_Set;
			if(m_MaxW_Flg)C->Syn[s].MaxWeight *= m_MaxW_Set;
			if(m_Falling_Flg)C->Syn[s].FallingTime *= m_Falling_Set;
			if(m_Rising_Flg)C->Syn[s].RisingTime *= m_Rising_Set;
			if(m_LP_Flg)C->Syn[s].LearnP *= m_LP_Set;
			if(m_LM_Flg)C->Syn[s].LearnM *= m_LM_Set;
			m_Work.SetPos(s);
		}
		break;
	case 1:
		for(s=0; s<=C->CountSyn; s++){
			if(C->Syn[s].SingleWeight>=0){
				if(m_Delay_Flg)C->Syn[s].Delay *= m_Delay_Set;
				if(m_InW_Flg)C->Syn[s].SingleWeight *= m_InW_Set;
				if(m_MinW_Flg)C->Syn[s].MinWeight *= m_MinW_Set;
				if(m_MaxW_Flg)C->Syn[s].MaxWeight *= m_MaxW_Set;
				if(m_Falling_Flg)C->Syn[s].FallingTime *= m_Falling_Set;
				if(m_Rising_Flg)C->Syn[s].RisingTime *= m_Rising_Set;
				if(m_LP_Flg)C->Syn[s].LearnP *= m_LP_Set;
				if(m_LM_Flg)C->Syn[s].LearnM *= m_LM_Set;
			}
			m_Work.SetPos(s);
		}
		break;
	case 2:
		for(s=0; s<=C->CountSyn; s++){
			if(C->Syn[s].SingleWeight<0){
				if(m_Delay_Flg)C->Syn[s].Delay *= m_Delay_Set;
				if(m_InW_Flg)C->Syn[s].SingleWeight *= m_InW_Set;
				if(m_MinW_Flg)C->Syn[s].MinWeight *= m_MinW_Set;
				if(m_MaxW_Flg)C->Syn[s].MaxWeight *= m_MaxW_Set;
				if(m_Falling_Flg)C->Syn[s].FallingTime *= m_Falling_Set;
				if(m_Rising_Flg)C->Syn[s].RisingTime *= m_Rising_Set;
				if(m_LP_Flg)C->Syn[s].LearnP *= m_LP_Set;
				if(m_LM_Flg)C->Syn[s].LearnM *= m_LM_Set;
			}
			m_Work.SetPos(s);
		}
		break;
	}
	CDialog::OnOK();
}

void NormSetter::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	OnReCalculate();
	m_TypeSyn = -1;
	UpdateData(false);
}

void NormSetter::OnReCalculate()
{
	UpdateData(true);
	CEdit *E;
	E= (CEdit*)GetDlgItem(IDC_DELAY_SET);E->EnableWindow(m_Delay_Flg);
	E= (CEdit*)GetDlgItem(IDC_INW_SET);E->EnableWindow(m_InW_Flg);
	E= (CEdit*)GetDlgItem(IDC_MINW_SET);E->EnableWindow(m_MinW_Flg);
	E= (CEdit*)GetDlgItem(IDC_MAXW_SET);E->EnableWindow(m_MaxW_Flg);
	E= (CEdit*)GetDlgItem(IDC_RT_SET);E->EnableWindow(m_Rising_Flg);
	E= (CEdit*)GetDlgItem(IDC_FT_SET);E->EnableWindow(m_Falling_Flg);
	E= (CEdit*)GetDlgItem(IDC_LP_SET);E->EnableWindow(m_LP_Flg);
	E= (CEdit*)GetDlgItem(IDC_LM_SET);E->EnableWindow(m_LM_Flg);
	m_Delay_Cur = m_InW_Cur = m_MinW_Cur = m_MaxW_Cur = m_LP_Cur = m_LM_Cur = 0.0;
	m_Falling_Cur = m_Rising_Cur = 0.0;
	int s, Count=0;
	switch(m_TypeSyn){
	case -1:
		for(s=m_From; s<=m_To; s++){
			m_Delay_Cur	+=C->Syn[s].Delay;
			m_InW_Cur	+=C->Syn[s].SingleWeight;
			m_MinW_Cur	+=C->Syn[s].MinWeight;
			m_MaxW_Cur	+=C->Syn[s].MaxWeight;
			m_Falling_Cur +=C->Syn[s].FallingTime;
			m_Rising_Cur +=C->Syn[s].RisingTime;
			m_LP_Cur	+=C->Syn[s].LearnP;
			m_LM_Cur	+=C->Syn[s].LearnM;
			Count++;
		}
		break;
	case 0:
		for(s=0; s<=C->CountSyn; s++){
			m_Delay_Cur	+=C->Syn[s].Delay;
			m_InW_Cur	+=C->Syn[s].SingleWeight;
			m_MinW_Cur	+=C->Syn[s].MinWeight;
			m_MaxW_Cur	+=C->Syn[s].MaxWeight;
			m_Falling_Cur +=C->Syn[s].FallingTime;
			m_Rising_Cur +=C->Syn[s].RisingTime;
			m_LP_Cur	+=C->Syn[s].LearnP;
			m_LM_Cur	+=C->Syn[s].LearnM;
			Count++;
		}
		break;
	case 1:
		for(s=0; s<=C->CountSyn; s++)
			if(C->Syn[s].SingleWeight>=0){
				m_Delay_Cur	+=C->Syn[s].Delay;
				m_InW_Cur	+=C->Syn[s].SingleWeight;
				m_MinW_Cur	+=C->Syn[s].MinWeight;
				m_MaxW_Cur	+=C->Syn[s].MaxWeight;
				m_Falling_Cur +=C->Syn[s].FallingTime;
				m_Rising_Cur +=C->Syn[s].RisingTime;
				m_LP_Cur	+=C->Syn[s].LearnP;
				m_LM_Cur	+=C->Syn[s].LearnM;
				Count++;
			}
		break;
	case 2:
		for(s=0; s<=C->CountSyn; s++)
			if(C->Syn[s].SingleWeight<0){
				m_Delay_Cur	+=C->Syn[s].Delay;
				m_InW_Cur	+=C->Syn[s].SingleWeight;
				m_MinW_Cur	+=C->Syn[s].MinWeight;
				m_MaxW_Cur	+=C->Syn[s].MaxWeight;
				m_Falling_Cur +=C->Syn[s].FallingTime;
				m_Rising_Cur +=C->Syn[s].RisingTime;
				m_LP_Cur	+=C->Syn[s].LearnP;
				m_LM_Cur	+=C->Syn[s].LearnM;
				Count++;
			}
		break;
	}
	if(Count != 0){
		m_Delay_Cur	/=(double)Count;
		m_InW_Cur	/=(double)Count;
		m_MinW_Cur	/=(double)Count;
		m_MaxW_Cur	/=(double)Count;
		m_Falling_Cur /=(double)Count;
		m_Rising_Cur /=(double)Count;
		m_LP_Cur	/=(double)Count;
		m_LM_Cur	/=(double)Count;
	}
	UpdateData(false);
}

void NormSetter::OnScaling() 
{
	UpdateData(true);
	if(m_Scaling){
		m_Delay_Set = (m_Delay_Set != 0) ? m_Delay_Cur/m_Delay_Set : 1.0;
		m_InW_Set = (m_InW_Set != 0) ? m_InW_Cur/m_InW_Set : 1.0;
		m_MaxW_Set = (m_MaxW_Set !=0) ? m_MaxW_Cur/m_MaxW_Set : 1.0;
		m_MinW_Set = (m_MinW_Set !=0) ? m_MinW_Cur/m_MinW_Set : 1.0;
		m_Rising_Set = (m_Rising_Set != 0) ? m_Rising_Cur/m_Rising_Set : 1.0;
		m_Falling_Set = (m_Falling_Set != 0) ? m_Falling_Cur/m_Falling_Set :1.0;
		m_LP_Set = (m_LP_Set != 0) ? m_LP_Cur/m_LP_Set : 1.0;
		m_LM_Set = (m_LM_Set != 0) ? m_LM_Cur/m_LM_Set :1.0;
	}
	else{
		m_Delay_Set = m_Delay_Cur*m_Delay_Set;
		m_InW_Set = m_InW_Cur*m_InW_Set;
		m_MaxW_Set = m_MaxW_Cur*m_MaxW_Set;
		m_MinW_Set = m_MinW_Cur*m_MinW_Set;
		m_Rising_Set = m_Rising_Cur*m_Rising_Set;
		m_Falling_Set = m_Falling_Cur*m_Falling_Set;
		m_LP_Set = m_LP_Cur*m_LP_Set;
		m_LM_Set = m_LM_Cur*m_LM_Set;
	}
	UpdateData(false);
}
