// Option.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "Option.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Option dialog


Option::Option(CWnd* pParent /*=NULL*/)
	: CDialog(Option::IDD, pParent)
{
	//{{AFX_DATA_INIT(Option)
	m_Timer = 0;
	m_BackUpPath = _T("");
	//}}AFX_DATA_INIT
}


void Option::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Option)
	DDX_Text(pDX, IDC_BACKUP_TIMER, m_Timer);
	DDV_MinMaxInt(pDX, m_Timer, 1, 1000);
	DDX_Text(pDX, IDC_BACKUP_PATH, m_BackUpPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Option, CDialog)
	//{{AFX_MSG_MAP(Option)
	ON_BN_CLICKED(IDC_BACKUP_SET_PATH, OnBackupSetPath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Option message handlers

void Option::OnBackupSetPath() 
{

	CFileDialog FDlg(false);
	if(FDlg.DoModal() != IDOK) return;
	CString Path = FDlg.GetPathName();
	int pp = Path.Find(FDlg.GetFileTitle());
	Path.Delete(pp, Path.GetLength()-pp);
	if(SetCurrentDirectory(Path.GetBuffer(Path.GetLength())))
		m_BackUpPath = Path;
	else
		if(CreateDirectory(Path.GetBuffer(Path.GetLength()), NULL))
			m_BackUpPath = Path;
	UpdateData(false);
	//}
}
