#if !defined(AFX_POLYCHANNELVIEW_H__65309D18_05D0_4117_9B48_73756DA03907__INCLUDED_)
#define AFX_POLYCHANNELVIEW_H__65309D18_05D0_4117_9B48_73756DA03907__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Model.h"
#include "SVCommunicator.h"

/////////////////////////////////////////////////////////////////////////////
// PCMChooser dialog

class PCMChooser : public CDialog
{
// Construction
public:
	PCMChooser(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(PCMChooser)
	enum { IDD = IDD_SV_CHOOSER };
	double	m_Time;
	float	m_ReDraw;
	//}}AFX_DATA
	bool Full, Imm;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PCMChooser)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(PCMChooser)
	afx_msg void OnSvFull();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class PolyChannelView : public CWnd
{
public:
	PolyChannelView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(PolyChannelView)
	virtual ~PolyChannelView();

// Attributes
public:
	Model *Mod;
	int CellCount;
	int *pCell;

	PVOID pStartData;
	float *pDataLast;
	float *pFirstRecord;
	BYTE *MaxFileSize;
	int RecordSize;
	int AllRecords;
	CString FileName;
	bool RecordingFlg;

	CellRecordView *CRV;
	int RightRecord;
	float Resolution;
	int ChannelHight, ChannelCount, SelectChannel;
	float PreCount;
	float PrePointCount;
	bool ReDraw;
	HANDLE hDrawing;
	int *LastPointY;
	int LastPointX;

	PCMChooser chooser;
	SVCommunicator SVC;

	CSize size;
	CBitmap *OldBmp, pBmp;
	CDC MDC;
	bool SizeFlg;
	int ViewLeft, ViewRight, DrawEnd;
	COLORREF ColBack, ColLine, ColSelect, ColGrid, ColAP, ColTH;
	COLORREF UserColor;
	bool GridFlg;




// Operations
public:
	void NewDate();
	void ReMapFile();
	void FlashScreen(CDC &dc);
	void StartRecord();
	void StopRecord();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PolyChannelView)
	protected:
	//}}AFX_VIRTUAL

// Implementation
protected:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(PolyChannelView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
#endif // !defined(AFX_POLYCHANNELVIEW_H__65309D18_05D0_4117_9B48_73756DA03907__INCLUDED_)
