// SVCommunicator.cpp : implementation file
//

#include "stdafx.h"
#include "NeuroCAD.h"
#include "SVCommunicator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SVCommunicator dialog


SVCommunicator::SVCommunicator(CWnd* pParent /*=NULL*/)
	: CDialog(SVCommunicator::IDD, pParent)
{
	//{{AFX_DATA_INIT(SVCommunicator)
	m_CellPointer = 0;
	m_SynPointer = 0;
	//}}AFX_DATA_INIT
}


void SVCommunicator::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SVCommunicator)
	DDX_Text(pDX, IDC_SV_CELL_POINTER, m_CellPointer);
	DDX_Text(pDX, IDC_SV_SYN_POINTER, m_SynPointer);
	DDX_Text(pDX, IDC_SV_AP, CRV[m_CellPointer].KAP);
	DDX_Text(pDX, IDC_SV_P, CRV[m_CellPointer].KP);
	DDX_Text(pDX, IDC_SV_SIN_I, CRV[m_CellPointer].SRV[m_SynPointer].KIn);
	DDX_Text(pDX, IDC_SV_SIN_S, CRV[m_CellPointer].SRV[m_SynPointer].KSIn);
	DDX_Text(pDX, IDC_SV_TH, CRV[m_CellPointer].KTH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SVCommunicator, CDialog)
	//{{AFX_MSG_MAP(SVCommunicator)
	ON_BN_CLICKED(IDC_SV_VP, OnSvVp)
	ON_BN_CLICKED(IDC_SV_VAP, OnSvVap)
	ON_BN_CLICKED(IDC_SV_AP_ATT, OnSvApAtt)
	ON_BN_CLICKED(IDC_SV_VTH, OnSvVth)
	ON_BN_CLICKED(IDC_SV_TH_ATT, OnSvThAtt)
	ON_BN_CLICKED(IDC_SV_SIN_VI, OnSvSinVi)
	ON_BN_CLICKED(IDC_SV_SIN_VSI, OnSvSinVsi)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SVCommunicator message handlers

BOOL SVCommunicator::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CSpinButtonCtrl* Cell = (CSpinButtonCtrl*) GetDlgItem(IDC_SV_CELL);
	Cell->SetRange(0, MaxCell-1);
	Syn = (CSpinButtonCtrl*) GetDlgItem(IDC_SV_SIN);
	Syn->SetRange(0, CRV[m_CellPointer].Count-1);
	bVP		= (CButton*) GetDlgItem(IDC_SV_VP);
	bVAp	= (CButton*) GetDlgItem(IDC_SV_VAP);
	bApAtt	= (CButton*) GetDlgItem(IDC_SV_AP_ATT);
	bVTH	= (CButton*) GetDlgItem(IDC_SV_VTH);
	bVThAtt	= (CButton*) GetDlgItem(IDC_SV_TH_ATT);
	bVSi	= (CButton*) GetDlgItem(IDC_SV_SIN_VI);
	bVSS	= (CButton*) GetDlgItem(IDC_SV_SIN_VSI);
	SetFlg();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void SVCommunicator::OnSvVp() 
{
	CRV[m_CellPointer].VP = !CRV[m_CellPointer].VP;
	SetFlg();
	CEdit *E = (CEdit*) GetDlgItem(IDC_SV_P); E->EnableWindow(CRV[m_CellPointer].VP);
	bApAtt->EnableWindow(CRV[m_CellPointer].VP & CRV[m_CellPointer].VAP); 
	bVThAtt->EnableWindow(CRV[m_CellPointer].VP & CRV[m_CellPointer].VTH);
}

void SVCommunicator::OnSvVap() 
{
	CRV[m_CellPointer].VAP = !CRV[m_CellPointer].VAP;
	SetFlg();
	CEdit *E = (CEdit*) GetDlgItem(IDC_SV_AP); E->EnableWindow(CRV[m_CellPointer].VAP);
	bApAtt->EnableWindow(CRV[m_CellPointer].VP & CRV[m_CellPointer].VAP); 
}

void SVCommunicator::OnSvApAtt() 
{
	CRV[m_CellPointer].AttAP = !CRV[m_CellPointer].AttAP;
	SetFlg();
}

void SVCommunicator::OnSvVth() 
{
	CRV[m_CellPointer].VTH = !CRV[m_CellPointer].VTH;
	SetFlg();
	CEdit *E = (CEdit*) GetDlgItem(IDC_SV_TH); E->EnableWindow(CRV[m_CellPointer].VTH);
	bVThAtt->EnableWindow(CRV[m_CellPointer].VP & CRV[m_CellPointer].VTH);
}

void SVCommunicator::OnSvThAtt() 
{
	CRV[m_CellPointer].AttTH = !CRV[m_CellPointer].AttTH;
	SetFlg();
}

void SVCommunicator::OnSvSinVi() 
{
	CRV[m_CellPointer].SRV[m_SynPointer].VIn = !CRV[m_CellPointer].SRV[m_SynPointer].VIn;
	SetFlg();
	CEdit *E = (CEdit*) GetDlgItem(IDC_SV_SIN_I); 
	E->EnableWindow(CRV[m_CellPointer].SRV[m_SynPointer].VIn);
}

void SVCommunicator::OnSvSinVsi() 
{
	CRV[m_CellPointer].SRV[m_SynPointer].VSIn = !CRV[m_CellPointer].SRV[m_SynPointer].VSIn;
	SetFlg();
	CEdit *E = (CEdit*) GetDlgItem(IDC_SV_SIN_S); 
	E->EnableWindow(CRV[m_CellPointer].SRV[m_SynPointer].VSIn);
}

void SVCommunicator::SetFlg()
{
	bVP		->SetCheck(CRV[m_CellPointer].VP);
	bVAp	->SetCheck(CRV[m_CellPointer].VAP);
	bApAtt	->SetCheck(CRV[m_CellPointer].AttAP);
	bVTH	->SetCheck(CRV[m_CellPointer].VTH);
	bVThAtt	->SetCheck(CRV[m_CellPointer].AttTH);
	bVSi	->SetCheck(CRV[m_CellPointer].SRV[m_SynPointer].VIn);
	bVSS	->SetCheck(CRV[m_CellPointer].SRV[m_SynPointer].VSIn);
	CEdit *E = (CEdit*) GetDlgItem(IDC_SV_P); E->EnableWindow(CRV[m_CellPointer].VP);
	E = (CEdit*) GetDlgItem(IDC_SV_AP); E->EnableWindow(CRV[m_CellPointer].VAP);
	E = (CEdit*) GetDlgItem(IDC_SV_TH); E->EnableWindow(CRV[m_CellPointer].VTH);
	E = (CEdit*) GetDlgItem(IDC_SV_SIN_I);
	E->EnableWindow(CRV[m_CellPointer].SRV[m_SynPointer].VIn);
	E = (CEdit*) GetDlgItem(IDC_SV_SIN_S); 
	E->EnableWindow(CRV[m_CellPointer].SRV[m_SynPointer].VSIn);
}

void SVCommunicator::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(nSBCode == SB_ENDSCROLL) return;
	if(pScrollBar->GetDlgCtrlID() == IDC_SV_SIN){
		UpdateData(true);
		m_SynPointer = nPos;
		SetFlg();
		UpdateData(false);
	}
	else if(pScrollBar->GetDlgCtrlID() == IDC_SV_CELL){
		UpdateData(true);
		Syn->SetRange(0, CRV[m_CellPointer].Count-1);
		m_SynPointer = 0;
		m_CellPointer = nPos;
		SetFlg();
		UpdateData(false);
	}
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
