// SimRecoder.cpp: implementation of the SimRecoder class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NeuroCAD.h"
#include "SimRecoder.h"
#include "string.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SimRecoder::SimRecoder(Model *pMod)
{
	Mod = pMod;
	hRecord = NULL;
}

SimRecoder::~SimRecoder()
{
	if(hRecord != NULL){
		::CloseHandle(hRecord);
		hRecord = NULL;
	}
}

bool SimRecoder::CreateRecord(LPTSTR ModelName,LPTSTR FileName)
{
	DWORD pFileLength;
	unsigned int ModRecLength=0;

	hRecord = ::CreateFile(FileName, GENERIC_READ|GENERIC_WRITE, 0, NULL,	OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hRecord == INVALID_HANDLE_VALUE)  return false;
	if(SetEndOfFile(hRecord) == 0) return false;

	char *FileId = "SimFile_V1.0\0";
	DWORD dR;
	::WriteFile(hRecord,FileId,13,&dR,NULL);
	pFileLength = dR;
	::WriteFile(hRecord,ModelName,1+(int)strlen(ModelName),&dR,NULL);
	pFileLength +=dR;
//Model description	
	unsigned int Temp=0;
	::WriteFile(hRecord,&Temp,sizeof(Temp),&dR,NULL);
	pFileRecCount =pFileLength+dR;
	ModRecLength +=sizeof(Temp);
	
	Temp = (unsigned int)Mod->CurrentCell;
	::WriteFile(hRecord,&Temp,sizeof(Temp),&dR,NULL);
	pFileRecCount+=dR;
	ModRecLength +=sizeof(Temp);

	for(int c=0; c<Mod->CurrentCell; c++){
		::WriteFile(hRecord,&Mod->VCellList[c],10,&dR,NULL);
		pFileRecCount+=dR;
		ModRecLength +=10;
	}
	unsigned int NLinc=0; Temp=0;
	DWORD pFileNLinc=pFileRecCount;

	::WriteFile(hRecord,&Temp,sizeof(Temp),&dR,NULL);
	pFileRecCount+=dR;
	ModRecLength +=sizeof(Temp);
	
	
	for(int From=0; From<Mod->CurrentCell; From++){
		for(int To=0; To<Mod->CurrentCell; To++){
			if(Mod->ConMap[From][To].Current != 0){
				NLinc++;
				::WriteFile(hRecord,&From,4,&dR,NULL);	//From
				pFileRecCount+=dR;
				ModRecLength +=4;
				::WriteFile(hRecord,&To,4,&dR,NULL);	//To
				pFileRecCount+=dR;
				ModRecLength +=4;
			}
		}
	}
	::SetFilePointer(hRecord,pFileNLinc,NULL,FILE_BEGIN);
	::WriteFile(hRecord,&NLinc,sizeof(NLinc),&dR,NULL);
	::SetFilePointer(hRecord,0,NULL,FILE_END);

	unsigned short Fr = Mod->Input.LevelCount;
	::WriteFile(hRecord,&Fr,sizeof(Fr),&dR,NULL);
	pFileRecCount+=dR;
	ModRecLength +=sizeof(Fr);

	::SetFilePointer(hRecord,pFileLength,NULL,FILE_BEGIN);
	::WriteFile(hRecord,&ModRecLength,sizeof(ModRecLength),&dR,NULL);
	::SetFilePointer(hRecord,0,NULL,FILE_END);

	float CurrentTime=(float)Mod->CellList->TimeStep;
	Temp = sizeof(CurrentTime) + Mod->Input.LevelCount*sizeof(Fr)+Mod->CurrentCell*2*sizeof(CurrentTime);
	::WriteFile(hRecord,&Temp,sizeof(Temp),&dR,NULL);
	pFileRecCount+=dR;
	Temp=0;
	::WriteFile(hRecord,&Temp,sizeof(Temp),&dR,NULL);
	::WriteFile(hRecord,&CurrentTime,4,&dR,NULL);

//Create Process

	return true;
}

void SimRecoder::EndRecord()
{
	if(hRecord == NULL) return;
	::CloseHandle(hRecord);
	hRecord = NULL;
}

void SimRecoder::WriteSampl()
{
	DWORD dR;
	float CurTime = (float)Mod->CellList->CurrentTime;
	::WriteFile(hRecord,&CurTime,4,&dR,NULL);
	for(int IL=0; IL<Mod->Input.LevelCount; IL++){
		short NPat = Mod->Input.Levels[IL].WorkPattern;
//		::WriteFile(hRecord,&NPat,sizeof(NPat),&dR,NULL);
		::WriteFile(hRecord,&NPat,2,&dR,NULL);
	}
	for(int c=0; c<Mod->CurrentCell; c++){
		if(Mod->VCellList[c].Select<0x10){
			float Temp = Mod->CellList[c].Potentioal;
			::WriteFile(hRecord,&Temp,4,&dR,NULL);
			Temp = Mod->CellList[c].ThresholdLevel;
			::WriteFile(hRecord,&Temp,4,&dR,NULL);
		}
	}
//UpdateData to Process

}