#if !defined(AFX_SIMULATORVIEW_H__1156421B_37F9_11D5_85C7_5254AB1ABD30__INCLUDED_)
#define AFX_SIMULATORVIEW_H__1156421B_37F9_11D5_85C7_5254AB1ABD30__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SimulatorView.h : header file
//
#include "Model.h"
#include "CellView.h"
#include "ModelRecoder.h"
#include "MainFrm.h"
#include "PolyChannelsMonitor.h"
#include "SimRecoder.h"
/////////////////////////////////////////////////////////////////////////////
// SimulatorView window

class SimulatorView : public CWnd
{
// Construction
public:
//	SimulatorView();
	SimulatorView(void *MF);

// Attributes
public:
	double dT;
	int dS;
	Model *Mod;

// View Attributes
	CSize MaxSize, CurSize;
	double Resolution;
	CPoint CurrentPoint, CursorPoint;
	bool ReDraw;
	bool InView, OutView, NumberView;
	CBitmap Bmp;
	bool MiniView;
	ModelRecoder *MR;
	CStatusBar  *m_StatusBar;
	void *MFrm;

//Record View
	PolyChannelsMonitor **PCM;
	SimRecoder *SimRec;
	int PCMCount;
	Position From_1;

//Condition of Simulator
	int Condition;

//Cell Property
	CellView *CV;
	int SelectCell, ViewCell;
	int SelectLink;

// Operations
public:
	void DrawView();
	void ReBuild(CDC &dc);
	void ReView();
//	virtual void Save(CFile &File);
//	virtual void Load(CFile &File);

protected:
	Position LPtoMOD(CPoint p);
	CPoint MODtoLP(Position p);
	void DrawSynapse(CDC &dc, int &From, int &To, int Select);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SimulatorView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~SimulatorView();

	// Generated message map functions
protected:
	//{{AFX_MSG(SimulatorView)
	afx_msg void OnReView(UINT wParam, LONG lParam);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnSimulatorIteration();
	afx_msg void OnUpdateSimulatorIteration(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorPause();
	afx_msg void OnUpdateSimulatorPause(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorPlay();
	afx_msg void OnUpdateSimulatorPlay(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorProperty();
	afx_msg void OnUpdateSimulatorProperty(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorStep();
	afx_msg void OnUpdateSimulatorStep(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorStop();
	afx_msg void OnUpdateSimulatorStop(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorSetSignal();
	afx_msg void OnUpdateSimulatorSetSignal(CCmdUI* pCmdUI);
	afx_msg void OnRecoderStart();
	afx_msg void OnUpdateRecoderStart(CCmdUI* pCmdUI);
	afx_msg void OnRecoderProperty();
	afx_msg void OnUpdateRecoderProperty(CCmdUI* pCmdUI);
	afx_msg void OnRecoderPause();
	afx_msg void OnUpdateRecoderPause(CCmdUI* pCmdUI);
	afx_msg void OnRecorderStop();
	afx_msg void OnUpdateRecorderStop(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorImPause();
	afx_msg void OnSimulatorImView();
	afx_msg void OnSimulatorImInport();
	afx_msg void OnSimulatorCodogramm();
	afx_msg void OnUpdateSimulatorCodogramm(CCmdUI* pCmdUI);
	afx_msg void OnSimulatorPoly();
	afx_msg void OnUpdateSimulatorPoly(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SIMULATORVIEW_H__1156421B_37F9_11D5_85C7_5254AB1ABD30__INCLUDED_)
