// StatWatcher.h: interface for the StatWatcher class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATWATCHER_H__8ED32D67_EB5E_41AC_AF79_EADE9CCFDD30__INCLUDED_)
#define AFX_STATWATCHER_H__8ED32D67_EB5E_41AC_AF79_EADE9CCFDD30__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "InputM.h"
#include "StatReportSetter.h"

struct SynapsesAccountStr{
	double AverageInjection;	int CountInjection;
	double AverageSpeed;		int CountSpeed;
	double LastWeight;
	//int NSynapse;
};

struct CellAccountStr{
	SynapsesAccountStr *SynapsesAccount;
	double AveragePotential;	int CountPotential;
	int SpikeCount;
};

struct PatternAccountStr{
	Event *TimeEvent;	int EventCount;
	float Window,StartTime;
};

class StatWatcher  
{
protected:
	StatReportSetter Setter;
	float CurrentTime;
//Attributs
public:
	void *Mod;
	int *CellPointer;
	int CellCount;
//Statistic
	CellAccountStr *CellAccount;
	unsigned long int FullSpikeCount;
	double AverageTotalInjection;	int CountTotalInjection;
	double AverageTotalSpeed;		int CountTotalSpeed;
	double AverageTotalPotential;	int CountTotalPotential;
	float ReportTime;
	CString ReportFileName;

//Claster
	PatternAccountStr ***PatternAccount;
	int pLastPattern, MaxLastPattern;

//CodoGramme
	bool WriteFlg;
	CFile CodFile;


public:
	StatWatcher();
	virtual ~StatWatcher();

	void AddCell(int Number);
	bool DeleteCell(int Number);

	bool Assemble(void *md);
	void Recode();

	void Activate(int Level, int Pattern);
	void DeActivate(int Level, int Pattern);

	void StartCodoGramme();
	void StopCodoGramme();
};

#endif // !defined(AFX_STATWATCHER_H__8ED32D67_EB5E_41AC_AF79_EADE9CCFDD30__INCLUDED_)
