// IfM.cpp: implementation of the IfM class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdio.h"
#include "NeuroCAD.h"
#include "IfM.h"
#include "Model.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Condition::Condition()
{
	AND_OR_ADD = ' ';	MORE_LESS = false;
	NCell = CellCount = CellMax = 0;
	Variable = Value = 0;
	pNCell = NULL;
}

Condition::~Condition()
{
	if(CellMax != 0)
		delete[] pNCell;
}

bool Condition::Calculate(void *M)
{
	Model *Mod = (Model *)M;
	if(CellCount == 0){
		if(NCell >= Mod->CurrentCell) return false;
		switch (Variable){
		case 0:	return ((Mod->CellList[NCell].CurrentTime > Value)^MORE_LESS); break;
		case 1:	return ((Mod->CellList[NCell].Potentioal > Value)^MORE_LESS); break;
		case 2:	return ((Mod->CellList[NCell].APPotential > Value)^MORE_LESS); break;
		case 3:	return ((Mod->CellList[NCell].Threshold > Value)^MORE_LESS); break;
		case 4:	return ((Mod->CellList[NCell].Fireing > Value)^MORE_LESS); break;
		}
	}
	else{
//		bool Result;
		if(AND_OR_ADD == '|'){
			bool Result = false;
			int s;
			switch (Variable){
			case 0:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result |=((Mod->CellList[pNCell[s]].CurrentTime > Value)^MORE_LESS);
				}
				break;
			case 1:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result |=((Mod->CellList[pNCell[s]].Potentioal > Value)^MORE_LESS);
				}
				break;
			case 2:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result |=((Mod->CellList[pNCell[s]].APPotential > Value)^MORE_LESS);
				}
				break;
			case 3:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result |=((Mod->CellList[pNCell[s]].ThresholdLevel > Value)^MORE_LESS);
				}
				break;
			case 4:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result |=((Mod->CellList[pNCell[s]].Fireing > Value)^MORE_LESS);
				}
				break;
			}
			return Result;
		}
		else if(AND_OR_ADD == '{'){
			float Result = 0.0f;
			int s;
			switch (Variable){
			case 0:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result +=Mod->CellList[pNCell[s]].CurrentTime;
				}
				break;
			case 1:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result +=Mod->CellList[pNCell[s]].Potentioal;
				}
				break;
			case 2:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result +=Mod->CellList[pNCell[s]].APPotential;
				}
				break;
			case 3:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result +=Mod->CellList[pNCell[s]].ThresholdLevel;
				}
				break;
			case 4:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result +=Mod->CellList[pNCell[s]].Fireing;
				}
				break;
			}
			return ((Result/CellCount > Value)^MORE_LESS);
		}
		else if(AND_OR_ADD == '['){
			bool Result = true;
			int s;
			switch (Variable){
			case 0:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result &=((Mod->CellList[pNCell[s]].CurrentTime > Value)^MORE_LESS);
				}
				break;
			case 1:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result &=((Mod->CellList[pNCell[s]].Potentioal > Value)^MORE_LESS);
				}
				break;
			case 2:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result &=((Mod->CellList[pNCell[s]].APPotential > Value)^MORE_LESS);
				}
				break;
			case 3:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result &=((Mod->CellList[pNCell[s]].ThresholdLevel > Value)^MORE_LESS);
				}
				break;
			case 4:
				for(s=0; s<CellCount; s++){
					if(pNCell[s]<Mod->CurrentCell)
						Result &=((Mod->CellList[pNCell[s]].Fireing > Value)^MORE_LESS);
				}
				break;
			}
			return Result;
		}
	}
	return true;
}

int Condition::Interpret(char * String)
{
	if(CellMax != 0)	delete[] pNCell;
	CellCount = 0;

	int p = 0;
	while(String[p]==' '){
		if((String[p] == (char)0x00)|(String[p] == (char)0x0a)|(String[p] == (char)0x0a))return (-p);
		p++;
	}

	switch (String[p++]){
	case 'T':	Variable = 0;	break;
	case 't':	Variable = 0;	break;
	case 'P':	Variable = 1;	break;
	case 'p':	Variable = 1;	break;
	case 'A':	Variable = 2;	break;
	case 'a':	Variable = 2;	break;
	case 'H':	Variable = 3;	break;
	case 'h':	Variable = 3;	break;
	case 'F':	Variable = 4;	break;
	case 'f':	Variable = 4;	break;
	case 'X':	Variable = 5;	break;
	case 'x':	Variable = 5;	break;
	default: return(-p);
	}

	while(String[p]==' '){
		if((String[p] == (char)0x00)|(String[p] == '\n'))return (-p);
		p++;
	}

	if((String[p] == '[')|(String[p] == '{')|(String[p] == '|')){
		pNCell = new int[CellMax = 10];
		AND_OR_ADD = String[p++];
		while((String[p] != ']')&(String[p] != '}')&(String[p] != '|')){
			if((String[p] == (char)0x00)|(String[p] == (char)0x0a)|(String[p] == (char)0x0a))return (-p);
			if(isdigit((int)String[p]) !=0){
				if((CellCount+1) == CellMax){
					int *New = new int[CellMax+10];
					for(int a=0; a<CellMax; a++) New[a] = pNCell[a];
					delete[] ((int *) NCell);
					pNCell = New;
					CellMax+=10;
				}
				CellCount += sscanf(&String[p],"%d",&pNCell[CellCount]);
				while(isdigit((int)String[p])!=0)p++;
			}
			else 
				p++;
		}
		p++;
	}
	else{
		if(isdigit((int)String[p]) !=0){
			sscanf(&String[p],"%d",&NCell); CellCount = CellMax = 0;
			while(isdigit((int)String[p])!=0)p++;
		}
		else return (-p);
	}

	while(String[p]==' '){
		if((String[p] == (char)0x00)|(String[p] == (char)0x0a)|(String[p] == (char)0x0a))return (-p);
		p++;
	}

	if((String[p] =='<')|(String[p] =='>'))
		MORE_LESS = (String[p++] =='<');
	else return (-p);

	while(String[p]==' '){
		if((String[p] == (char)0x00)|(String[p] == (char)0x0a)|(String[p] == (char)0x0a))return (-p);
		p++;
	}

	if(sscanf(&String[p],"%f",&Value) == 0)	return (-p);
	while((isdigit((int)String[p]) !=0)|(String[p] == '-')|
		  (String[p] == '.')|(String[p] == 'e')|(String[p] == 'E'))p++;

	return p;
}

ConditionBloc::ConditionBloc(){
	pCondition = NULL;
	ConditionCount = ConditionMax = 0;
}

ConditionBloc::~ConditionBloc(){
	if(pCondition != NULL){
		for(int i=0; i<ConditionMax; i++){
			if(pCondition[i].CON_BLOC) delete ((ConditionBloc*)pCondition[i].Condition);
			else delete ((Condition*)pCondition[i].Condition);
		}
		delete[] pCondition;
	}
	ConditionCount = ConditionMax = 0;
}

bool ConditionBloc::Calculate(void *M){
	Model *Mod = (Model*)M;
	bool Return;
	for(int i=0; i<ConditionCount; i++){
		switch(pCondition[i].Operation){
		case ' ': Return = (pCondition[i].CON_BLOC)?
					((ConditionBloc *)pCondition[i].Condition)->Calculate(Mod):
					((Condition *)pCondition[i].Condition)->Calculate(Mod);
					break;
		case '&': Return &= (pCondition[i].CON_BLOC)?
					((ConditionBloc *)pCondition[i].Condition)->Calculate(Mod):
					((Condition *)pCondition[i].Condition)->Calculate(Mod);
					break;
		case '|': Return |= (pCondition[i].CON_BLOC)?
					((ConditionBloc *)pCondition[i].Condition)->Calculate(Mod):
					((Condition *)pCondition[i].Condition)->Calculate(Mod);
					break;
		case '^': Return ^= (pCondition[i].CON_BLOC)?
					((ConditionBloc *)pCondition[i].Condition)->Calculate(Mod):
					((Condition *)pCondition[i].Condition)->Calculate(Mod);
					break;
		case '!': Return != (pCondition[i].CON_BLOC)?
					((ConditionBloc *)pCondition[i].Condition)->Calculate(Mod):
					((Condition *)pCondition[i].Condition)->Calculate(Mod);
					break;
		default: return false;
		}
	}
	return Return;
}

int ConditionBloc::Interpret(char * String){
	if(pCondition != NULL){
		for(int i=0; i<ConditionMax; i++){
			if(pCondition[i].CON_BLOC) delete ((ConditionBloc*)pCondition[i].Condition);
			else delete ((Condition*)pCondition[i].Condition);
		}
		delete[] pCondition;
	}
	ConditionCount =  0;
	int p=0;

	while(String[p]==' '){
		if((String[p] == (char)0x00)|(String[p] == (char)0x0a)|(String[p] == (char)0x0a))return (-p);
		p++;
	}
	if(String[p] == '('){
		p++;
		char Com =' ';
		int ret = 0, s = 0;
		while(String[p] !=')'){
			switch (String[p]){
			case ' '		: p++; break;
			case (char)0x00	: return -p; break;
			case (char)0x0a	: return -p; break;
			case (char)0x0d		: return -p; break;
			case '&': Com = '&'; p++; break;
			case '|': Com = '|'; p++; break;
			case '^': Com = '^'; p++; break;
			case '!': Com = '!'; p++; break;
			case '(':
				s = AddCon();
				pCondition[s].Operation = Com; Com = ' ';
				pCondition[s].CON_BLOC = true;
				pCondition[s].Condition = new ConditionBloc;
				ret =((ConditionBloc*)pCondition[s].Condition)->Interpret(&String[p]);
				if(ret<0) return -(p+abs(ret));
				p += ret;
				break;
			default:
				s = AddCon();
				pCondition[s].Operation = Com; Com = ' ';
				pCondition[s].CON_BLOC = false;
				pCondition[s].Condition = new Condition;
				ret =((Condition*)pCondition[s].Condition)->Interpret(&String[p]);
				if(ret<0) return -(p+abs(ret));
				p += ret;
				break;
			}
		}
		p++;
	}
	else if(String[p] == '='){
		p++;
		char Com =' ';
		int ret = 0, s = 0;
		while((String[p] != (char)0x00)&(String[p] != (char)0x0a)&(String[p] != (char)0x0d)){
			switch (String[p]){
			case ' ': p++; break;
			case '&': Com = '&'; p++; break;
			case '|': Com = '|'; p++; break;
			case '^': Com = '^'; p++; break;
			case '!': Com = '!'; p++; break;
			case '(':
				s = AddCon();
				pCondition[s].Operation = Com; Com = ' ';
				pCondition[s].CON_BLOC = true;
				pCondition[s].Condition = new ConditionBloc;
				ret =((ConditionBloc*)pCondition[s].Condition)->Interpret(&String[p]);
				if(ret<0) return -(p+abs(ret));
				p += ret;
				break;
			default:
				s = AddCon();
				pCondition[s].Operation = Com; Com = ' ';
				pCondition[s].CON_BLOC = false;
				pCondition[s].Condition = new Condition;
				ret =((Condition*)pCondition[s].Condition)->Interpret(&String[p]);
				if(ret<0) return -(p+abs(ret));
				p += ret;
				break;
			}
		}
	}
	else{
		char Com =' ';
		int ret = 0, s = 0;
		while((String[p] != (char)0x00)&(String[p] != (char)0x0a)&(String[p] != (char)0x0d)){
			switch (String[p]){
			case ' ': p++; break;
			case '&': Com = '&'; p++; break;
			case '|': Com = '|'; p++; break;
			case '^': Com = '^'; p++; break;
			case '!': Com = '!'; p++; break;
			case '(':
				s = AddCon();
				pCondition[s].Operation = Com; Com = ' ';
				pCondition[s].CON_BLOC = true;
				pCondition[s].Condition = new ConditionBloc;
				ret =((ConditionBloc*)pCondition[s].Condition)->Interpret(&String[p]);
				if(ret<0) return -(p+abs(ret));
				p += ret;
				break;
			default:
				s = AddCon();
				pCondition[s].Operation = Com; Com = ' ';
				pCondition[s].CON_BLOC = false;
				pCondition[s].Condition = new Condition;
				ret =((Condition*)pCondition[s].Condition)->Interpret(&String[p]);
				if(ret<0) return -(p+abs(ret));
				p += ret;
				break;
			}
		}
	}
	return p;
}

int ConditionBloc::AddCon()
{
	if((ConditionCount+1) >= ConditionMax){
		ConditionPointer *New = new ConditionPointer[ConditionMax+10];
		for(int s=0; s<ConditionMax; s++) New[s] = pCondition[s];
		for(s=ConditionMax; s<ConditionMax+10; s++){
			New[s].Condition = NULL;
			New[s].CON_BLOC = false;
		}
		delete[] pCondition;
		pCondition = New; ConditionMax +=10;
	}
	return (ConditionCount++);
}

IfM::IfM()
{
	m_String = _T("");
	CC.m_EditString = &m_String;
	InputList = IfCommand = NULL; InputCount = 0;
	Command = NULL;
	CommandCounter = CommandMax =0;
	IfDriver = NULL;

}

IfM::~IfM()
{
	if(InputList != NULL) delete[] InputList;
	if(IfCommand !=NULL) delete[] IfCommand;
	if(Command != NULL) delete[] Command;
	if(IfDriver != NULL) delete[] IfDriver;
	CommandCounter = CommandMax =0;
}

void IfM::EditCondition(void *Mod)
{
	if(CC.DoModal() != IDOK) return;
	if(IfCommand !=NULL) 
		delete[] IfCommand;
	if(Command != NULL) 
		delete[] Command;
	if(IfDriver != NULL) 
		delete[] IfDriver;
	CommandCounter = 0;

	Command = new ConditionBloc[CommandMax = 10];
	IfCommand = new int [CommandMax];
	IfDriver = new IfDrive[((Model*)Mod)->CurrentCell];

	char *CommandLine = m_String.GetBuffer(m_String.GetLength());
	CommandLine[0] = (char)toupper((int)CommandLine[0]);
	CommandLine[1] = (char)toupper((int)CommandLine[1]);
	int p=1;
	while(CommandLine[p] !=(char)0x00){
		CommandLine[p] = (char)toupper((int)CommandLine[p]);
		if((CommandLine[p-1] == 'I')&(CommandLine[p] == ':')){
			p++; 
			while(isdigit(CommandLine[p]) ==0){
				if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
					{ErrorFlash(-p); return;}
				p++;
			}
			int res;
			if(sscanf(&CommandLine[p],"%d",&res) != 0){
				while(isdigit(CommandLine[p]) !=0){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				while(CommandLine[p] == ' '){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				if(CommandLine[p] == '='){
					int s = AddCommand(); IfCommand[s] = res;
					res = Command[s].Interpret(&CommandLine[p]);
					if(res < 0)ErrorFlash(res);
					else p+= res;
				}
				else
					{ErrorFlash(-p); return;}
			}
		}
		else if((CommandLine[p-1] == 'S')&(CommandLine[p] == 'T')&((CommandLine[p+1] == 'P')|(CommandLine[p+1] == 'p'))){
			p++; 
			while(CommandLine[p] != '='){
				if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
					{ErrorFlash(-p); return;}
				p++;
			}
			int s = AddCommand(); IfCommand[s] = -1;
			int res = Command[s].Interpret(&CommandLine[p]);
			if(res < 0)ErrorFlash(res);
			else p+= res;
		}
		else if((CommandLine[p-1] == 'R')&(CommandLine[p] == ':')){
			p++; 
			while(isdigit(CommandLine[p]) ==0){
				if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
					{ErrorFlash(-p); return;}
				p++;
			}
			int res;
			if((sscanf(&CommandLine[p],"%d",&res) != 0)&(res>0)&(res<((Model*)Mod)->CurrentCell)){
				while(isdigit(CommandLine[p]) !=0){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				while(CommandLine[p] == ' '){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				if(CommandLine[p] == '='){
				if(sscanf(&CommandLine[p],"%f",&IfDriver[res].Rate) == 0)
					{ErrorFlash(-p); return;}
					while((isdigit((int)CommandLine[p]) !=0)|(CommandLine[p] == '-')|
						(CommandLine[p] == '.')|(CommandLine[p] == 'e')|(CommandLine[p] == 'E'))p++;

				}
				else
					{ErrorFlash(-p); return;}
			}
		}
		else if((CommandLine[p-1] == 'T')&(CommandLine[p] == ':')){
			p++; 
			while(isdigit(CommandLine[p]) ==0){
				if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
					{ErrorFlash(-p); return;}
				p++;
			}
			int res;
			if((sscanf(&CommandLine[p],"%d",&res) != 0)&(res>0)&(res<((Model*)Mod)->CurrentCell)){
				while(isdigit(CommandLine[p]) !=0){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				while(CommandLine[p] == ' '){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				if(CommandLine[p] == '='){
				if(sscanf(&CommandLine[p],"%f",&IfDriver[res].TimeOut) == 0)
					{ErrorFlash(-p); return;}
					while((isdigit((int)CommandLine[p]) !=0)|(CommandLine[p] == '-')|
						(CommandLine[p] == '.')|(CommandLine[p] == 'e')|(CommandLine[p] == 'E'))p++;

				}
				else
					{ErrorFlash(-p); return;}
			}
		}
		else if((CommandLine[p-1] == 'N')&(CommandLine[p] == ':')){
			p++; 
			while(isdigit(CommandLine[p]) ==0){
				if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
					{ErrorFlash(-p); return;}
				p++;
			}
			int res;
			if((sscanf(&CommandLine[p],"%d",&res) != 0)&(res>0)&(res<((Model*)Mod)->CurrentCell)){
				while(isdigit(CommandLine[p]) !=0){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				while(CommandLine[p] == ' '){
					if((CommandLine[p] ==(char)0x00)|(CommandLine[p] == (char)0x0a)|(CommandLine[p] == (char)0x0d))
						{ErrorFlash(-p); return;}
					p++;
				}
				if(CommandLine[p] == '='){
				if(sscanf(&CommandLine[p],"%d",&IfDriver[res].SpikeCount) == 0)
					{ErrorFlash(-p); return;}
					while((isdigit((int)CommandLine[p]) !=0)|(CommandLine[p] == '-')|
						(CommandLine[p] == '.')|(CommandLine[p] == 'e')|(CommandLine[p] == 'E'))p++;

				}
				else
					{ErrorFlash(-p); return;}
			}
		}

		else p++;
	}
	CString str; str.Format("Condition Configuration \nRead: %d line with %d-th symbols\n", CommandCounter, p+1);
	AfxMessageBox(str, MB_OK|MB_ICONINFORMATION   );
}

void IfM::Assemble(void *MDL)
{
	Model *Mod = (Model*) MDL;
	if(IfDriver == NULL) IfDriver = new IfDrive[Mod->CurrentCell];
	for(int c=0; c<InputCount; c++){
		Mod->CellList[InputList[c]].Threshold = 10.0;
		Mod->CellList[InputList[c]].ThresholdPTime = 
		Mod->CellList[InputList[c]].ThresholdMTime =
		Mod->CellList[InputList[c]].FireThresholdTime = -1;
		Mod->CellList[InputList[c]].Potentioal = 0.0; 
		Mod->CellList[InputList[c]].Fireing = 1e36;
		Mod->CellList[InputList[c]].RC = 100;
		Mod->CellList[InputList[c]].C=1;
		Mod->CellList[InputList[c]].APR=1e16;
		Mod->CellList[InputList[c]].APC = 1;
		Mod->CellList[InputList[c]].APSingPotential = 0;
		IfDriver[c].CT = 0.0f; IfDriver[c].SC = 0;
	}
}

void IfM::Calculate(void *MDL)
{
	Model *Mod = (Model*) MDL;
	for(int I=0; I<InputCount; I++)
		if((InputList[I]<Mod->CurrentCell))
			Mod->CellList[InputList[I]].Potentioal = 0;

	for(int c=0; c<CommandCounter; c++){
		if((Command[c].Calculate(MDL))&(InputList[c ] <Mod->CurrentCell)&(IfCommand[c]>=0)){
			if(IfDriver[InputList[c]].SC < IfDriver[InputList[c]].SpikeCount){
				if(Mod->CellList[InputList[IfCommand[c]]].Fireing > IfDriver[InputList[c]].Rate){
					Mod->CellList[InputList[IfCommand[c]]].Fireing = 0;
					IfDriver[InputList[c]].SC++;
				}
			}
			else{
				if(IfDriver[InputList[c]].CT > IfDriver[InputList[c]].TimeOut){
					IfDriver[InputList[c]].CT = 0.0f; IfDriver[InputList[c]].SC = 0;
				}
				else
					IfDriver[InputList[c]].CT+=Mod->CellList[0].TimeStep;
			}
			if(Mod->CellList[InputList[IfCommand[c]]].Fireing > IfDriver[InputList[c]].TimeOut){
				IfDriver[InputList[c]].CT = 0.0f; IfDriver[InputList[c]].SC = 0;
			}
		}
		else if ((Command[c].Calculate(MDL))&(IfCommand[c] < 0))
			Mod->Stop = false;
	}
}

int IfM::GetNumberInput(int NCell)
{
	for(int I=0; I<InputCount; I++){
		if(InputList[I] == NCell)
			return I;
	}
	return -1;
}

int IfM::AddInput(int NCell)
{	
	int *New = new int[InputCount+1];
	for(int I=0; I<InputCount; I++) New[I] = InputList[I];
	delete[] InputList; InputList = New;
	InputList[InputCount] = NCell;
	return(InputCount++);
}

void IfM::DeleteInput(int NInput)
{
	if((InputCount == 0)|(NInput>=InputCount)) return;
	if(InputCount == 1){
		delete[] InputList;
		InputCount =0;
		return;
	}

	InputCount -- ;
	for(int I=NInput; I<InputCount; I++)	
		InputList[I] = InputList[I+1];
}

void IfM::SaveIFMachine(CFile &File)
{
	File.Write(&InputCount,4);
	if(InputCount !=0){
		for(int I=0; I<InputCount; I++)
			File.Write(&InputList[I],4);
	}
	int Length = m_String.GetLength();
	File.Write(&Length, 4);
	File.Write(m_String.GetBuffer(Length), Length);
}

void IfM::LoadIFMachine(CFile &File)
{
	if(InputCount !=0) delete[]InputList;
	File.Read(&InputCount,4);
	InputList = new int[InputCount];
	if(InputCount !=0){
		for(int I=0; I<InputCount; I++)
			File.Read(&InputList[I],4);
	}
	int Length;
	File.Read(&Length, 4);
	if(Length == 0) return;
	char *St = new char[Length+200];
	File.Read(St, Length);
	St[Length] = St[Length+1] = (char)0;
	m_String.Empty( );
	m_String = St;
}

void IfM::ErrorFlash(int NE)
{
	CString str; str.Format("Condition Configuration \n Syntax Error near %d character\n", abs(NE));
	AfxMessageBox(str, MB_OK|MB_ICONEXCLAMATION);
}

int IfM::AddCommand()
{
	if((CommandCounter+1) >= CommandMax){
		ConditionBloc *NewBloc = new ConditionBloc[CommandMax+10];
		int *NewInt = new int[CommandMax+10];
		for(int i=0; i<CommandMax; i++){
			NewBloc[i] = Command[i];
			NewInt[i] = IfCommand[i];
		}
		delete[] Command; delete[] IfCommand;
		Command = NewBloc; IfCommand = NewInt;
	}
	return (CommandCounter++);
}
/////////////////////////////////////////////////////////////////////////////
// ConditionConf dialog


ConditionConf::ConditionConf(CWnd* pParent /*=NULL*/)
	: CDialog(ConditionConf::IDD, pParent)
{
	//{{AFX_DATA_INIT(ConditionConf)
	//}}AFX_DATA_INIT
}


void ConditionConf::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ConditionConf)
	DDX_Text(pDX, IDC_EDIT, *m_EditString);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ConditionConf, CDialog)
	//{{AFX_MSG_MAP(ConditionConf)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ConditionConf message handlers
