// ModelRecoder.cpp: implementation of the ModelRecoder class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NeuroCAD.h"
#include "ModelRecoder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ModelRecoder::ModelRecoder(LPCTSTR FName, Model *M)
{
	ModelRecoderSet MRS;
	if((FileFlg = (bool)File.Open(FileName = FName, CFile::modeCreate|CFile::modeWrite,NULL == true))&
		(MRS.DoModal() == IDOK))
		File.Write(&(TimeStep = MRS.m_Time), sizeof(TimeStep));
	Mod = M;
	RecodeTime = TimeStep = MRS.m_Time;
	PauseFlg = false;
}

ModelRecoder::~ModelRecoder()
{
	if(FileFlg)File.Close();
}

void ModelRecoder::Recode()
{
	char Out[1000];
	if(FileFlg&(RecodeTime>=Mod->CellList[0].CurrentTime)&(!PauseFlg)){
		File.Write(&Out,sprintf(Out,"Time %f\n",Mod->CellList[0].CurrentTime));
//		File.Write(&RecodeTime, sizeof(RecodeTime));
		for(int c=0; c< Mod->CurrentCell; c++){
//			File.Write(&(Mod->CellList[c].Axon), sizeof(Mod->CellList[c].Axon));
			File.Write(&Out,sprintf(Out," %d %5.4f %5.4f %5.4f %5.4f	S:", c,
				(float)Mod->CellList[c].Potentioal,
				(float)Mod->CellList[c].APPotential,
				(float)Mod->CellList[c].ThresholdLevel,
				(float)Mod->CellList[c].SynK));
//			float Trec = (float)Mod->CellList[c].Potentioal;File.Write(&Trec, sizeof(Trec));
//			Trec = (float)Mod->CellList[c].APPotential;		File.Write(&Trec, sizeof(Trec));
//			Trec = (float)Mod->CellList[c].Threshold;		File.Write(&Trec, sizeof(Trec));
			for(int s=0; s<Mod->CellList[c].CountSyn; s++){
			File.Write(&Out,sprintf(Out," %d %E %E", s,
				(float)Mod->CellList[c].Syn[s].I,
				(float)Mod->CellList[c].Syn[s].SingleWeight));
/*				Trec = (float)Mod->CellList[c].Syn[s].I;
				File.Write(&Trec, sizeof(Trec));
				Trec = (float)Mod->CellList[c].Syn[s].SingleWeight;	
				File.Write(&Trec, sizeof(Trec));
*/			}
			File.Write(&Out,sprintf(Out,"\n"));
		}
		RecodeTime +=TimeStep;
	}
}

bool ModelRecoder::Pause()
{
	if(PauseFlg)RecodeTime = Mod->CellList[0].CurrentTime+TimeStep;
	return (PauseFlg = !PauseFlg);
}

void ModelRecoder::RecodePro()
{
	ModelRecoderSet MRS; MRS.m_Time = TimeStep;
	if(MRS.DoModal() != IDOK) return;
	TimeStep = MRS.m_Time;
	RecodeTime = TimeStep+Mod->CellList[0].CurrentTime;
}
/////////////////////////////////////////////////////////////////////////////
// ModelRecoderSet dialog


ModelRecoderSet::ModelRecoderSet(CWnd* pParent /*=NULL*/)
	: CDialog(ModelRecoderSet::IDD, pParent)
{
	//{{AFX_DATA_INIT(ModelRecoderSet)
	m_Time = 0.002f;
	//}}AFX_DATA_INIT
}


void ModelRecoderSet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ModelRecoderSet)
	DDX_Text(pDX, IDC_EDIT1, m_Time);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ModelRecoderSet, CDialog)
	//{{AFX_MSG_MAP(ModelRecoderSet)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ModelRecoderSet message handlers
