// SignalView.h : interface of the SignalView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIGNALVIEW_H__0D9E1B1B_8742_4190_BA93_93B883F15097__INCLUDED_)
#define AFX_SIGNALVIEW_H__0D9E1B1B_8742_4190_BA93_93B883F15097__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "SVCommunicator.h"
#include "HighView.h"


/////////////////////////////////////////////////////////////////////////////
// SignalView window

class SignalView : public CWnd
{
// Construction
public:
	SignalView();

// Attributes
public:
	int CellCount;
	void *Fraim;

	PVOID pStartData;
	float *pDataLast;
	float *pFirstRecord;
	int LeftRecord;
	int MaxFileSize;
	int RecordSize;
	int AllRecords;
	CString FileName;
	float TimeStep, LastTime;

	CellRecordView *CRV;
	float Resolution;
	int ChannelHight, ChannelCount, SelectChannel;
	bool ReDraw;
	int *Min, *Max;
	int LastPointX;
	float Position;

	SVCommunicator SVC;
	CStatusBar  *m_StatusBar;

	CSize size;
	CBitmap *OldBmp, pBmp;
	CDC MDC;
	bool ReBuildFlg;
	COLORREF ColBack, ColLine, ColSelect, ColGrid, ColAP, ColTH, ColMark;
	COLORREF UserColor;
	bool GridFlg;
	bool LoadFileFlg;
	bool BWCreate;
	bool Magnet;
	
	float *Marker;
	CPoint Cursor;

	HighView HV;
	bool HVFlag;
	float *HVPoint, HVWeight;

// Operations
public:
	void LoadFile(LPCTSTR lpszFileName);
	void ReBuild(CDC &dc);
	int LeftDrawing(int Record, int Points);
	int RightDrawing(int Record, int Points);
	inline void OneRecordDwar(float *Rec, CPoint &Current, bool MM);
	inline void PreSet(int Record);
	inline void ParamView(int Record, int ViewP);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SignalView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~SignalView();

	// Generated message map functions
protected:
	//{{AFX_MSG(SignalView)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnFileOpen();
	afx_msg void OnPop();
	afx_msg void OnUpdatePop(CCmdUI* pCmdUI);
	afx_msg void OnPush();
	afx_msg void OnUpdatePush(CCmdUI* pCmdUI);
	afx_msg void OnSeekHome();
	afx_msg void OnUpdateSeekHome(CCmdUI* pCmdUI);
	afx_msg void OnSeekEnd();
	afx_msg void OnUpdateSeekEnd(CCmdUI* pCmdUI);
	afx_msg void OnRefresh();
	afx_msg void OnCentre();
	afx_msg void OnUpdateCentre(CCmdUI* pCmdUI);
	afx_msg void OnFilePrint();
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnGridView();
	afx_msg void OnUpdateGridView(CCmdUI* pCmdUI);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnUp();
	afx_msg void OnUpdateUp(CCmdUI* pCmdUI);
	afx_msg void OnDown();
	afx_msg void OnUpdateDown(CCmdUI* pCmdUI);
	afx_msg void OnBmp();
	afx_msg void OnUpdateBmp(CCmdUI* pCmdUI);
	afx_msg void OnMarker();
	afx_msg void OnUpdateMarker(CCmdUI* pCmdUI);
	afx_msg void OnMargnet();
	afx_msg void OnUpdateMargnet(CCmdUI* pCmdUI);
	afx_msg void OnSeekMark();
	afx_msg void OnUpdateSeekMark(CCmdUI* pCmdUI);
	afx_msg void OnEnd();
	afx_msg void OnHome();
	afx_msg void OnLineDown();
	afx_msg void OnLineLeft();
	afx_msg void OnLineRight();
	afx_msg void OnLineUp();
	afx_msg void OnPadgeUp();
	afx_msg void OnPageDown();
	afx_msg void OnSeekTime();
	afx_msg void OnUpdateSeekTime(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRefresh(CCmdUI* pCmdUI);
	afx_msg void OnWav();
	afx_msg void OnUpdateWav(CCmdUI* pCmdUI);
	afx_msg void OnHighview();
	afx_msg void OnUpdateHighview(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SIGNALVIEW_H__0D9E1B1B_8742_4190_BA93_93B883F15097__INCLUDED_)
